//functions for dashboard, logs and faceting
(function ($) {

	var methods = {};
methods.getSessionFlag = function() {
	var widget = $(this);
	$.ajax({
	url: "../../rest/commonlog/get_sessionID",
	type: "GET",
	async: false,
	dataType: "JSON",
	success: function(data) {
		widget.data("session_flag", data.session_flag);
		widget.data("interrupted_log", data.interrupted_log);
		//session_flag = data.session_flag;
	},
	error: function(err) {
		console.log(err);
	}
	});
}

methods.getFacetCustomConfig = function(did) {
	var widget = $(this);
	$.ajax({
	url: "../../rest/commonlog/get_facetconfig?did=" + did,
	type: "GET",
	async: false,
	dataType: "JSON",
	success: function(data) {
		widget.data("facet_config", data.facet_config);
		widget.data("time_range", data.time_range);
	},
	error: function(err) {
		console.log(err);
	}
	});
}

methods.setFacetCustomConfig = function() {
	var widget = $(this);
	var jsontimerange = {};
	if($('.duration', widget).val() == '0')
	{
		jsontimerange = {
					"form_period": $('#duration', widget).val(),
					"form_from": $('#json-report-from', widget).val(),
					"form_to": $('#json-report-to', widget).val(),
					"show_string": $('.timeRangeLabel').html()
				}
	}
	var jsonData = {
			"facetName": methods._getParam('did')[0],
			"timerange": jsontimerange,
			"filters": {
							"duration": $('.duration', widget).val(),
							"topN":$('.topN', widget).val() - 0,
							"group":$('.group', widget).val(),
							"filter" : 
							{
								'CLF_DeviceName':$('.group', widget).val(),						
							}
						}
		};
		
		var json = JSON.stringify(jsonData);
		$.ajax({
			url: "../../rest/commonlog/set_facetconfig",
			type: "POST",
			data: json,
			success: function (data) {
			
			},
			error: function (a, b, c) {
				console.log("ERROR:", a, b, c);
			}
		});
}


	methods.deviceGroup = [];
	methods.getDeviceGroup = function() {
	var widget = $(this)
	$.ajax({
		url: "../../rest/commonlog/central/getallgroup",
		type: "POST",
		async: false,
		dataType: "json",
		success: function(data) {
		var json_data = eval(data);
		var device_info;
		//widget.data("groups", json_data);
		// we have to get the map between
		// device and it's name.
		$.ajax({
			url: "../../rest/commonlog/central/getalldevice",
			type: "POST",
			async: false,
			dataType: "json",
			success: function(data) {
			device_info = eval(data);
			// get local device
			$.ajax({
				url: "../../rest/commonlog/central/getlocaladdr",
				type: "POST",
				async: false,
				success: function(data) {
				var local_addr = JSON.parse(data);
				device_info.push(local_addr);
				},
				error: function(err_msg) {
				console.log(err_msg);
				alert(i18n_central_log_get_local_addr_fail);
				}
			});
			}
		});
		for(var i = 0; i < json_data.length; i++) {
			var devices = json_data[i].GroupDevices;
			var device_ip_list = devices.split(";");
			var device_name_list = [];
			if((device_ip_list.length == 1) && (device_ip_list[0] == '')) {
			device_ip_list = [];
			}
			for(var j = 0; j < device_ip_list.length; j++) {
			var dup_flag = false;
			for(var k = 0; k < device_info.length; k++) {
				if(device_info[k].DeviceAddr == device_ip_list[j]) {
				for(var l = 0; l < device_name_list.length; l++) {
					if(device_name_list[l] == device_info[k].DeviceName) {
					dup_flag = true;
					break;
					}
				}
				if(!dup_flag) {
					device_name_list.push(device_info[k].DeviceName);
				}
				break;
				}
			}
			}
			json_data[i].GroupDevicesName = device_name_list;
		}
		methods.deviceGroup = json_data;
		},
		error: function(err_msg) {
		console.log(err_msg);
		}
	});
	}
	methods.getParamsFromPage = function (params) {
		var widget = $(this);
		if (!params) {
			params = {};
		}
		var topN = $('.topN', widget);
		if (topN.is(":visible")) {
			params.topN = $('.topN', widget).val() - 0;
		}

		var group = $('.group', widget);
		if(group.is(":visible")) {
			params.group = $('.group', widget).val();
		}
		var timeRange = $('.duration', widget);
		// With datetime picker, we will have a "hidden" field
		if (timeRange.is(":visible") || timeRange.is(":hidden")) {
			params.timeRange = timeRange.val();
			if (!params.timeRange || params.timeRange == '0') {
				params.timeRange = $('#json-report-from').val() * 1000 + ',' + $('#json-report-to').val() * 1000;
		//		params.timeRange = methods.str_to_timestamp($('.range_start').html()) + ',' + methods.str_to_timestamp($('.range_end').html());
			}
		}

		params.chartType = methods.getChartType.call(widget);
		return params;

	};

	methods.str_to_timestamp = function (time) {
		time_arr = time.split(' ');
		date_str = time_arr[0];
		day_str = time_arr[1];

		var date_split = date_str.split('-');
		var year = parseInt(date_split[0], 10) - 0;
		var month = parseInt(date_split[1], 10) - 0 - 1;
		var day = parseInt(date_split[2], 10) - 0;

		var day_split = day_str.split(':');
		var hour = parseInt(day_split[0], 10) - 0;
		var minute = parseInt(day_split[1], 10) - 0;


		time = (new timezoneJS.Date(year, month, day, hour, minute, 0, currentTimeZone)).getTime();
		return time;
	};

	methods.getChartType = function () {
		var widget = $(this);
		var defChart = $('.chartType .activeChart', widget);
		if (defChart.length === 0) {
			defChart = $('.chartType div:not(".notdefault")', widget).eq(0);
			defChart.addClass('activeChart');
		}
		var chart = $('.chart', widget);
		var chartType = defChart.attr('data-ctype');
		widget.data("chartType", chartType);
		return chartType;
	};

	methods.setFilters = function(filters) {
		var widget = $(this);
		widget.data('filters',filters);
	};

	methods.getFilters = function() {
		var widget = $(this);
		var filters = widget.data('filters');
		if (!filters) {
			filters = {};
		}
		return filters;
	};

	// params is an existing query
	// options contain new options to add to the query
	methods.getRestObject = function (params, field) {
		var widget = $(this);
		params = methods.getParamsFromPage.call(widget, params);
		field = field || "reportParam";
		var restObject = {};
		restObject[field] = params.hasOwnProperty(field) ? $.extend(true, {}, params[field]) : {};

		if (params.timeRange) {
			var tr = methods.calculateTimeRange(params.timeRange);
			if (tr.range && tr.range != '0') {
				restObject[field].period = tr.range;
			}
			else {
				restObject[field].timeBegin = tr.serverunixstart;
				restObject[field].timeEnd = tr.serverunixend;
			}
			widget.data("retrievedTimeRange", tr);
		}
		if (params.filters) {
			restObject[field].filters = params.filters;
		}
		else {
			restObject[field].filters =  methods.getFilters.call(widget);
		}
		if (params.topN) {
			restObject[field].topN = params.topN;
		}

		// column is the sneaky field that is "outside" the main scope
		// so we have to pass it over
		if (params.hasOwnProperty("column")) {
			restObject.column = params.column;
		}

		// cid needs to be passed down
		if (params.hasOwnProperty("cid")) {
			restObject[field].cid = params.cid;
		}
		if (!restObject[field].hasOwnProperty("cid")) {
			restObject[field].cid = "0";
		}

		// need to make sure we get reportTemplate
		if (params.hasOwnProperty("reportTemplate")) {
			restObject[field].reportTemplate = params.reportTemplate;
		}

		// make sure we have filters
		if (params.filters) {
			restObject[field].filters = params.filters;
		}
		if (!restObject[field].filters) {
			restObject[field].filters = {};
		}
		// log query needs translation of filter params
		if (field == 'query') {
		   restObject.paging = {
				"skip": 0,
				"limit": 20
			};
			restObject.query.filters = methods.translateFilters.call(widget, restObject.query.filters);
		}

		return restObject;
	};

	/*
	 *
	 * Set initial values and handlers for topn, duration, group
	 *
	 */

	methods.populateDuration = function (md, defaultValue, type) {
		var widget = $(this);

		// drill down uses pseudo-select list, so we do lots of things differently
		if (type == 'drill') {
			methods.initDatePicker.call(widget, md.duration, defaultValue);
			// For facets, duration is a pseudo dropdown, so we look for click and change in values

			//duration handler
			var dC = $('.durationContainer', widget);
			dC.data('currentDuration', $('.duration', widget).val());
			dC.click(function (e) {
				var newDur = $('.duration', widget).val();
				var oldDur = dC.data('currentDuration');
				// only update custom time after the datePicker click
				if (newDur == '0' && oldDur != -1) {
					return;
				}
				// if the duration is different, redraw
				if ((oldDur != newDur)) {
					// don't let messages crash us
					methods.setFacetCustomConfig.call(widget);
					$.datepicker.log = function (l) {
						console.log(l);
					};
					$("#duration-picker").enhanced_datetimepicker("set_values", {
						"form_period": "#duration",
						"form_from": "#json-report-from",
						"form_to": "#json-report-to"
					});
					methods.getFacets.call(widget);
					if(methods.getChartType.call(widget) == "logs") {
						var filters = methods.getFilters.call(widget);
						methods.initLogs.call(widget, {
							filters: filters
						});
					}
					dC.data('currentDuration', newDur);
				}
			});
			// When the datePicker select button is pressed, update the display
			widget.on('click', '.datePickerAction', function (e) {
				dC.data('currentDuration', -1);
				dC.click();
			});
		}

		// dashboard uses straightforward select list and handlers
		// but it does save the state afterwards
		else {
			if (md.hasOwnProperty('duration')) {
				widget.find('.duration').dashboardSettings('setOptions', md.duration, defaultValue, "Custom");
			}
			$('.duration', widget).change(function (e) {
				// update the metadata object (so it can be saved)
				var md = widget.data('md');
				var defObj = {
					"default": $(this).val()
				};
				if (md.duration && $.isArray(md.duration)) {
					if ($.isPlainObject(md.duration[0])) {
						md.duration[0] = defObj;
					} else {
						md.duration.unshift(defObj);
					}
				} else {
					md.duration = [defObj];
				}
				widget.closest('#dashboard').trigger('dashboardStateChange');
				methods.updateChart.call(widget, {
					timeRange: $(this).val()
				});
			});
		}

	};

	methods.populateGroup = function (md, defaultValue, type) {
		var widget = $(this);
		var gC = $('.groupContainer', widget);
		var group_info = methods.deviceGroup;
		var text = '';

		for(var i = 0; i < group_info.length; i++) {
			text += '<option value="' + group_info[i].GroupName + '">' + group_info[i].GroupName + "</option>"
		}

		$('.groupContainer > .group', widget).append(text);
		$('.groupContainer > .group', widget).val(defaultValue);
		widget.off('change', '.groupContainer > .group').on('change', '.groupContainer > .group', function(e) {
			e.stopPropagation();
			//var key = "CLF_DeviceName";
			var group_name = $('.groupContainer > .group').val();
			var group_info = methods.deviceGroup;
			var group_device_str = '';
			var filters;
			if(type == "drill") {
				var key = "CLF_DeviceName";
				filters = methods.getFilters.call(widget);
				methods.setFacetCustomConfig.call(widget);
				if(group_name == 'ALL') {
					delete filters[key];
				} else {
					for(var i = 0; i < group_info.length; i++) {
						if(group_info[i].GroupName == group_name) {
						//group_device_str += group_info[i].GroupDevices;
							if(group_info[i].GroupDevicesName.length > 0) {
								filters[key] = group_info[i].GroupDevicesName;
								break;
							}
						}
					}
				//filters[key] = methods.formatDeviceList.call(widget, group_device_str);
				}

				methods.setFilters.call(widget, filters);

				if(methods.getChartType.call(widget) == "logs") {
					methods.initLogs.call(widget, {
						filters: filters
					});
				}

				methods.getFacets.call(widget);
			} else {
				var key = "device";
				filters = {};
				if(group_name == 'ALL') {
					methods.updateChart.call(widget, {});
				} else {
					for(var i = 0; i < group_info.length; i++) {
						if(group_info[i].GroupName == group_name) {
							if(group_info[i].GroupDevicesName.length > 0) {
								filters[key] = group_info[i].GroupDevicesName;
								break;
							}
						}
					}

					methods.updateChart.call(widget, {
						"filters": filters
					});
				}
			}
		});
	}

	methods.populateTopN = function (md, defaultValue, type) {
		var widget = $(this);
		if (md.hasOwnProperty('topN')) {
			widget.find('.topN').dashboardSettings('setOptions', md.topN, defaultValue);
			// facet
			$('.topN', widget).change(function (e) {
				// drill down we update facets then chart
				if (type == 'drill') {
					methods.getFacets.call(widget);
					methods.setFacetCustomConfig.call(widget);
				} else {
					var md = widget.data('md');
					var defObj = {
						"default": $(this).val()
					};
					if (md.topN && $.isArray(md.topN)) {
						if ($.isPlainObject(md.topN[0])) {
							md.topN[0] = defObj;
						} else {
							md.topN.unshift(defObj);
						}
					} else {
						md.topN = [defObj];
					}
					widget.closest('#dashboard').trigger('dashboardStateChange');
					methods.updateChart.call(widget, {
						topN: $(this).val()
					});
				}
			});
		} else {
			widget.find('.topNContainer').hide();
			widget.find('.topN').hide();
			if (defaultValue) {
				$('.topN', widget).val(defaultValue);
			}
		}
	};




	// auto-refresh of the chart
	// if called with "true", will only set refresh interval, and not automatically refresh
	methods.refreshChart = function (interval, init) {
		var widget = $(this);
		interval = interval || 60000;
		var refreshId = widget.data('refreshId');
		if (refreshId) {
			clearTimeout(refreshId);
		}
		// Use timeout instead of interval, because queries
		// could take a long time
		refreshId = setTimeout(function () {
			methods.updateChart.call(widget, {});
		}, interval);
		widget.data('refreshId', refreshId);
		widget.data('interval', interval);
		if (!init) {
			methods.updateChart.call(widget, {});
		}
	};

	// configuration-based widget instanciation
	methods.initWidget = function (md, type, params) {
		// don't process if there is no metadata
		if (!md || $.isEmptyObject(md)) {
			return;
		}
		var widget = $(this);
		params = params || {};
		if (!md.i18n) {
			md.i18n = 'common';
		}
		widget.data('md', md);
		widget.data('type', type);
		// use custom duration if configured - or use default
		methods.populateDuration.call(widget, md, params.timeRange, type);
		methods.populateTopN.call(widget, md, params.topN, type);
		methods.populateGroup.call(widget, md, params.group, type);
		
		// If we don't have chart and data config, we may have issues
		// So, we will go wild and assume we have them
		methods.setChartTypes.call(widget, md.chartConfig);

		if ((type && type == 'drill')) {
			widget.data('restService', 'report_query');
			var time_range = widget.data("time_range");
			var time_json = eval(time_range);
			if(time_json.form_period == '0')
			{
				$('#json-report-from').val(time_json.form_from);
				$('#json-report-to').val(time_json.form_to);
				$('.timeRangeLabel').html(time_json.show_string);
			}
		} else {
			// initialize autorefresh -- only on dashboard
			methods.refreshChart.call(widget, 60000, true);

			// for dashboard, update chart here. For facets, facet will call chart update
			methods.updateChart.call(widget, params);
		}

		// set the favorites handlers
		methods.initFavorites.call(widget);


	};


	// Set available charts for use by a given widget
	methods.setChartTypes = function (chartConfig) {
		var widget = $(this);
		var chartSet = false;
		var html = '';
		var chartCount = 0;
		var graphType = widget.data('type');
		$.each(chartConfig, function (k, v) {
			if (v.hasOwnProperty('enabled') && (!v.enabled)) {
				// if its disabled, we ignore it
			} else {
				chartCount++;
				html += '<div data-ctype="' + k + '" class="btn_small btn_small' + k;
				if (!chartSet && v.hasOwnProperty('default')) {
					html += ((v['default']) ? ' activeChart' : ' notdefault ');
				}
				html += '"></div>';
			}
		});

		if (graphType == 'drill') {
			html += '<div data-ctype="logs" id="showlogs" title="showlogs" class="btn_small btn_smalltable"></div>';
			html += '<span id="downloadpdf" title="downloadpdf" class="btn_small btn_smallpdf"></span>';
		}

		$('.chartType', widget).html(html);
		localizePage('dashboard');
		// hide charttype selection if we don't have multiple
		if (chartCount < 2) {
			$('.chartType', widget).hide();
		}

		$('.chartType div', widget).click(function () {
			$('#chartContainer', widget).show();
			$('.logs', widget).hide();
			var type = $(this).attr('data-cType');
			$('.chartType div', widget).removeClass('activeChart');
			$(this).addClass('activeChart');
			var drill = widget.data('type');
			if (drill == 'drill') {
				if (type == 'line') {
					methods.dynamicTimeChart.call(widget);
				} else {
					// use the facet data to update most charts
					var gb = $('.groupby', widget).attr('data-key');
					// no data - no point in trying to show chart
					// Do we need to present better error message?
					// or will this only occur on load?
					if (!widget.data('rawFacets')) {
						return;
					}
					var data = widget.data('rawFacets')[gb];
					methods.updateChart.call(widget, {
						"chartType": type
					}, data);
				}

			} else {
				methods.updateChart.call(widget, {
					"chartType": type
				});
			}
		});
	};

	methods.getGroupDevice = function () {
		var widget = $(this);
		var group = $('.group', widget).val();
		var group_info = methods.deviceGroup;
		if(group != "ALL") {
			for(var i = 0; i < group_info.length; i++) {
				if(group_info[i].GroupName == group) {
					if(group_info[i].GroupDevicesName.length > 0) {
						return group_info[i].GroupDevicesName;
					}
				}
			}
		}
		return "";
	}


	/*
	 *
	 * Draw graphical charts (using highcharts)
	 *
	 */


	methods.updateChart = function (params, chartData) {
		var widget = $(this);

		var refreshId = widget.data('refreshId');
		if (refreshId) {
			clearTimeout(refreshId);
		}

		var chartType = methods.getChartType.call(widget);

		// line chart
		if ((chartType == 'line') && (widget.data('type') == 'drill')) {
			methods.dynamicTimeChart.call(widget, params);
		}

		// For facets, we can just pass in the facet data, so we don't have to do another query
		else if (chartData) {
			var force = false;
			if (params && params.chartType) {
				force = params.chartType;
			}
			methods.drawChart.call(widget, chartType, chartData, force);
		} else if (chartData === undefined && (widget.data('type') != 'drill')) {
			params = $.extend(true, {}, widget.data('md').dataConfig, params);
			var restObject = methods.getRestObject.call(widget, params);
			var group_devices = methods.getGroupDevice.call(widget);
			if(group_devices) {
				restObject.reportParam.filters['device'] = group_devices;
			}
			var restText = JSON.stringify(restObject);

			var service = widget.data('restService') || 'dashboard_query';


			methods.loader(0,widget);
			$.ajax({
				url: "../../rest/commonlog/" + service,
				dataType: "json",
				cache: false,
				type: "POST",
				data: restText,
				success: function (data) {
					methods.loader(1,widget);
					methods.drawChart.call(widget, chartType, data);
					if (widget.data('interval')) {
						methods.refreshChart.call(widget, widget.data('interval'), true);
					}
					// add timestamp to header
					$('.widgetheader .timestamp',widget).remove();
					//var timestamp = methods.formatTime(+new Date());
					//var timestamp = new Date().toLocaleTimeString();
					var dt = +new Date();
					var lt = new timezoneJS.Date(dt,currentTimeZone);
					var timestamp = lt.toString('HH:mm:ss');
					$('.widgetheader',widget).append("<span class='timestamp'>"+timestamp+"</span>");
				},
				error: function (a, b, c) {
					methods.loader(1,widget);
					$('.chart', widget).empty().text(geti18n("NO_DATA"));
					if (widget.data('interval')) {
						methods.refreshChart.call(widget, widget.data('interval'), true);
					}
				}
			});
		} else {
			methods.drawChart.call(widget, null, null);
		}
	};


	// Some have an identifier before the array - we strip that here
	methods.removeIdentifier = function (data) {
		if (!($.isArray(data))) {
			for (var i in data) {
				data = data[i];
				break;
			}
		}
		return data;
	};

	methods.drawChart = function (chartType, data, forceChart) {


		var widget = $(this);
		if(!chartType){
			chartType = widget.data("chartType");
		}
		/*
		if (chartType == 'logs') {
			$('.logs', widget).show();
			$('#chartContainer', widget).hide();
			methods.hideChartBy();
			methods.initLogs.call(widget, widget.data("params"));
			return;
		}
		*/

		var md = widget.data('md');
		var i18nCat = md.i18n;
		var textConfig = $.extend(true, {}, md.chartConfig[chartType]);

		textConfig.title = geti18n(textConfig.title, "dashboard");
		textConfig.ytitle = geti18n(textConfig.ytitle, "dashboard");
		textConfig.subtitle = geti18n(textConfig.subtitle || '', "dashboard");
		textConfig.seriesname = geti18n(textConfig.seriesname, "dashboard");

		var retrievedTimeRange = widget.data('retrievedTimeRange');
		var ts = methods.formatTime(retrievedTimeRange.start);
		var te = methods.formatTime(retrievedTimeRange.end);
		textConfig.subtitle = ts + " - " + te;

		if ($('.groupby', widget).attr('data-key') && chartType != 'line') {
			i18nCat = $('.groupby',widget).attr('data-key');
			textConfig.title += " - " + geti18n($('.groupby', widget).attr('data-key'), "dashboard");
		}

		var drill = widget.data('type');
		if (!drill) {
			textConfig.title = '';
			textConfig.subtitle = '';
		} else {
			textConfig.format = md.facetConfig.format || '';
		}

		var i;
		var datacategories = [];
		var dataseries = [];
		var elem = methods.getSelector($('.chart', widget));
		widget.data("rawData", $.extend(true, {}, data));

		if (!data || ($.isArray(data) && data.length === 0)) {
			if (widget.data('highchartsObj')) {
				widget.data('highchartsObj').destroy();
			}
			widget.data('highchartsObj', null);

			$('.iws_common_widget', widget).css("opacity", 1);

			$('.chart', widget).text(geti18n("NO_DATA"));

			return;
		}

		// will do an async call to get the data and call this stuff again
		// for the dynamic time chart. We don't do it if they explicitly picked  chart
		// that is not line
		if (drill) {
			if ((chartType != 'line' && data.length == 1 && !forceChart)) {
				//methods.dynamicTimeChart.call(widget);
				//$('.chartType div', widget).removeClass('activeChart');
				//$('.btn_smallline', widget).addClass('activeChart').css("box-shadow","0px 0px 5px #fff");
				$('.btn_smallline', widget).css("box-shadow","0px 0px 5px #fff");
			} else if (chartType == 'line') {
				// don't do this, or you will infinite loop
				//methods.dynamicTimeChart.call(widget);
				//return;
			}
		}
		var chartConfig;
		if (chartType == "pie") {

			var data_length = data.length;
			var other_data = widget.data("TotalCount");

			for(i = 0; i < data.length; i++) {
				other_data -= data[i][1];
			}

			if(other_data > 0) {
				var other_array = ["Others", other_data];
				data.push(other_array);
			}

			data = methods.removeIdentifier(data);
			var pie_data = new Array();
			for (i = 0; i < data.length; i++) {
				var pie_item = new Array();
				pie_item.push(data[i][0]);
				pie_item.push(data[i][1]);
				pie_data.push(pie_item);
				if(i18nCat == "URLCategories") {
					i18nCat = "CLF_URLCategory";
				}
				if(i18nCat == "appcats") {
					i18nCat = "CLF_AppID";
				}
				if(pie_data[i][0] != "Others") {

					if(i18nCat == "CLF_URLCategory") {
						if(data[i][2] == 0) {
							pie_data[i][0] = methods.getCategoryName(pie_data[i], i18nCat);
						} else if(data[i][2] == 1) {
							pie_data[i][0] = methods.getCategoryName(pie_data[i]);
						}
					} else if(i18nCat == "CLF_AppID") {

						pie_data[i][0] = methods.getCategoryName(pie_data[i],i18nCat);
					}else if(i18nCat == "CLF_MsgType") {
						pie_data[i][0] = methods.getCategoryName(pie_data[i], i18nCat);
					} else {
						pie_data[i][0] = methods.getCategoryName(pie_data[i], i18nCat);
					}
				} else {
					pie_data[i][0] = geti18n("Others");
				}
			}
			chartConfig = methods.pieChart.call(widget, pie_data, textConfig);
			methods.showChartBy();
		} else if (chartType == "line") {
			chartConfig = methods.lineChart.call(widget, data, textConfig);
			methods.hideChartBy();
		}
		// bar or column
		else {
			methods.showChartBy();
			data = methods.removeIdentifier(data);
			for(i = 0; i < data.length; i++) {
				if(data[i][0] == "Others")
					data.splice(i, 1);
			}
			for (i = 0; i < data.length; i++) {
				if(!isNaN(parseInt(data[i][0]))) {
					if(i18nCat == "URLCategories") {
						i18nCat = "CLF_URLCategory";
					}
					if(i18nCat == "appcats") {
						i18nCat = "CLF_AppID";
					}
					datacategories.push(methods.getCategoryName(data[i], i18nCat));
					dataseries.push(data[i][1]);
				} else {
					datacategories.push(data[i][0]);
					dataseries.push(data[i][1]);
				}
			}
			data.categories = datacategories;
			data.series = dataseries;
			if (chartType == "bar") {
				chartConfig = methods.barChart.call(widget, data, textConfig);
			} else if (chartType == "column") {
				chartConfig = methods.columnChart.call(widget, data, textConfig);
			}
		}

		var basicConfig = {
			chart: {
				renderTo: elem,
				animation: false
			},
			/* title : false, */
			subtitle: false,
			title: {
				text: textConfig.title
			},
			/*
			subtitle: {
				text: textConfig.subtitle
			},
			*/
			credits: {
				enabled: false
			},
			plotOptions: {
				series: {
					cursor: "pointer",
					animation: false,
					events: {
						click: function (e) {
							// We may not want to do this is we are in faceting
							methods.launchDrillDown.call(widget, e, elem, this);
						}
					}
				}
			}

		};


		chartConfig = $.extend(true, {}, basicConfig, chartConfig);

		// show local browser time
		Highcharts.setOptions({
			global: {
				useUTC: false
			}
		});

		//fix the colors of chart
		Highcharts.setOptions({
			colors: ["#4572A7","#AA4643","#89A54E","#80699B","#3D96AE","#DB843D","#92A8CD","#A47D7C","#B5CA92", "#9ACD32", "#FFFF00", "#EE82EE", "#FF6347", "#008080", "#4169E1", "#4B0082", "#ADD8E6", "#B0C4DE", "#00FF00", "#ADFF2F", "#FF0000"]
		});


		if (widget.data('highchartsObj')) {
			widget.data('highchartsObj').destroy();
		}

		var chart = new Highcharts.Chart(chartConfig);

		/*
		// Title positioned on highchart
		var title = $('<span id="chartTitle">This is some text</span>');
		$("#chartTitle").remove();
		$('#chartContainer').append(title);
		var titleWidth = title.width();
		var chartWidth = $('#chart').width();
		// This is bad if title doesn't fit in chart
		if (titleWidth > chartWidth) {
			titleWidth = chartWidth;
		}
		var titleLeft = $('#chart').position().left + (chartWidth - titleWidth)/2;
		var titleTop = $('#chart').position().top + 10;
		$('#chartTitle').css({'position':'absolute','left':titleLeft,'top':titleTop, 'display':'block', 'z-index':5});
		*/

		// chart selection icons
		/*
		if (widget.data('type') == 'drill') {
			var leftPos = $('#chart').position().left + $('#chart').width() -140;
			var topPos = $('#chart').position().top +10;
			$('.chartType').css({"left":leftPos,"top":topPos});
		}
		*/


		$('.iws_common_widget', widget).css("opacity", 1);

		widget.data("highchartsObj", chart);
		var JQ = $(chart.container);
		chart.setSize(JQ.width(), JQ.height());
		var pdfConfig = widget.data('pdfConfig') || {};
		var pdfChartConfig = $.extend(true, {}, chartConfig);
		pdfChartConfig.chart.renderTo = 'container0';
		pdfConfig.chart = pdfChartConfig;
		widget.data('pdfConfig', pdfConfig);
	};

	methods.pieChart = function (data, textConfig) {
		var widget = $(this);
		var chart;
		// may add config for special tooltip formatting
		var formatType = textConfig.format;
		var chartConfig = {
			chart: {
				spacingLeft: 0,
				spacingRight: 0,
				plotBackgroundColor: null,
				plotBorderWidth: null,
				plotShadow: false
			},
			tooltip: {
				formatter: function () {
			this.point.name = methods.formatter_language(this.point.name);
					var base = methods.tooltip(this.point.name, this.y, formatType);
					base += ' (' + ((this.y / this.total) * 100).toFixed(0) + '%)';
					return base;
				}
			},
			legend: {
				labelFormatter: function() {
					this.name = methods.formatter_language(this.name);
					var name;
					if(this.name.length > 20) {
						name = this.name.substr(0, 20) + "...";
					} else {
						name = this.name;
					}
					return name;
				}
			},
			plotOptions: {
				pie: {
					allowPointSelect: true,
					cursor: 'pointer',
					dataLabels: {
						//enabled: false,
						enabled: true,
						color: '#000000',
						distance: -30,
						connectorColor: '#000000',
						formatter: function () {
							return this.percentage>5 ? this.percentage.toFixed(0)+'%' : '';
							//return '<b>' + this.point.name + '</b>: ' + ' ' + ((this.y / this.total) * 100).toFixed(1) +
								//'%';
						}
					},
					showInLegend: true
				}
			},
			series: [{
				type: 'pie',
				name: "pie chart",
				data: data
			}]
		};
		return chartConfig;
	};

	methods.formatter_language = function (str) {
		var lm = str.split('&#');
		var ret;
		if(lm.length > 1) {
			ret = "";
			for(var i = 0; i < lm.length; i++) {
				var sub_str = lm[i].split(';');
				var cd = parseInt(sub_str[0]);
				if(cd && !isNaN(sub_str[0])) {
					ret += String.fromCharCode(cd);
					sub_str.shift();
				}
				ret += sub_str.join(';');
			}
			return ret;
		} else {
			return str;
		}
	}

	methods.barChart = function (data, textConfig) {
		var widget = $(this);
		var formatType = textConfig.format;

		var chartConfig = {
			legend: {
				enabled: false
			},
			chart: {
				type: 'bar',
				spacingRight: 20,
				spacingLeft: 20
			},
			xAxis: {
				categories: data.categories,
				title: {
					text: null
				},
				labels: {
					formatter: function() {
						this.value = methods.formatter_language(this.value);
						var that;
						if(this.value.length >= 20) {
							that = this.value.substr(0, 20) + "...";
						} else {
							that = this.value;
						}
						return that;
					}
				},
				minPadding: 0.06
			},
			yAxis: {
				min: 0,
				title: {
					text: textConfig.ytitle,
					align: 'middle'
				},
				labels: {
					overflow: 'justify'
				}
			},
			tooltip: {
				formatter: function () {
			this.x = methods.formatter_language(this.x);
					var base = methods.tooltip(this.x, this.y, formatType);
					return base;

					//return '' + this.x + ': ' + this.y + '';
				}
			},
			plotOptions: {
				bar: {
					dataLabels: {
						enabled: true
					}
				}
			},
			series: [{
				//name : textConfig.seriesname,
				data: data.series
			}]
		};
		// Do we do a logarithm?
		var first = data.series[0];
		var last = data.series[data.series.length - 1];
		if ((last > 0) && ((first / last > 25))) {
			chartConfig.yAxis.type = "logarithmic";
			delete chartConfig.yAxis.min;
		}

		return chartConfig;
	};
	methods.columnChart = function (data, textConfig) {
		var widget = $(this);

		var chartConfig = {
			chart: {
				type: 'column',
				spacingRight: 20,
				spacingLeft: 20
			},
			legend: {
				enabled: false
			},
			xAxis: {
				categories: data.categories,
				labels: {
						align: 'right',
						rotation: -45,
			style: {
				backgroundColor:"#ffffff"
			},
						formatter: function() {
							this.value = methods.formatter_language(this.value);
							var that;
							if(this.value.length > 20)
								that = this.value.substr(0, 20) + "...";
							else
								that = this.value;
							return that;
						}
				},
				title: {
					text: null
				},
				minPadding: 0.06
			},
			yAxis: {
				min: 0,
				title: {
					text: textConfig.ytitle,
					align: 'middle',
			style: {
			backgroundColor:"#ffffff"
			}
				},
				labels: {
					overflow: 'justify'
				}
			},
			tooltip: {
				formatter: function () {
			this.x = methods.formatter_language(this.x);
					return '' + this.x + ': ' + this.y + '';
				}
			},
			plotOptions: {
				bar: {
					dataLabels: {
						enabled: true
					}
				}
			},
			series: [{
				name: textConfig.seriesname,
				data: data.series
			}]
		};
		// Do we do a logarithm?
		var first = data.series[0];
		var last = data.series[data.series.length - 1];
		if ((last > 0) && ((first / last > 25))) {
			chartConfig.yAxis.type = "logarithmic";
			delete chartConfig.yAxis.min;
		}
		return chartConfig;
	};





	methods.prepareLineChartData = function (d) {
		var widget = $(this);
		var chartData = {};
		var seriesIndex = [];
		var k, j, data, dataObj;
		var log = false;
		var chartConfig = widget.data('md').chartConfig;
		// change Unix timestamps to javascript timestamps
		var singleLevel = false;
		for (j in d) {
			if (d.hasOwnProperty(j)) {
				if (typeof d[j] != 'object') {
					singleLevel = true;
				}
				break;
			}
		}

		if ($.isArray(d) || singleLevel) {
			dataObj = methods._dateTransformSeries(d);
			if (dataObj.min != 0 && dataObj.max / dataObj.min > 50) {
				log = true;
			}
			var cName = geti18n(chartConfig.line.seriesname, "dashboard.series");
			chartData.series = [{
				name: cName,
				data: dataObj.data
			}];
			return {
				chartData: chartData,
				log: log
			};
		} else {
			chartData.series = [];
			for (k in d) {
				if (d.hasOwnProperty(k)) {
					dataObj = methods._dateTransformSeries(d[k]);
					chartData.series.push({
						name: geti18n(k, "dashboard.series"),
						data: dataObj.data
					});
					if (dataObj.min != 0 && dataObj.max / dataObj.min > 50) {
						log = true;
					}
					seriesIndex.push(k);
				}
			}
			widget.data('seriesIndex', seriesIndex);
			return {
				chartData: chartData,
				log: log
			};
		}
	};



	methods.lineChart = function (data, textConfig) {
		var formatType = textConfig.format;
		var widget = $(this);
		var type = widget.data('type');

		var dataObj = methods.prepareLineChartData.call(widget, data);
		var log = dataObj.log;
		//dataObj.chartData.series[0].name = textConfig.seriesname;

		var starttime = widget.data('retrievedTimeRange').start;
		var endtime = widget.data('retrievedTimeRange').end;
		//var dtStart = new timezoneJS.Date(starttime,currentTimeZone);
		//var dtEnd = new timezoneJS.Date(endtime,currentTimeZone);
		//var t1 = new timezoneJS.Date(dtStart.getFullYear(), dtStart.getMonth(), dtStart.getDate(), 0, 0, 0, currentTimeZone);
		//var t2 = new timezoneJS.Date(dtStart.getFullYear(), dtStart.getMonth(), dtStart.getDate() + 1, 0, 0, 0, currentTimeZone);

		var chartConfig = {
			chart: {
				// Show chart as "line" on dashboard, but bar on drill
				type: ((type == 'drill') ? 'column' : 'line')
				/*marginRight : 130,
						marginBottom : 25,
						events : {
							selection : function(event) {
								var extremesObject = event.xAxis[0], min = extremesObject.min, max = extremesObject.max, detailData = [], xAxis = this.xAxis[0];
							}
						}*/
			},
			xAxis: {
				//min: widget.data("retrievedTimeRange").range == "TODAY" ? t1.getTime() : widget.data('retrievedTimeRange').start,
				//max: widget.data("retrievedTimeRange").range == "TODAY" ? t2.getTime() : widget.data('retrievedTimeRange').end,
				type: "datetime",
				labels: {
						align: 'right',
						rotation: -45,
			style: {
				backgroundColor:"#ffffff"
			},
					formatter: function() {
						var dt = new timezoneJS.Date(this.value,currentTimeZone);
						//console.log(dt.toString(), new Date(this.value));
						//return "QQ:"+this.value;
						return dt;

						//return methods.formatTime(this.value);

						//var dt = new Date(this.value);
						//return dt.toLocaleDateString() + " " + dt.toLocaleTimeString();

					}
				}
				//categories: dataObj.chartData.categories,
				/*
						labels: {
			   }*/

			},
			yAxis: {
				title: {
					text: textConfig.ytitle,
			style:{
				backgroundColor:"#ffffff"
			}
				}
			},
			tooltip: {
				formatter: function () {
					var dt = new timezoneJS.Date(this.x,currentTimeZone);
					//var timeRange = Highcharts.dateFormat('%e %b %H:%M', this.x);
					var timeRange = dt.toString();
					var base = methods.tooltip(timeRange, this.y, formatType);
					return base;
				}
				/*
						formatter : function() {
							return '<b>' + Highcharts.dateFormat('%e %b %H:%M', this.x) + '</b><br/>' +
									this.y;
						}
						*/
			},
			plotOptions: {
				series: {
					marker: {
						radius: 1
					},
					lineWidth: 1

				}
			},
			series: dataObj.chartData.series
		};

		// change chart type to logarithmic if there is huge difference
		if (log) {
			chartConfig.yAxis.type = "logarithmic";
		} else {
			chartConfig.yAxis.min = 0;
		}


		// don't display legend in single series
		if (dataObj.chartData.series.length == 1) {
			chartConfig.legend = {
				enabled: false
			};
		}
		return chartConfig;
	};

	methods.hideChartBy = function() {
			$('.chartby').addClass('disabled').prop('disabled',true).hide();
			$('#chartedByContainer').hide();
	};

	methods.showChartBy = function() {
			$('.chartby').removeClass('disabled').prop('disabled',false).show();
			$('#chartedByContainer').show();
	};





	/*
	 *
	 * Connect dashboard to faceting
	 *
	 */





	methods.launchDrillDown = function (e, elem, hc) {
		// Get a time range from the point before and after the current point
		var widget = $(this);
		var seriesName = '';
		var timeStart = null,
			timeEnd = null;
		var rawData = widget.data('rawData');
		var val = rawData[e.point.x];
		var key = widget.data('md').dashField;
		var field = methods.getFilter(key, val);
		var chartType = hc.chart.options.chart.type;
		if (chartType == 'spline') {
			var point = $.inArray(e.point,hc.data);
			//var point = hc.data.indexOf(e.point);
			if (point > 0) {
				timeStart = hc.data[point - 1].x;
			}
			if (point < (hc.data.length - 1)) {
				timeEnd = hc.data[point + 1].x;
			}
			if (!timeStart && !timeEnd) {
				timeStart = hc.data[0];
				timeEnd = hc.data[hc.data.length - 1];
			}
			if (timeStart === null) {
				timeStart = e.point.x - (timeEnd - e.point.x);
			}
			if (timeEnd === null) {
				timeEnd = e.point.x + (e.point.x - timeStart);
			}
			duration = timeStart + "," + timeEnd;
		}
		if (widget.data('type') == 'drill') {
			// just click the facet
			if(chartType == 'column') {
				var restObject = methods.getRestObject.call(widget);
				var ts_start;
				var ts_end;
				if(restObject.reportParam.period) {
					var period = restObject.reportParam.period;
					if(period == 'TODAY' || period == 'L1H' || period == 'L12H' || period == 'L1D') {
						ts_start = e.point.x;
						ts_end = e.point.x + 1 * 60 * 60 * 1000;
					} else {
						ts_start = e.point.x;
						ts_end = e.point.x + 1 * 24 * 60 * 60 * 1000;
					}
				} else {
					ts_start = restObject.reportParam.timeBegin * 1000;
					ts_end = restObject.reportParam.timeEnd * 1000;
					if(ts_end - ts_start <= 5 * 24 * 60 * 60 * 1000) {
						ts_start = e.point.x;
						ts_end = e.point.x + 1 * 60 * 60 * 1000;
					} else {
						ts_start = e.point.x;
						ts_end = e.point.x + 1 * 24 * 60 *60 * 1000;
					}
				}
				$('#json-report-from').val(ts_start/1000);
				$('#json-report-to').val(ts_end/1000);
				var lts = new timezoneJS.Date(ts_start, currentTimeZone);
				var lte = new timezoneJS.Date(ts_end, currentTimeZone);
				$('.range_start').html(lts.toString());
				$('.range_end').html(lte.toString());
				$('.timeRangeLabel').attr("data-val", "0");
				$('#duration').val(0);
				methods.getFacets.call(widget);
			//	methods.dynamicTimeChart.call(widget);
				return;

			} else if (chartType != 'spline') {
				var findIt = '[data-rawname="' + encodeURIComponent(val[0]) + '"]';
				var facetelem = $(findIt, '.facets_container .groupby');
				facetelem.click();
				return;
			} else {
				// set time range
				$('#json-report-from').val(timeStart / 1000);
				$('#json-report-to').val(timeEnd / 1000);
				$('#duration').val(0);
				$('.timeRangeLabel').html($('li[data-val="0"]').html());
				$('.durationContainer').data('currentDuration', -1).trigger('click');
				return;
			}
		}
		var seriesIndex = widget.data('seriesIndex');
		if (seriesIndex) {
			seriesName = seriesIndex[hc.index];
		}
		methods.getSessionFlag.call(widget);
		if(widget.data("session_flag") != 0)
		{

			var id = methods.jQObjFromSelector(elem).closest(".ui-widget").attr('id');
			var params = new paramString();
			params.add("s", seriesName);
			params.add("did", id);

			var paramsOnThePage = methods.getParamsFromPage.call(widget);
			var topn = paramsOnThePage.topN;
			var duration = paramsOnThePage.timeRange;
			var group = paramsOnThePage.group;

			// Get specific range of time for spline charts
			params.add("t", topn);
			params.add("d", duration, true);
			params.add("f", field, true);
			params.add("g", group, true);

			window.location.href = 'facet.html?' + params;
		}
		else
		{
			window.location.href = '#';
		}

	};

	/*
	 *
	 * Facet-related methods
	 *
	 */


	// facet initialization methods
	methods.initializeFacetChart = function () {
		var widget = $(this);
		var id = methods._getParam('did')[0];
		methods.getFacetCustomConfig.call(widget, id);
		var facet_config = widget.data("facet_config");
		var facet_json = eval(facet_config);
		
		var series = methods._getParam('s')[0];
		var topn = methods._getParam('t')[0];
		if(!topn && facet_json.topN != "")
		{
			topn = facet_json.topN;
		}
		var duration = methods._getParam('d')[0];
		if(!duration  && facet_json.duration != "")
		{
			duration = facet_json.duration;
		}
		var chartType = methods._getParam('c')[0];
		var viewChart = methods._getParam('v')[0];
		var favoriteid = methods._getParam('favoriteid')[0];
		var group = methods._getParam('g')[0];
		if(!group && facet_json.group != "")
		{
			group = facet_json.group;
		}
		var filters = methods._getParam('f')[0];
		if (filters) {
			filters = JSON.parse(filters);
		}
		else if(facet_json.filter && group != "ALL")
		{
			filters = facet_json.filter;
		}
		if (group != "ALL" && group != "") {
			var group_info = methods.deviceGroup;
			for(var i = 0; i < group_info.length; i++) {
				if(group_info[i].GroupName == group) {
					if(group_info[i].GroupDevicesName.length > 0) {
						filters["CLF_DeviceName"] = group_info[i].GroupDevicesName;
						break;
					}
				}
			}
		}

		widget.data("favorite_id", favoriteid);
		var params = {
			"topN": topn,
			"timeRange": duration,
		"chartType": chartType,
		"viewChart":viewChart,
			"filters": filters,
			"group": group
		};
		methods.initializeFacetChartById.call(widget, id, series, params);
	};

	methods.initializeFacetChartById = function (widgetid, series, params) {
		var widget = $(this);
		$.ajax({
			"url": 'jsonfeed/allwidgets.json',
			"success": function (all_widgets_config) {
				methods._initFacet.call(widget, all_widgets_config, widgetid, series, params);
			},
			type: "GET",
			dataType: "json",
			error: function (a, b, c) {
				console.log("ERROR:", a, b, c);
			}

		});
	};

	methods.check_favorite_input = function(favoriteName, desc) {
		var widget = $(this);
		if(favoriteName == "") {
			alert(i18n_dashboard_settings_input_favorite_name);
			return false;
		} else {
			if(favoriteName.length >=256 || (desc != undefined && desc.length >=256)) {
				alert(i18n_dashboard_settings_name_length_limit);
				return false;
			} else {
				var favorite_data = widget.data('favorites');
				var flag = true;
				var i;
				for(i = 0; i < favorite_data.length; i++) {
					if(favorite_data[i][1] == favoriteName) {
						//if(confirm("The name has already existed!"))
						alert(i18n_dashboard_settings_dup_name);
						flag = false;
						break;
					}
				}
				return flag;
			}
		}
	}

	methods.initFavorites = function () {
		var widget = $(this);
		// only do favorites stuff if we have the proper markup waiting
		if (!$('#chooseFavorite').length) {
			return;
		}

		$('#addFavorite').unbind('click').click(function (e) {
			var saveFavorite = function (e, elem) {
				var favoriteName = $('[name="name"]',elem).val();
				var desc = $('[name="description"]',elem).val();
				//need do check
				if(!methods.check_favorite_input.call(widget, favoriteName)) {
					return false;
				}
				$('#chooseFavorite').show();
				var params = methods.getParamsFromPage.call(widget);
				var viewChart = $('#view_chart').val() || '';
				var logSettings = methods.getCurrentLogSettings.call(widget);
				var jsonConfigData = widget.data() || {};
				if(jsonConfigData.filters.hasOwnProperty("CLF_DeviceName")) {
					delete jsonConfigData.filters.CLF_DeviceName;
				}
				var chartTypeNum;
				switch (params.chartType){
					case "bar":
						chartTypeNum = 0;
						break;
					case "pie":
						chartTypeNum = 1;
						break;
					case "logs":
						chartTypeNum = 2;
						break;
					case "line":
						chartTypeNum = 3;
						break;
				}
				var cDid;
				switch(jsonConfigData.currentDid) {
					case "traffic":
						var series_type = $('.seriesSelect').val();
						if(series_type == "dash_bandwidth_in")
							cDid = "bandwidth_in";
						else if(series_type == "dash_bandwidth_out")
							cDid = "bandwidth_out";
						else
							cDid = "bandwidth_total";
						break;
					case "app_category_access":
						cDid = "bandwidth_total";
						break;
					case "url_filtering":
					case "blocked_url_categories":
					case "app_category_block":
					case "top_policy_enforcement_for_application_control":
					case "top_policy_enforcement_for_url_filtering":
						cDid = "policy_enforcement";
						break;
					case "internet_access":
					case "payload":
					case "url_categories_access":
						cDid = "internet_access";
						break;
					case "internet_security":
					case "users_block_by_internet_security":
					case "top_threat_detection_count":
						cDid = "internet_security";
						break;
					case "dlp":
					case "top_policy_enforcement_for_dlp":
						cDid = "data_security";
						break;
					case "access_control":
						cDid = "access_control";
						break;
				}
				var custom_cols = {};
				if(logSettings.cols == 0) {
					switch(cDid) {
						case "bandwidth_in":
							logSettings.cols = "CLF_UTCTimeStamp,CLF_DeviceName,CLF_UserName,CLF_AppID,CLF_ClientIP,CLF_PolicyName,CLF_InByte";
							break;
						case "bandwidth_out":
							logSettings.cols = "CLF_UTCTimeStamp,CLF_DeviceName,CLF_UserName,CLF_AppID,CLF_ClientIP,CLF_PolicyName,CLF_OutByte";
							break;
						case "bandwidth_total":
							logSettings.cols = "CLF_UTCTimeStamp,CLF_DeviceName,CLF_UserName,CLF_AppID,CLF_ClientIP,CLF_PolicyName";
							break;
						case "policy_enforcement":
							logSettings.cols = "CLF_UTCTimeStamp,CLF_DeviceName,CLF_MsgType,CLF_UserName,CLF_AppID,CLF_URL,CLF_Channel,CLF_ClientIP,CLF_Action,CLF_PolicyName,CLF_URLCategory,CLF_RuleName";
							break;
						case "internet_access":
							logSettings.cols = "CLF_UTCTimeStamp,CLF_DeviceName,CLF_UserName,CLF_URL,CLF_ClientIP,CLF_Domain,CLF_URLCategory";
							break;
						case "internet_security":
							logSettings.cols = "CLF_UTCTimeStamp,CLF_DeviceName,CLF_MsgType,CLF_UserName,CLF_URL,CLF_MalwareName,CLF_Channel,CLF_ClientIP,CLF_Action,CLF_PolicyName";
							break;
						case "dataSecurity":
							logSettings.cols = "CLF_UTCTimeStamp,CLF_DeviceName,CLF_UserName,CLF_URL,CLF_Channel,CLF_ClientIP,CLF_Action,CLF_PolicyName,CLF_RuleName";
							break;
						case "access_control":
							logSettings.cols = "CLF_UTCTimeStamp,CLF_DeviceName,CLF_MsgType,CLF_UserName,CLF_URL,CLF_Channel,CLF_ClientIP,CLF_Action,CLF_PolicyName";
							break;
					}
//					logSettings.cols = "CLF_UTCTimeStamp,CLF_ProductID,CLF_DeviceName,CLF_UserName,CLF_AppID,CLF_ClientIP,CLF_Connection,CLF_Action,CLF_PolicyName,CLF_InByte,CLF_OutByte";
					custom_cols.c = logSettings.cols;
				} else {
					custom_cols = logSettings.cols;
				}
				var jsonData = {
					"favoriteName": favoriteName,
					"description": desc,
					"logFilters": {
						"chartType": chartTypeNum,
						"topN":params.topN,
						"timeRange":params.timeRange,
						"currentDid":jsonConfigData.currentDid,
						"logCategory":cDid,
						"filters":jsonConfigData.filters,
						"rows":logSettings.rows,
						"cols":custom_cols,
						"viewChart":viewChart
					}
				};
				var json = JSON.stringify(jsonData);
				$('#favoriteNameForm').hide();
				$.ajax({
					url: "../../rest/commonlog/log_favorite",
					type: "POST",
					data: json,
					success: function (data) {
						methods.initFavorites.call(widget);
					   // $('#addFavorite').addClass('isFavorite');
					},
					error: function (a, b, c) {
						console.log("ERROR:", a, b, c);
					}
				});
			};

			e.preventDefault();
			$('#addFavoriteDialog').find('input:text').val('');
			$('#addFavoriteDialog').dialog({autoOpen: true,
				"title":geti18n("SAVE_FAVORITE"),
				"modal":true,
				"buttons": [ { text: geti18n("SAVE"),
								click: function(e) {
								saveFavorite(e,$(this));
								$(this).dialog("close");
								}
							},
							{"text":geti18n("CANCEL"),
								"click":function() {
								$(this).dialog("close");
								}
							}
				]
			});
		});

		$('#chooseFavorite').unbind('change').change(function (e) {
			e.preventDefault();
			var id = $(this).val();
			widget.data("favorite_id", id);
			var favorites = widget.data('favorites');
			if (favorites && $.isArray(favorites)) {
				for (var i = 0; i < favorites.length; i++) {
					if (favorites[i][0] == id) {
						var inP = favorites[i][3];
					/*	switch(inP.chartType) {
							case 0:
								inP.chartType = "bar";
								break;
							case 1:
								inP.chartType = "pie";
								break;
							case 2:
								inP.chartType = "logs";
								break;
							case 3:
								inP.chartType = "line";
								break;
						}*/
						//var inP = JSON.parse(favorites[i][3]);
						methods.initializeFacetChartById.call(widget,inP.currentDid,inP.series, inP);
						//methods._initFacetWithConfig.call(widget, inP.md, inP.params);
						// do something!
						break;
					}
				}
			} else {
				// some sort of error
			}

		});


		// get favorites
		$.ajax({
			url: "../../rest/commonlog/log_favorite",
			type: "GET",
			cache: false,
			"dataType": "json",
			success: function (data) {
		if(data && $.isArray(data)) {
			for(var i = 0; i < data.length; i++) {
				inP = data[i][3];
				switch(data[i][3].chartType) {
									case 0:
											inP.chartType = "bar";
												break;
										case 1:
												inP.chartType = "pie";
												break;
										case 2:
												inP.chartType = "logs";
												break;
										case 3:
												inP.chartType = "line";
												break;
								}

			}
		}
				widget.data('favorites', data);
				//$('#addFavorite').removeClass('isFavorite');
				$('#favoriteName').val('');
				if (data.length) {
					$('#chooseFavorite').html('');
					$('#chooseFavorite').append($("<option value=''>" + geti18n("LABEL.SELECT_FAVORITE") + "</option>"));
					for (var i = 0; i < data.length; i++) {
						$('#chooseFavorite').append($("<option></option>")
							.attr('value', data[i][0])
							.text(data[i][1]));

							/*if (methods.isSameParams.call(widget,data[i][3], 'init')) {
								$('#addFavorite').addClass('isFavorite').attr('data-favoriteid',data[i][0]);
								$('#favoriteName').val(data[i][1]);
								$('#chooseFavorite').val(data[i][0]);
							}*/
					}
		if(widget.data("favorite_id")) {
			$("#chooseFavorite").val(widget.data("favorite_id"));
		}
					$('#chooseFavorite').show();
				} else {
					$('#chooseFavorite').hide();
				}
			},
			error: function (a, b, c) {
				console.log("ERROR:", a, b, c);
			}
		});
	methods.getSessionFlag.call(widget);
	   if(widget.data("session_flag") != 3) {
		$('#addFavorite').hide();
	   }


	};

	/*methods.isSameParams =function(fparams, where) {
		var widget = $(this);
		if (fparams.currentDid != widget.data('currentDid')) {
			return false;
		}
		var ip;
		if(where == 'init') {
			ip = widget.data('initParams').params;
		} else if(where == 'update') {
		var duration = $('.duration', widget).val();
		if(duration == 0) {
			ip = methods.getParamsFromPage.call(widget);
		} else {
			ip = new Object();
			ip.timeRange = duration;
			ip.topN = $('.topN', widget).val();
		}
		ip.filters = methods.getFilters.call(widget);
	}
		if (!ip.chartType) {
			ip.chartType = methods.getChartType.call(widget);
		}
		if (fparams.chartType != ip.chartType) {
			return false;
		}*/
		// skip columns because we need to wait for facets
		/*
		if (params.column != ip.column) {
			return false;
		}
		*/
		/*if (fparams.timeRange != ip.timeRange) {
			return false;
		}
		if (fparams.topN !=  ip.topN) {
			return false;
		}*/
		// sort the filters
		//var noMsgParams = $.extend(true,{},fparams.filters);
		//var noMsgParams2 = $.extend(true,{},ip.filters);
		/*
		if (noMsgParams.hasOwnProperty('CLF_MsgType')) {
			delete noMsgParams.CLF_MsgType;
		}
		if (noMsgParams2.hasOwnProperty('CLF_MsgType')) {
			delete noMsgParams2.CLF_MsgType;
		}
		*/

		// For ie8
		/*Object.keys = Object.keys || function(o) {
			var result = [];
			for(var name in o) {
				if (o.hasOwnProperty(name))
				  result.push(name);
			}
			return result;
		};

		var favoriteKeys = Object.keys(noMsgParams);
		var currentKeys = Object.keys(noMsgParams2);
		if (favoriteKeys.length != currentKeys.length) {
			return false;
		}
		favoriteKeys.sort();
		currentKeys.sort();
		for (var i=0;i<favoriteKeys.length;i++) {
			if (favoriteKeys[i] != currentKeys[i]) {
				return false;
			}
			if (fparams.filters[favoriteKeys[i]] != ip.filters[favoriteKeys[i]]) {
				return false;
			}
		}

		return true;
	};*/

	methods._initFacet = function (all_widgets_config, id, series, params) {
		var widget = $(this);
		var metadata = methods.getWidgetConfigById.call(widget, all_widgets_config, id, series);

		widget.data("initParams", {
			id: id,
			series: series,
			params: params
		});
		methods._initFacetWithConfig.call(widget, metadata, params);
	};


	methods._initFacetWithConfig = function (metadata, params) {
		var widget = $(this);

		// set title

		//$('#queryTitle').text(geti18n(metadata.chartConfig.bar.title,"dashboard"));
		if(methods._getParam('s')[0] == "dash_bandwidth_out"){
			$('#queryTitle').text(geti18n("LABEL.ApplicationBandwidthOut","dashboard"));
		}else if(methods._getParam('s')[0] == "dash_bandwidth_in"){
			$('#queryTitle').text(geti18n("LABEL.ApplicationBandwidthIn","dashboard"));
		}else if(methods._getParam('s')[0] == "dash_bandwidth_total"){
			$('#queryTitle').text(geti18n("LABEL.ApplicationBandwidth","dashboard"));
		}else{
			$('#queryTitle').text(geti18n(metadata.chartConfig.bar.title,"dashboard"));
		}

		// initialize widgets -- sets md data as side effect
		methods.initWidget.call(widget, metadata, "drill", params);

		var params = params || {};
		params.filters = params.filters || {};

		var columnStr = "";
		if(metadata){
			var columnList = metadata.logFields.defaultFields;
			if(widget.data("interrupted_log") == 1 && typeof(metadata.logFields1) != "undefined")
			{
				columnList = metadata.logFields1.defaultFields;
			}
			
			for(var i=0; i<columnList.length; i++){
				if(i != columnList.length -1){
					columnStr += columnList[i] + ",";
				}else{
					columnStr += columnList[i];
				}
			}
		}

		var chartType = null;
		var viewChart = params.viewChart ? params.viewChart+'' : null;
		if(viewChart) {
			widget.data("viewchartid", viewChart);
		}
		if (params.chartType) {
			chartType = params.chartType+'';
		}

		params.column = columnStr;

		var restObject = methods.getRestObject.call(widget, params, "query");
		var pdfConfig = widget.data('pdfConfig') || {};


		// restObject function will overwrite params.chartType with page value
		if (!chartType) {
			chartType = params.chartType;
		}

		var filters = {};
		filters.col = "CLF_MsgType";
		filters.op = "==";
		filters.value = widget.data('md').logCategory;
		restObject.query.filters.push(filters);
		pdfConfig.logPageQueryParam = restObject;

		widget.data('pdfConfig', pdfConfig);


		//methods.initLogs.call(widget, params);

		// initialize facets
		methods.setFilters.call(widget, params.filters);
		methods.getFacets.call(widget);
		methods.setFacetsHandlers.call(widget);

		widget.data("params", params);
		// facet/chart switcher
		/*
		$('#showchart').click(function (e) {
			$('#chartContainer', widget).show();
			$('.logs', widget).hide();
		});
		*/
		$('#showlogs').click(function (e) {
			e.preventDefault();
		// initialize log detail -
			methods.setFilters.call(widget, widget.data("params").filters);
			methods.updateChart.call(widget, {}, widget.data('rawFacets').CLF_UserName);
			$('.logs', widget).show();
			methods.initLogs.call(widget, widget.data("params"));
			$('#chartContainer', widget).hide();
		//    methods.hideChartBy();
		//    $('.logs', widget).show();
		});
/*
		$('#chartedBy').click(function(e) {
			e.preventDefault();
			$('#chartedBy').hide();
			$('#view_chart').show();
		});
		$('#chartedBy').mouseover(function(e) {
			$('#chartedBy').hide();
			$('#view_chart').show();
		});
*/



/*
 *
 *For online help
 *
 */


		$("#online_help").click(function(){
				var did = widget.data('currentDid');
				switch(did){
						case "traffic":
						case "app_category_access":
								openhelpwin('../../../../html/help/log_analysis_bandwidth.htm');
								break;
						case "url_filtering":
						case "blocked_url_categories":
						case "app_category_block":
						case "top_policy_enforcement_for_application_control":
						case "top_poiicy_enforcement_for_url_filtering":
								openhelpwin('../../../../html/help/logs_policy_enforcement.htm');
								break;
						case "internet_security":
						case "users_block_by_internet_security":
						case "top_threat_detection_count":
								openhelpwin('../../../../html/help/logs_internet_security.htm');
								break;
						case "internet_access":
						case "payload":
						case "url_categories_access":
								openhelpwin('../../../../html/help/logs_internet_access.htm');
								break;
						case "dlp":
						case "top_policy_enforcement_for_dlp":
								openhelpwin('../../../../html/help/logs_data_security.htm');
								break;
						case "access_control":
								openhelpwin('../../../../html/help/logs_access_control.htm');
								break;
				}
		});















		$('#downloadpdf').click(function (e) {
		  var dialogOpts = {
			 dialogClass: "my-dialog"
			};
			$('#pdfdialog').dialog(dialogOpts).show();
			var jsonData = widget.data('pdfConfig') || {};

			/*var logPageQuery = jsonData.logPageQueryParam;
			logPageQuery.query.period = undefined;
			logPageQuery.query.timeBegin = undefined;
			logPageQuery.query.timeEnd = undefined;
			var restObject = methods.getRestObject.call(widget, logPageQuery, "query");
			jsonData.logPageQueryParam = restObject;*/
			var cols = $('[name=columns]:checked').map(function() { return $(this).val(); }).get().join(",");
			jsonData.logPageQueryParam.column = cols;
			var chartType = methods.getChartType.call(widget);
			if(chartType == "logs") {
				jsonData.log = true;
			} else {
				jsonData.log = false;
			}
			jsonData.currentTimeZone = currentTimeZone;

			var json = JSON.stringify(jsonData);
			$('#pdfParams').val(json);
			$('#downloadpdf').submit();
			$('#getpdf').click();
			setTimeout(function() {
				$('#pdfdialog').dialog('close');
			}, 4000);
		});

		if(params.timeRange){
			$('.timeRangeLabel').html($('ul.optionList > li[data-val="'+ params.timeRange +'"]').html());
		}

		if (chartType) {
			$('[data-ctype="'+chartType+'"]',widget).click();
		}
		if(viewChart) {
			$('#view_chart').val(viewChart);
		} /*else {
			var groupByField = "CLF_UserName";
					$('[data-key=' + groupByField + ']').addClass('groupby');
					$('#view_chart').val(groupByField);
		}*/
	};

	methods.addSeriesChanger = function (md, selected) {
		var widget = $(this);
		var series;
		var option = '';
		var did = widget.data('currentDid');
		var seriesSwitch = '<select class="seriesSelect">';
		var count = 0;
		if (md.hasOwnProperty('seriesFacets')) {
			for (series in md.seriesFacets) {
				// not a series - it just tells us to display other charts
				if (series == '_includeParentChart') {
					continue;
				}
				if (md.seriesFacets.hasOwnProperty(series)) {
					count++;
					option = (series == selected) ? ' selected="selected" ' : '';
					seriesSwitch += '<option value="' + series + '"' + option + '>' + geti18n(series, "dashboard.series") + '</option>';
				}
			}
		}
		seriesSwitch += "</select>";
		// Only show series switch if we have more than one series
		if (count > 1) {
			$(".seriesSwitch").html(seriesSwitch);
		}

		$('.seriesSelect').change(function () {
			// for now just reload the page
			var item = $(this).val();
			// need better way of calling
			//methods.launchDrillDown();
			var params = methods.getParamsFromPage.call(widget); 
			var topN = params.topN;
			var chartType = params.chartType;
			var timeRange = params.timeRange;
			var filters = methods.getFilters.call(widget);
			var viewChart = $('#view_chart').val();
			var group = params.group;

			window.location.href = 'facet.html?did=' + did + '&s=' + item + '&t=' + topN + '&d=' + timeRange + '&c=' + chartType + '&v=' + viewChart + '&g=' + group + '&f=' + JSON.stringify(filters);
		});
	};


	methods.getWidgetConfigById = function (all_widgets_config, id, series) {
		var widget = $(this);
		widget.data("currentDid", id);
		var i, ob, sn;
		var cc, fd, md;
		var lo = {};
		// check the log query config
		if (all_widgets_config.log_only) {
			lo = all_widgets_config.log_only;
		}
		if (lo.hasOwnProperty(id)) {
			md = $.extend(true, {}, lo._common, lo[id]);
		} else {
			var base = all_widgets_config.result.data;
			for (i = 0; i < base.length; i++) {
				ob = base[i];
				if (ob.id == id) {
					break;
				} else {
					ob = null;
				}
			}

			if (ob === null) {
				return ob;
			}
			md = ob.metadata;
			// but wait - we may want to find a log query config from dashboard
			// we can check for the "drillData" property - and get the
			// config for that
			if (md.hasOwnProperty('drillData')) {
				if (lo.hasOwnProperty(md.drillData)) {
					md = $.extend(true, {}, lo._common, lo[md.drillData]);
				}
			}

		}


		if (!series) {
			series = md.defaultSeries;
		}
		// find the appropriate series
		if (md.hasOwnProperty('seriesFacets')) {
			for (sn in md.seriesFacets) {
				if (md.seriesFacets.hasOwnProperty(series)) {
					fd = $.extend(true, {}, md.seriesFacets[series]);
					$.extend(true, md, fd);
					// delete chartTypes that are not in series config
					// (but allow config using same chart type)
					// However, includeParentChart setting allows all to be included
					if (!md.seriesFacets._includeParentChart) {
						if (fd.hasOwnProperty("chartConfig")) {
							for (cc in md.chartConfig) {
								if (!fd.chartConfig.hasOwnProperty(cc)) {
									delete md.chartConfig[cc];
								}
							}
						}
					}
				}
			}
		}


		methods.addSeriesChanger.call(widget, md, series);
		return md;


	};

	methods.getTotalCount = function(totalCountObject) {
var widget = $(this);
	$.ajax({
		url:"../../rest/commonlog/report_query",
		dataType: "json",
		type: "POST",
		async: false,
		data: totalCountObject,
		success: function(device_list) {
			var count = 0;
			var i;
			if(device_list) {
				for(i = 0; i < device_list.length; i++)
					count += device_list[i][1];
				widget.data('TotalCount', count);
			} else {
				widget.data('TotalCount', 0);
			}
		},
		error: function(err) {
			console.log(err);
		}
	});

	};


	methods.getFacetsHTML = function (facetData, filters) {
		var widget = $(this);
		var name, rawName;
		var columns = [];
		var okToDisplayColumn = false;
		var viewChartHTML = '';
		var facetsList = '<ul class="facets_container clearfix">';
		//var totalCount = methods.getTotalCount(facetData);
	var totalCount = widget.data('TotalCount');
		var tc = methods.format([[null,totalCount]], widget.data('md').facetConfig.format);

		widget.data('TotalCount', totalCount);

		facetsList += '<li class="facet_group"><span class="facetname">'+geti18n('TOTAL')+'</span><span class="facetvalue">'+tc[0][1]+'</span></li>';
		for (var key in facetData) {
			if(facetData.hasOwnProperty(key) && key != 'CLF_DeviceName') {
				var opts = facetData[key];
				if (widget.data('md').facetConfig.format) {
					opts = methods.format(opts, widget.data('md').facetConfig.format);
				}
			if(filters.hasOwnProperty("CLF_MsgType") && filters.CLF_MsgType == "851969" && key == 'CLF_ClientIP') {
				facetsList += '<li class="facet_group" data-key="' + key + '">' + geti18n('CLF_CompromisedHost', "dashboard") +
		' <span class="chartby"></span>' +
		' <input type="text" class="mysearch"></input>' + '<ul class="' + key + '">';
			} else {
				//facetsList+= '<li class="facet_group" data-key="'+key+'">'+key.replace(/^CLF_/,'')+"<ul class='"+key+"'>";
				facetsList += '<li class="facet_group" data-key="' + key + '">' + geti18n(key, "dashboard") +
		' <span class="chartby"></span>' +
		' <input type="text" class="mysearch"></input>' + '<ul class="' + key + '">';
			}
				viewChartHTML += '<option value="' + key + '">' + geti18n(key, "dashboard") + '</option>';
				okToDisplayColumn = true;
				for (var i = 0; i < opts.length; i++) {
					name = methods.getCategoryName(opts[i], key);
					rawName = encodeURIComponent(opts[i][0]);
					rawName = rawName.replace(/'/g, "\t");
					facetsList += "<li data-rawname='" + rawName + "'><a href='#" + rawName + "' class='facetname'>" + (name + '') + "</a> <span class='facetvalue'>" + opts[i][1] + "</span>";
					if (filters && filters.hasOwnProperty(key) && filters[key] == opts[i][0]) {
						facetsList += '<span class="remove">[x]</span>';
						okToDisplayColumn = false;
					}
					facetsList += "</li>";
				}
				// we wont display data for columns we filter
				if (okToDisplayColumn) {
					columns.push(key);
				}
				facetsList += "</ul></li>";
				$('#view_chart').html(viewChartHTML);

			}
		}

		columns.unshift('CLF_UTCTimeStamp');
		//widget.trigger('updateColumns', columns + '');
		facetsList += "</ul>";
		return facetsList;
	};

	methods.pdfConfigifyFacet = function (facet) {
		var f;
		var outObj = {};
		for (f in facet) {
			// we only allow one facet per item, and the counts are somewhat bogus
			outObj[geti18n(f)] = [
				[methods.getCategoryName(facet[f], f), ""]
			];
		}
		return outObj;
	};

	methods.breadcrumbfacet = function (facet) {
		var f;
		var facetText = '';
		for (f in facet) {
			if(f != 'CLF_DeviceName') {
				if(methods.getCategoryName(facet[f], f).length > 100) {
					facetText += "<span data-key='" + f + "' class='remove' style='display:block'>" + methods.getCategoryName(f, "CLF_Fields") + " &gt; " + methods.getCategoryName(facet[f], f) + "[x]</span>";
				} else {
					facetText += "<span data-key='" + f + "' class='remove'>" + methods.getCategoryName(f, "CLF_Fields") + " &gt; " + methods.getCategoryName(facet[f], f) + "[x]</span>";
				}
			}
		}
		$('#breadcrumb').html(geti18n("FILTERS") + facetText);
	};

	methods.facetSearch = function (key,search,callback) {
		var widget = $(this);
		var restObj = {};
		restObj.column = key;

		//restObj.keyword = "*" + methods.convert8859String(search) + "*";
		if (key == 'CLF_UserName')
		{
			restObj.keyword = "*" + search + "*";
		}
		else
		{
			restObj.keyword = "*" + methods.convert8859String(search) + "*";
		}

		var restText = JSON.stringify(restObj);

		$.ajax({
			url: "../../rest/commonlog/log_search",
			dataType: "json",
			type: "POST",
			data: restText,
			success: function (searchData) {
				if("CLF_URLCategory" == key) {
					for(var i = 0; i < searchData.length; i++) {
						if("0" == searchData[i].column_id) {
							searchData.splice(i, 1);
						}
					}
				}
				callback(searchData);
			}
		});
	};
	methods.string_to_binary = function(str) {
		var bytes = [];
		for(var i = 0; i < str.length; i++) {
			bytes.push(str.charCodeAt(i));
		}
		return bytes;
	}

	methods.isLatin = function(byte) {
		return byte >= 0x80 && byte < 0x2000 ;
	}

	methods.convert8859String = function(str) {
		var arr = new Array();
		arr = methods.string_to_binary(str);
		var new_str = '';
		for(var i = 0; i < arr.length; i++) {
			if(methods.isLatin(arr[i])) {
				new_str += "&#" + arr[i].toString() + ';'
			} else {
				new_str += str[i];
			}
		}
		return new_str;
	}



	methods.getFacets = function (filter) {
		var widget = $(this);
		filter = methods.getFilters.call(widget);
		var pdfConfig = widget.data('pdfConfig') || {};
		pdfConfig.facet = methods.pdfConfigifyFacet(filter);
		widget.data('pdfConfig', pdfConfig);
		methods.breadcrumbfacet(filter);

		methods.setFilters.call(widget,filter);
		var basicParams = $.extend(true, {}, widget.data('md').facetConfig, {
			reportParam: {
				filters: filter,
				topN: 5
			}
		});
		var restObject = methods.getRestObject.call(widget, basicParams);

		var restText = JSON.stringify(restObject);
	restObject.reportParam.reportTemplate = restObject.reportParam.reportTemplate.replace('facet', 'facet_total');
	var restTextTotalCount = JSON.stringify(restObject);
	methods.getTotalCount.call(widget, restTextTotalCount);
		methods.loader(0, widget);
		$.ajax({
			url: "../../rest/commonlog/report_query",
			dataType: "json",
			type: "POST",
		async: false,
			data: restText,
			success: function (facetData) {
				methods.loader(1, widget);
				var rawFacets = {};
				rawFacets = $.extend(true, {}, rawFacets, facetData);
				widget.data('rawFacets', rawFacets);
				$('.facets', widget).empty().html(methods.getFacetsHTML.call(widget, facetData, filter));
		$('.mysearch').autocomplete( {
			source: function(req,add) {

				var key = $(this.element).closest('li').attr('data-key');
				methods.facetSearch.call(widget,key,req.term,function(data) {
					var res = $.map(data,function(el,i) {
						var elm_type = el.column_type;
						var elm_val = el.column_value;
						var src = new RegExp("(" + req.term + ")", "g");
						var label = elm_val.replace(src, '<b>' + "$1" + '</b>');
						if(elm_type == "CLF_URLCategory" || elm_type == "CLF_AppID" || elm_type == "CLF_Action" || elm_type == "CLF_MsgType"){
							var elm_id = el.column_id;
							var ret = {"label":label, "value":elm_id, "key":elm_type};
							return ret;
						} else {
							var ret = {"label":label, "value":elm_val, "key":elm_type};
							return ret;
						}
					});
					add(res);
				});
			}
		});

		// allow html to be passed in to autocomplete results
		$('.mysearch').each (function() {
			if (!$(this).data('uiAutocomplete')) {
				return;
			}
			$(this).data('uiAutocomplete')._renderItem = function(ul,item) {
				return $( "<li></li>" )
					.data( "item.autocomplete", item )
					.append( $( "<a></a>" ).html( item.label ) )
					.appendTo( ul );
			};
		});
		$('.mysearch').off('autocompleteselect').on('autocompleteselect', function(event,ui) {
			var rawName = ui.item.value;
			//var key = $(this).closest('li').attr('data-key');
			var key = ui.item.key;
			methods.updateFacets.call(widget,key,rawName);

		});
		//var favorite_id = widget.data('favoriteid');
//if(favorite_id == undefined) {
	var favid = widget.data("favorite_id");
	var data = widget.data("favorites");
	if(favid && data) {

		for(var i = 0; i < data.length; i++) {
			if(data[i][0] == favid) {
				break;
			}
		}
		$("#chooseFavorite").val(data[i][0]);
		$("#favoriteName").val(data[i][1]);
	}
//	if(data) {
	//$('#addFavorite').removeClass('isFavorite').attr('data-favoriteid', '');
//	$('#chooseFavorite').val("");
/*		for(var i = 0; i < data.length; i++) {
			if (methods.isSameParams.call(widget, data[i][3], "update")) {
									$('#addFavorite').addClass('isFavorite').attr('data-favoriteid',data[i][0]);
									$('#favoriteName').val(data[i][1]);
									$('#chooseFavorite').val(data[i][0]);
					}
		}
	}*/
//} else {
/*console.log(favorite_id);
	$('#addFavorite').removeClass('isFavorite').attr('data-favoriteid', '');
	$('#addFavorite').addClass('isFavorite').attr('data-favoriteid', favorite_id);
	$('#chooseFavorite').val(favorite_id);
	$('#favoriteName').val($('#chooseFavorite option:selected').text());
	widget.data('favoriteid', undefined);*/
//}
				// to enable highlighting the group of selected facet
				$('li .remove').closest('li').parent().closest('li').addClass('selectedFacet');


//	var groupByField = widget.data("viewchartid");
			   // var groupByField = "CLF_UserName";
			   // $('[data-key=' + groupByField + ']').addClass('groupby');
			   // $('#view_chart').val(groupByField);
				//$('#chartedBy').text(geti18n(groupByField));

				var time_val = $(".timeRangeLabel").attr("data-val");
				var time;
				$(".optionList").children().each(function(){
					if($(this).attr("data-val") == time_val && $(this).attr("data-val")!= "0") {
						time = $(this).html();
						$('.timeRangeLabel').html(time);
					} else if($(this).attr("data-val") == time_val && $(this).attr("data-val") == "0") {
						time = $('.range_start').html() + " to " + $('.range_end').html();
						$('.timeRangeLabel').html(time);
						methods.setFacetCustomConfig.call(widget);
					}
				});

				//fix the bug to show selected view chart after refresh
		var id = widget.data("viewchartid");
		if(!id) {
			id = $('#view_chart').val();
		}
				if(id && widget.data("rawFacets").hasOwnProperty(id)){
					//$('[data-key="' + id + '"] .chartby').trigger('click');
					//$('#chartedBy').text(geti18n(id));
		$('[data-key=' + id + ']').addClass('groupby');
				$('#view_chart').val(id);
				$('#chartedBy').text(geti18n(id));
					$('#view_chart').val(id);
					methods.updateChart.call(widget, {"filters":filter}, rawFacets[id]);
				} else {
		var groupByField = "CLF_UserName";
				$('[data-key=' + groupByField + ']').addClass('groupby');
				$('#view_chart').val(groupByField);
				$('#chartedBy').text(geti18n(groupByField));
					methods.updateChart.call(widget, {"filters":filter}, rawFacets.CLF_UserName);
				}
			},
			error: function (a, b, c) {
				methods.loader(1, widget);
				// print no data message
				$('.facets', widget).empty().text(geti18n("NO_DATA"));
				methods.updateChart.call(widget, {"filters":filter}, null);

			}
		});

	};

	methods.updateFacets = function(key, rawName) {
		var widget = $(this);
			if (rawName) {
				rawName = decodeURIComponent(rawName);
				rawName = rawName.replace(/\t/g, "\'");
			}
			var filters = methods.getFilters.call(widget);
			if (filters.hasOwnProperty(key)) {
				// may want to do something with old property
			}
			filters[key] = rawName;
			methods.setFilters.call(widget,filters);
			// call initLogs first - so that the getFacets can call the update event
			//methods.initLogs.call(widget, {
			//    filters: filters
			//});
			if(methods.getChartType.call(widget) == "logs") {
				methods.initLogs.call(widget, {
					filters: filters
				});
			}
			methods.getFacets.call(widget);
			// chart will be updated with the facet data

	};

	methods.setFacetsHandlers = function () {
		var widget = $(this);
		// add facet
		widget.off('click', '.facet_group li').on('click', '.facet_group li', function (e) {
			var key = $(this).closest('.facet_group').attr('data-key');
			var rawName = $(this).attr('data-rawname');
			if (rawName) {
				rawName = decodeURIComponent(rawName);
				rawName = rawName.replace(/\t/g, "\'");
			}
			if(key == "CLF_URLCategory") {
				var raw_data = widget.data("rawFacets");
				var i;
				for(i = 0; i < raw_data.CLF_URLCategory.length; i++) {
					if(raw_data.CLF_URLCategory[i][0] == rawName && raw_data.CLF_URLCategory[i][2] == 1) {
						key = "CLF_CustomURLCategory";
					}
				}
			}
			var filters = methods.getFilters.call(widget);
			if (filters.hasOwnProperty(key)) {
				// may want to do something with old property
			}
			filters[key] = rawName;
			methods.setFilters.call(widget,filters);
			// call initLogs first - so that the getFacets can call the update event
			if(methods.getChartType.call(widget) == "logs") {
				methods.initLogs.call(widget, {
					filters: filters
				});
			}
			methods.getFacets.call(widget);
			// chart will be updated with the facet data
		});
		// remove facet
		widget.off('click', '.remove').on('click', '.remove', function (e) {
			e.stopPropagation();
			var filters = methods.getFilters.call(widget);
			var key = $(this).attr('data-key');
			if (!key) {
				key = $(this).closest('.facet_group').attr('data-key');
			}
			delete filters[key];
			methods.setFilters.call(widget,filters);
			if(methods.getChartType.call(widget) == "logs") {
				methods.initLogs.call(widget, {
					filters: filters
				});
			}
			methods.getFacets.call(widget);
		});

		$(document).off('click', '.chartby').on('click', '.chartby', function (e) {
			e.stopPropagation();
			if ($(this).hasClass('disabled')) {
				return;
			}
			$('.groupby').removeClass('groupby');
			$(this).closest('.facet_group').addClass('groupby');
			var key = $(this).closest('.facet_group').attr('data-key');
/*var favorites_arr = widget.data("favorites");
	if(favorites_arr) {
	for(var i = 0; i < favorites_arr.length; i++) {
		if(favorites_arr[i][0] == $('#addFavorite').attr("data-favoriteid")) {
			if(key != favorites_arr[i][3].viewChart) {
				$('#addFavorite').removeClass('isFavorite').attr('data-favoriteid', '');
				$('#chooseFavorite').val("");
			}
		}
	}
	}*/
			var rawFacets = widget.data('rawFacets');
			var filters = methods.getFilters.call(widget);
			if (rawFacets.hasOwnProperty(key)) {
				methods.updateChart.call(widget, filters, rawFacets[key]);
			}
			$('#view_chart').val(key);
		});
		$('#view_chart').off('change').on('change', function (e) {
			e.stopPropagation();
			var id = $(this).val();
			widget.data("viewchartid", id);
			$('[data-key="' + id + '"] .chartby').trigger('click');
			//$('#chartedBy').text(geti18n(id));
			//$('#view_chart').hide();
			//$('#chartedBy').show();
		});

	};

	methods.formatDeviceList = function(devices) {
	var device_list = devices.split(",");
	return device_list;
	}

	/*
	 *
	 *  Detailed log table
	 *
	 */

 methods.getCurrentLogSettings = function() {
		var widget = $(this);
		var dtObj = widget.data('dtObj') || null;
		if (!dtObj) {
			return {"rows":0,"cols":0};
		}
		var dtSettings = dtObj.fnSettings();
		var aoColumns = dtSettings.aoColumns || [];
		var tableObj = {};
		tableObj.rows = dtSettings._iDisplayLength;
		var columnNames = [];
		var columnViz = [];
		var columnWidth = [];
		for (var i=0;i<aoColumns.length;i++) {
			columnNames.push(aoColumns[i].sName);
			columnViz.push(aoColumns[i].bVisible ? 1:0);
			columnWidth.push(parseInt(aoColumns[i].sWidth,10));
		}
		tableObj.cols = {
			c : columnNames.join(","),
			v : columnViz.join(','),
			w : columnWidth.join(',')
		};
		return tableObj;
	};
	methods.getDataColumns = function (columnNames,colData) {
		// Will be errors here until we configure logs!
		if (colData && colData.c) {
			columnNames = colData.c;
		}
		var cols = columnNames.split(",");
		var i;
		colHeads = [];
		var toDate = function (origDate, type, row) {
			//var d = new Date(origDate * 1000);
			var dt = new timezoneJS.Date(origDate * 1000, currentTimeZone);
			var d = dt._dateProxy;
			return d.toLocaleDateString() + ' ' + d.toLocaleTimeString() + ' ' + dt.getTimezoneInfo().tzAbbr;
		};

		var localizedCategory = function (o, type, row) {
			if("0" == o) {
				return geti18n("GENERIC");
			} else if(undefined == o || "" == o) {
				if ( undefined == row["CLF_CustomURLCategory"] || "" == row["CLF_CustomURLCategory"])
				{
					return geti18n("undefined_token");
				}
				else
				{
					return row["CLF_CustomURLCategory"];
				}
			} else {
				return methods.getCategoryName(o, "CLF_URLCategory");
			}
		};

		var localizedAction = function (o, type, row) {
			if("" == o) {
				return geti18n("undefined_token");
			} else {
				return methods.getCategoryName(o, "CLF_Action");
			}
		};

		var localizedMsgType = function (o, type, row) {
			if("" == o) {
				return geti18n("undefined_token");
			} else {
				return methods.getCategoryName(o, "CLF_MsgType");
			}
		};

		var localizedAppID = function (o, type, row) {
			if("4" == o) {
				return geti18n("GENERIC");
			} else if("" == o) {
				return geti18n("undefined_token");
			} else {
				return methods.getCategoryName(o, "CLF_AppID");
			}
		};

		var localizedOthers = function (o, type, row) {
			if("" == o) {
				return geti18n("undefined_token");
			} else {
				return o;
			}
		};

		var truncateTooltip = function (o, type, row) {
			if("" == o || "https:///" == o || "http:///" == o) {
				return geti18n("undefined_token");
			} else {
				return '<div class="truncSpan" title="'+o+'">'+o+'</div>';
			}
		};

		var renderSize = function (o, type, row) {
			var arr = methods.format ([[null,o]],"KB");
			return arr[0][1];
		};

		var truncateRendered = function(func) {
			var newFunc = function(o, type, row) {
				var result = func(o, type, row);
				var truncated = truncateTooltip(result);
				return truncated;
			};
			return newFunc;
		};

		for (i = 0; i < cols.length; i++) {
			var title = geti18n(cols[i]);
			var obj = {
				"sTitle": title,
				"sDefaultContent": "",
				"sName":cols[i],
				"mData":cols[i]
			};
			if ('CLF_UTCTimeStamp' == cols[i]) {
				obj.sType = "date";
				obj.mRender = toDate;
			} else if ('CLF_URLCategory' == cols[i]) {
				obj.mRender = localizedCategory;
			} else if ('CLF_Action' == cols[i]) {
				obj.mRender = localizedAction;
			} else if ('CLF_MsgType' == cols[i]) {
				obj.mRender = localizedMsgType;
			} else if ('CLF_AppID' == cols[i]) {
				obj.mRender = localizedAppID;
			} else if ('CLF_URL' == cols[i]) {
				obj.mRender = truncateTooltip;
			} else if ('CLF_Size' == cols[i]) {
				obj.mRender = renderSize;
			} else {
				obj.mRender =localizedOthers;
			}

		// Add truncateToolTip to everything
			if (obj.mRender) {
				if (obj.mRender != truncateTooltip) {
					obj.mRender = truncateRendered(obj.mRender);
				}
				else {
					obj.mRender = truncateTooltip;
				}
			}
			else {
				obj.mRender = truncateTooltip;
			}

			if (colData && colData.w) {
				obj.sWidth = colData.w.split(",")[i];
			}

			if (colData && colData.v) {
				obj.bVisible = (colData.v.split(",")[i] == 1);
			}
			//obj.sWidth = "auto";
			obj.sWidth = "1";
			colHeads.push(obj);
		}
		return colHeads;
	};

	// Add the paging and cursor to the log query params (using data table api)
	methods.updateLogQueryParams = function (restObject, dataobj) {
	restObject = restObject || {};
		var widget = $(this);
		var qp = {};
		for (var i = 0; i < dataobj.length; i++) {
			qp[dataobj[i].name] = dataobj[i].value;
		}
		// set the CSV download params
		var csvParams = $.extend(true, {}, restObject);
		delete csvParams.paging;
		delete csvParams.cursor;
		$('#csvParams').attr('value', JSON.stringify(csvParams));

		var cursor = widget.data('cursor');
		if (cursor) {
			restObject.cursor = cursor;
		}

		// don't use cursor if we are starting a new query
		if (!qp.iDisplayStart) {
			delete restObject.cursor;
		}
		if(qp.iDisplayLength) {
			restObject.paging = {
				"limit": qp.iDisplayLength,
				"skip": qp.iDisplayStart
			};
		}
		return restObject;

	};


	methods.populateFields = function(elem) {
		var widget = $(this);
/*        var dtObj = $(this).data('dtObj');
		var availableFields = dtObj.fnSettings().aoColumns;
		var html ='<div class="selcol1">';
		var d2 = (availableFields.length-1) /2;
		for (var i=0;i<availableFields.length;i++) {
			var tp = "col"+(i%2);
			if (i > d2) {
				html += '</div><div class="selcol2">';
				d2 = 99999999;
			}
			var selected = availableFields[i].bVisible;
			html += '<span class="'+tp+'"><input name="columns" type="checkbox" '+(selected ? 'checked="checked"' : "")+' value="'+availableFields[i].sName+'">'+geti18n(availableFields[i].sTitle)+"</span>";
		}
		html  += "</div>";
		$('#selectFields').html(html);*/
		$('#selectFields input').off('change').on('change', function (e) {
			//var cols = $('[name=columns]:checked').map(function() { return $(this).val(); }).get().join(",");
			//widget.trigger('updateColumns', cols);
			var index = $('#selectFields input').index($(this));
			var checked = $(this).is(":checked");
			try
			{
				widget.data('dtObj').fnSetColumnVis(index,checked,true);
			}
			catch(err)
			{
			}
			if ("CLF_URLCategory" == this.value)
			{
				$('#selectFields input[value="CLF_CustomURLCategory"]')[0].checked = checked;
			}
		});
	};

	methods.createColumnSelectList = function(elem) {
		var widget = $(this);
/*        var dtObj = $(this).data('dtObj');
	   if ($(elem).length) {
		}
		else {
			elem = $('#selectFields');
		}
		if (!elem.length) {
		}*/

		//var availableFields = widget.data('md').logFields.availableFields;
/*        var availableFields = dtObj.fnSettings().aoColumns;
		var html ='<div class="selcol1">';
		var d2 = (availableFields.length-1) /2;
		for (var i=0;i<availableFields.length;i++) {
			var tp = "col"+(i%2);
			if (i > d2) {
				html += '</div><div class="selcol2">';
				d2 = 99999999;
			}
			var selected = availableFields[i].bVisible;
			html += '<span class="'+tp+'"><input name="columns" type="checkbox" checked="'+(selected ? "checked" : "")+'" value="'+availableFields[i].sName+'">'+geti18n(availableFields[i].sTitle)+"</span>";
		}
		html  += "</div>";
		$('#selectFields').html(html);*/
		$('#selectFields input').off('change').on('change', function (e) {
			//var cols = $('[name=columns]:checked').map(function() { return $(this).val(); }).get().join(",");
			//widget.trigger('updateColumns', cols);
			var index = $('#selectFields input').index($(this));
			var checked = $(this).is(":checked");
			widget.data('dtObj').fnSetColumnVis(index,checked,true);
		});
		$('#selectFields').dialog({autoOpen: false,
			"title":geti18n("SELECT_COLUMNS"),
			"modal":true
			/*,
			"buttons": [ { text: geti18n("DONE"),
						   click: function() {
							   $(this).dialog("close");
						   }
			}]
			*/
		});
		$('.logs th').unbind('contextmenu').bind('contextmenu', function(e) {
			e.preventDefault();
			methods.populateFields.call(widget,$('#selectFields'));
			$('#selectFields').dialog("option","position",[e.clientX,e.clientY]);
			$('#selectFields').dialog("open");
		});
		localizePage("common",$('#selectColumns'));
	};
	methods.initLogs = function (params) {
		var widget = $(this);
		// now requires facet to run first - could possibly change later
		// now it doesn't...
		widget.off('updateColumns').on('updateColumns', function (e, columns) {
			$('#selectFields:checkbox').prop('checked',false);
			var col = columns.split(',');
			for (var i=0;i<col.length;i++) {
				$('#selectFields [value='+col[i]+']').prop('checked',true);
			}
			methods._initDataTable.call(widget, columns, params);
		});
		var availableFields = widget.data('md').logFields.availableFields;
		if(widget.data("interrupted_log") == 1 && typeof(widget.data('md').logFields1) != "undefined")
		{
			availableFields = widget.data('md').logFields1.availableFields;
		}
		var html ='<div class="selcol1">';
	var d2 = (availableFields.length - 1) / 2;
		for (var i=0;i<availableFields.length;i++) {
		var tp = "col" + (i%2);
		if(i > d2) {
			html += "</div><div class='selcol2'>";
			d2 = 99999999;
		}
		if("CLF_UTCTimeStamp" == availableFields[i])
		{
			html += '<span class="' + tp + '"><input name="columns" disabled="disabled" type="checkbox" value="'+availableFields[i]+'">'+geti18n(availableFields[i])+" ";
		} 
		else if("CLF_CustomURLCategory" == availableFields[i])
		{
			html += '<span class="' + tp + '" style="display:none"><input name="columns" type="checkbox" value="'+availableFields[i]+'">'+geti18n(availableFields[i])+" ";
		}
		else
		{
			html += '<span class="' + tp + '"><input name="columns" type="checkbox" value="'+availableFields[i]+'">'+geti18n(availableFields[i])+" ";
		}
        }
	html += "</div>";
		$('#selectFields').html(html);
		$('#selectFields').off('change').on('change', function (e) {
			var cols = $('[name=columns]:checked').map(function() { return $(this).val(); }).get().join(",");
			widget.trigger('updateColumns', cols);
		});
		if (params && params.column) {
			widget.trigger('updateColumns',params.column+'');
		}
		else {
			if(widget.data("interrupted_log") != 1 || typeof(widget.data('md').logFields1) == "undefined")
			{
				widget.trigger('updateColumns',widget.data('md').logFields.defaultFields+'');
			}
			else
			{
				widget.trigger('updateColumns',widget.data('md').logFields1.defaultFields+'');
			}
		}

	methods.createColumnSelectList.call(widget);
	};


	methods._initDataTable = function (columns, initparams) {
		var widget = $(this);
		initparams = initparams || {};
		var params = $.extend(true,{},widget.data('initParams').params, initparams);
		params.filters = params.filters || {};
	if (params.cols && params.cols.c) {

			columns = params.cols.c;
		}
		if (widget.data('md').logCategory) {
			if (!params.filters.hasOwnProperty("CLF_MsgType")) {
				params.filters.CLF_MsgType = [];
				params.filters.CLF_MsgType = params.filters.CLF_MsgType.concat(widget.data('md').logCategory);
			}

		}
		params.column = columns;

		//var dataColumns = methods.getDataColumns(columns);

		var restObject = methods.getRestObject.call(widget, params, "query");
		var pdfConfig = widget.data('pdfConfig') || {};
		pdfConfig.logPageQueryParam = restObject;
		pdfConfig.logPageQueryParam.query.reportTemplate = widget.data('md').facetConfig.reportTemplate + '';
		widget.data('pdfConfig', pdfConfig);
		if (widget.data('dtObj')) {
			var dtObj = widget.data('dtObj');
			dtObj.fnDestroy();
			// dataTables dorks on a style, so we remove it
			$('.logs table', widget).removeAttr('style');
			dtObj = null;
			$('.logs table', widget).empty();
		}
		$.fn.dataTableExt.sErrMode = 'throw';
		var logs = $('.logs table', widget);
	var l1width = $('#line1').innerWidth() || '95%';
		// if we have a larger table width, use it
		if (params.cols && params.cols.w) {
			var width2 = 0;
			$.map(params.cols.w.split(), function() {width2 += this;});
			if (width2 > l1width ) {
				l1width = width2;
			}
		}
		var dataColumns = methods.getDataColumns(columns, params.cols);


		logs.width(l1width);
		var oTable = logs.dataTable({
			"oLanguage": {
				"sProcessing":geti18n("LOADING","DATATABLES"),
				"sLoadingRecords":geti18n("LOADING","DATATABLES"),
				"oPaginate": {
					"sPrevious": geti18n("PREVIOUS","DATATABLES"),
					"sNext":geti18n("NEXT","DATATABLES")
				},
				"sInfoEmpty":geti18n("NODATA","DATATABLES"),
				"sLengthMenu":"_MENU_ "+geti18n("PERPAGE","DATATABLES")
			},
		//"bAutoWidth":false,
			"bInfo": false,
			"aoColumns": dataColumns,
			"bProcessing": true,
			"bFilter": false,
			"bSort": false,
		// "sDom": "RClfrpti",
			"sDom": "Rlfrtip",
			"iDisplayLength": (params.rows !== undefined) ? params.rows : 20,
			"aLengthMenu": [[1, 20, 50, 100, 500],[1,20,50,100,500]],
			"bServerSide": true,
			"sAjaxSource": "../../rest/commonlog/log_page_query",
			"sServerMethod": "POST",
			"fnServerData": function (sSource, aoData, fnCallback, oSettings) {

				restObject = methods.updateLogQueryParams.call(widget, restObject, aoData);
				oSettings.jqXHR = $.ajax({
					"dataType": 'json',
					"type": "POST",
					"url": sSource,
					"data": JSON.stringify(restObject),
					"success": function (ajaxData) {
						if(ajaxData.err_code == undefined) {
							// somewhere in here we need to do localization
							var newData = [];
							for(var i = 0; i < ajaxData.results.length; i++) {
								var r = ajaxData.results[i];
								newData[i] = {};
								for(var j = 0; j < r.length; j++) {
									newData[i][dataColumns[j].mData] = r[j];
								}
							}
							widget.data('cursor', ajaxData.cursor);
							var ddResults = {
								"sEcho": aoData[0].value - 0,
								"iTotalRecords": 9999999,
								"iTotalDisplayRecords": 9999999,
								"aaData": newData
							};

							if(restObject.paging.limit && (restObject.paging.limit > newData.length)) {
								ddResults.iTotalRecords = newData.length + restObject.paging.limit * restObject.paging.skip;
								ddResults.iTotalDisplayRecords = ddResults.iTotalRecords;
							}
							fnCallback(ddResults);
							$('th', logs).each(function(a, b) {
								$(this).width($(this).width());
							});
						} else {
							switch(ajaxData.err_code) {
								case 'timeout':
									alert(i18n_dashboard_settings_log_query_timeout);
									break;
								case 'dupreq':
									alert(i18n_dashboard_settings_dup_request);
									break;
							}
							var ddResults = {
								"sEcho": aoData[0].value - 0,
								"iTotalRecords": 9999999,
								"iTotalDisplayRecords": 9999999,
								"aaData": {}
							};
							fnCallback(ddResults);
						}
					},
					"error": function(err) {
						console.log(err);
					}
				});
			},
			"fnServerParams": function (aoData) {
				aoData.push({
					"name": "more_data",
					"value": "my_value"
				});
			},
		// set the tooltip to equal the header
			"fnHeaderCallback": function( nHead, aData, iStart, iEnd, aiDisplay ) {
			  $('th',nHead).each( function() {
				  $(this).attr('title',$(this).text());
			  });
		}
		});

 $('#selectFields').dialog({autoOpen: false,
			"title":geti18n("SELECT_COLUMNS"),
			"modal":true
			/*,
			"buttons": [ { text: geti18n("DONE"),
						   click: function() {
							   $(this).dialog("close");
						   }
			}]
			*/
		});
		widget.data('dtObj', oTable);
 	//remove custom url category
        for ( cl in widget.data('dtObj').fnSettings().aoColumns)
        { 
            if ("CLF_CustomURLCategory" == widget.data('dtObj').fnSettings().aoColumns[cl].sName)
            {
                widget.data('dtObj').fnSetColumnVis(cl, false, true);
            }
        }
	/* $('.logs th').unbind('contextmenu').bind('contextmenu', function(e) {
			e.preventDefault();
			$('#selectFields').dialog("option","position",[e.clientX,e.clientY]);
			$('#selectFields').dialog("open");
		});*/
		$('.logs th').unbind('dblclick').bind('dblclick', function(e) {
			var dtObj = widget.data('dtObj');
			e.preventDefault();
			var tableWidth = $('.logs table').width();
			var aoColumns = dtObj.fnSettings().aoColumns;

			var realWidths = $.map($('.logs table.display th'), function(l) {return $(l).width();});
			var index = $(this).parent().find('th').index($(this));

			var newWidth;
			if ($(this).hasClass('maxwidth')) {
				newWidth = tableWidth / ($('.logs table th').length - 1);
				$(this).removeClass('maxwidth');
			}

			else {
				$('.logs table').css('table-layout',"auto");
				newWidth = $('.logs table.display th').eq(index).width();
				$(this).addClass("maxwidth");
			}

			var newTableWidth = tableWidth + newWidth - parseInt(realWidths[index],10);

			$('.logs table').width(newTableWidth);
			$('.logs table').css('table-layout',"fixed");
			$(this).width(newWidth);

			aoColumns[index].sWidth = newWidth+"px";




		});
		localizePage("common",$('#selectColumns'));
	};


	/*
	 *
	 * Support Methods
	 *
	 */

	// Given an object of form {"key":"val"}
	// returns an array of filters in the way used by the log query webservices
	methods.translateFilters = function (filters) {
		// If its an array, we don't need to translate
		if ($.isArray(filters)) {
			return filters;
		}
		var newFilters = [];
		for (var f in filters) {
			if (filters.hasOwnProperty(f)) {
				var op = 'eq';
				// hardcode string compare fields
				if (f == 'CLF_MsgType') {
					op = '==';
				}
				newFilters.push({
					"col": f,
					"op": op,
					"value": filters[f]
				});
			}
		}
		return newFilters;
	};
	// Get appropriate filter string
	// Does mapping for custom/url categories
	methods.getFilter = function (key, val) {
		var filters = {};
		if (!key) {
			return '';
		}
		// hmmm... fixes deep drill issue. Why?
		if (!val) {
			return '';
		}
		key = key.replace(/^LABEL./, '');
		if (key == '_categoryMap') {
			if (val[2] === 0) {
				key = "CLF_URLCategory";
			} else {
				key = "CLF_CustomURLCategory";
			}
		}
		filters[key] = val[0];
		//var filters = methods.translateFilters({key:val[0]});
		return JSON.stringify(filters);
	};

	// Formats
	// 1minute, 1hour, 1day, 1week -> 1 minute, hour, day or week ago
	// Any number can be used (543minute)
	// today -> 24 hours starting at midnight
	// yesterday -> previous 24 hours starting at midnight
	// If timestamp is passed that is used as "now" otherwise current time
	methods.calculateTimeRange = function (range, now) {
		var times = {
			start: 0,
			end: now
		};
		var ranges = range.split(",");
		if (ranges.length == 2) {
			times.start = ranges[0] - 0;
			times.end = ranges[1] - 0;
			times.range = 0;
		} else {

			var timeRanges = {
				"second": 1000,
				"minute": 1000 * 60,
				"hour": 1000 * 60 * 60,
				"day": 1000 * 60 * 60 * 24,
				"week": 1000 * 60 * 60 * 24 * 7
			};
			timeRanges.D = timeRanges.day;
			timeRanges.H = timeRanges.hour;

			if (!now) {
				now = +new Date();
				times.end = now;
			}
			if (!range) {
				return times;
			}
			if (range == "TODAY") {
				var start = new Date();
				start.setHours(0, 0, 0, 0);
				times.start = +start;
				times.end = +start + timeRanges.day;
			} else if (range == "YESTERDAY") {
				var end = new Date();
				end.setHours(0, 0, 0, 0);
				times.start = +end - timeRanges.day;
				times.end = +end;
			} else {
				var matches = range.match(/(\d+)(.*?)s*$/);
				if (matches.length == 3) {
					if (timeRanges.hasOwnProperty(matches[2])) {
						times.start = now - (matches[1] * timeRanges[matches[2]]);
						times.end = now;
					}
				}
			}
			// Hack for demo
			// times.start = 0;
			// end hack

			times.range = range;
		}
		times.unixstart = Math.floor(times.start / 1000);
		times.unixend = Math.floor(times.end / 1000);
	var lts = new Date(times.start);

	var lte = new Date(times.end);
	var cts = new timezoneJS.Date(lts.getFullYear(),lts.getMonth(),lts.getDate(),lts.getHours(),currentTimeZone);
	var cte = new timezoneJS.Date(lte.getFullYear(),lte.getMonth(),lte.getDate(),lte.getHours(),currentTimeZone);

		//times.serverunixstart = Math.floor(new timezoneJS.Date(times.start,currentTimeZone) / 1000);
	times.serverunixstart = Math.floor(cts / 1000);
		//times.serverunixend = Math.floor(new timezoneJS.Date(times.end,currentTimeZone) / 1000);
	times.serverunixend = Math.floor(cte / 1000);
		//times.serverunixstart = Math.floor(new Date(times.start) / 1000);
		//times.serverunixend = Math.floor(new Date(times.end) / 1000);


		return times;
	};



	// Get the localized text from an id for charts
	// With special handling for custom/ predefined category
	// also replace underscores with spaces
	methods.getCategoryName = function (data, i18nCat) {
		if (!$.isArray(data)) {
			data = [data, null];
		}
		if (!i18nCat) {
			i18nCat = "common";
		}
		// Custom categories - return string
		if (data[2] == 1) {
			//return data[0].replace(/_/g,'_');
			return data[0];
		} else {
		var localized;
		switch(i18nCat) {
			case 'CLF_URLCategory':
			case 'CLF_AppID':
			case 'CLF_Action':
			case 'CLF_MsgType':
			case 'CLF_Fields':
				localized = dy_geti18n(data[0], i18nCat);
				break;
			default:
				localized = geti18n(data[0], i18nCat);
				localized = localized.replace(/_/g, '_');
		}

		return localized;
			// some possible mappings
		   /* if (i18nCat == 'CLF_URLCategory') {
				i18nCat = 'URLCategories';
			}
			if (i18nCat == 'CLF_AppID') {
				i18nCat = 'appcats';
			}
			if (i18nCat == 'CLF_Action') {
				i18nCat = 'CLF_Action';
			}
			if (i18nCat == 'CLF_MsgType') {
				i18nCat = 'CLF_MsgType';
			}
			var localized = geti18n(data[0], i18nCat);
			localized = localized.replace(/_/g, '_');
			return localized;*/
		}
	};
	// get a parameter from the query string
	methods._getParam = function (name,qs) {
		var i, u, v, n;
		var r = [];
		if (!qs) {
			qs = window.location.search.substring(1);
		}
		else if (qs[0] == '?') {
			qs = qs.substring(1);
		}
		v = qs.split('&');
		for (i = 0; i < v.length; i++) {
			n = v[i].split('=');
			if (n[0] == name) {
				r.push(decodeURIComponent(n[1]));
			}
		}
		return r;
	};

	/* Manage get parameters */
	var paramString = function (p) {
		this.string = '';
	};

	paramString.prototype.add = function (k, v, urlencode) {
		if (!k) {
			return this.string;
		}
		if (v === undefined || v === '' || v === null) {
			return this.string;
		}
		v += '';
		k += '';
		if (this.string) {
			this.string += "&";
		}
		k = k.replace(/\W/g, '');
		if (urlencode) {
			v = encodeURIComponent(v);
		} else {
			v = v.replace(/\W/g, '');
		}
		this.string += k + '=' + v;
		return this.string;
	};
	paramString.prototype.toString = function () {
		return this.string;
	};


	methods.initDatePicker = function (opts, timeRange) {
		if (!opts || !$.isArray(opts)) {
			opts = ['L1H', 'L12H', 'TODAY', 'L1D', 'L7D'];
		}
		var customTimePeriod = {};

		for (var i = 0; i < opts.length; i++) {
			if ($.isPlainObject(opts[i])) {
				if (opts[i]['default']) {
					//$('#duration').val(opts[i]['default']);
					if (!timeRange) {
						timeRange = opts[i]['default'];
					}
				}
				continue;
			}
			customTimePeriod[opts[i]] = geti18n(opts[i]);
		}


		$('#duration-picker').empty().enhanced_datetimepicker({
			"useLocalTimeZome": true,
			"show_customized_label": true,
			"customized_time_period": customTimePeriod,
			"customized_value": "0",
			"customized_label": "Customized time range",
			"range_start_label": "From: ",
			"range_start_format": "mm/dd HH:MM",
			"range_end_format": "mm/dd",
			"range_end_label": "To: ",
			"form_period": "#duration",
			"form_from": "#json-report-from",
			"form_to": "#json-report-to"
		});

		if (timeRange) {
			var tr = methods.calculateTimeRange(timeRange);
			$('#duration').val(tr.range);
			$('#json-report-from').val(tr.unixstart);
			$('#json-report-to').val(tr.unixend);

		}
		$("#duration-picker").enhanced_datetimepicker("set_values", {
			"form_period": "#duration",
			"form_from": "#json-report-from",
			"form_to": "#json-report-to"
		});
	};
	methods.setOptions = function (opts, defaultValue, defaultName) {
		var optionElem = $(this);
		optionElem.empty();
		var html = '';
		var i;
		var selected;
		var foundSelected = false;
		for (i = 0; i < opts.length; i++) {
			if (!defaultValue && $.isPlainObject(opts[i]) && opts[i].hasOwnProperty('default')) {
				defaultValue = opts[i]['default'];
				continue;
			}
			selected = (opts[i] == defaultValue) ? ' selected="selected" ' : '';
			html += '<option value="' + opts[i] + '"' + selected + '>' + geti18n(opts[i]) + '</option>';
			if (selected) {
				foundSelected = true;
			}
		}
		if (!foundSelected && defaultValue) {
			html += '<option value="' + defaultValue + '" selected="selected" >' + geti18n(defaultName) + '</option>';
		}
		optionElem.html(html);
		return optionElem;
	};

	methods.jQObjFromSelector = function (sel) {
		if ($('#' + sel).length) {
			return $('#' + sel);
		} else {
			return $(sel);
		}
	};

	methods.getSelector = function (sel) {
		// selector can be a jquery selector, jquery object or id
		var id = 1;
		var selector = null;
		if (typeof sel == 'string') {
			selector = $(sel);
			if (selector.length === 0) {
				selector = $('#' + sel);
			}
		} else {
			selector = sel;
		}
		if (selector instanceof jQuery) {
			if (selector.length === 0) {
				return null;
			} else {
				selector = selector[0];
			}
		} else if (selector instanceof HTMLElement) {
			// html element is fine for highcharts
		} else {
			// not a jQuery selector or dom element...  return null
			return null;
		}

		// In the end we decide to force it to id
		if (!$(selector).attr('id')) {
			if ($(document).data('counter')) {
				id = $(document).data('counter') + 1;
			}
			$(document).data('counter', id);
			$(selector).attr('id', 'widgetChartNum' + id);
		}
		selector = $(selector).attr('id');
		$(selector).text("This is some fun stuff");
		return selector;
	};



	methods.tooltip = function (key, val, format) {
		var data = [key, val];
		data = methods.format([data], format);
		var formatted = '<b>' + data[0][0] + '</b>: ' + ' ' + data[0][1];
		return formatted;
	};

	methods.format = function (data, formatter) {
		var formatters = {
			"KB": function (arr) {
				var ID = "KB";
				arr[1] = arr[1] / 1024;
				if (arr[1] >= 1024) {
					arr[1] = arr[1] / 1024;
					ID = "MB";
				}
				if (arr[1] >= 1024) {
					arr[1] = arr[1] / 1024;
					ID = "GB";
				}
				arr[1] = Math.round(arr[1] * 100) / 100;
				arr[1] += ID;
				return arr;
			}
		};
		if (!formatters[formatter]) {
			return data;
		}
		for (var i = 0; i < data.length; i++) {
			data[i] = formatters[formatter](data[i]);
		}
		return data;

	};

	methods._dateTransformSeries = function (d) {
		var data = [];
		var k;
		var min = -1;
		var max = -1;
		for (k in d) {
			if (d.hasOwnProperty(k)) {
				var val = d[k] - 0;
				if (min == -1) {
					min = val;
				}
				if (max == -1) {
					max = val;
				}
				if (val < min) {
					min = val;
				}
				if (val > max) {
					max = val;
				}
				data.push([(k - 0) * 1000, val]);

			}
		}

		data.sort( function(a, b) {
			return a[0]-b[0];
		});

		return {
			data: data,
			min: min,
			max: max
		};

	};


	methods.dynamicTimeChart = function (params) {
		var widget = $(this);
		var md = widget.data('md');
		var restObject = methods.getRestObject.call(widget, params);

		var rt = md.dataConfig.reportTemplate + '';
		rt = rt.replace(/^lc_/, 'lc_ts_');
		restObject.reportParam.reportTemplate = rt;
		var restText = JSON.stringify(restObject);

		$.ajax({
			url: "../../rest/commonlog/report_query",
			dataType: "json",
		async: false,
			type: "POST",
			data: restText,
			success: function (data) {
				methods.drawChart.call(widget, "line", data, params);
			},
			error: function (a, b, c) {
				methods.drawChart.call(widget, null, null);
			}
		});
		/*
		console.log('MD',md);
		var csvParamsText = $('#csvParams').val();
		console.log("CSVP:",csvParamsText);
		var csvParams = JSON.parse(csvParamsText);
		//csvParams.column = $('.groupby').attr('data-key');
		csvParams.column = 'CLF_UTCTimeStamp';
		var timeStart = csvParams.query.timeBegin-0;
		console.log("timeStart:",timeStart);
		var range = csvParams.query.timeEnd - timeStart;
		var bucketCount = 50;
		var bucketSize = range/bucketCount;
		csvParamsText = JSON.stringify(csvParams);
		console.log("CSVP:",csvParamsText);
		var csvQuery = encodeURIComponent(JSON.stringify(csvParams));
		console.log("CSVPQ:",csvQuery);
		var ajaxData = 'data='+csvQuery;
			$.ajax({
				url : "../../rest/commonlog/log_export_csv",
				dataType : "text",
				processData: false,
				type : "POST",
				data : ajaxData,
				success : function(data) {
					var lines = data.split('\n');
					// assume it is in time order
					var buckets = [];
					for (var i=2;i<lines.length;i++) {
						var time = lines[i]-0;
						var bucket = Math.floor((time-timeStart)/bucketSize);
						if (!buckets[bucket]) {
							buckets[bucket] = 1;
						}
						else {
							buckets[bucket] = buckets[bucket] + 1;
						}
					}
					// We could draw a line chart here - if we have decent values in the buckets

				},
				error : function(a, b, c) {
					console.log("ERROR:", a, b, c);
				}
			});
			*/
	};

	// Display a modal loader - 1 to turn off, 0 to turn on
	methods.loader = function (m, elem) {
		if (!elem) {
			elem = $('body');
			$('#loader').parent().css('opacity', 1);
		} else {
			if (m) {
				elem.css('opacity', 1);
			}
		}


		if (!m) {
			$(".loader",elem).remove();
			elem.append('<div class="loader"><img src="/lib/tmPlugins/images/ajax-loader.gif" /></div>');
			elem.css('opacity', 0.5);
			$("#loader").show().css({
				"height": elem.height(),
				position: "absolute",
				"text-align": "center",
				opacity: 1,
				"width": elem.width()
			});
		} else {
			$(".loader",elem).remove();
		}
	};

	methods.formatTime = function (timestamp) {
		var dt = new Date(timestamp);
		return new Date(timestamp).toLocaleString();
	};


	// INITIALIZE the DASHBOARD PAGE

	methods.initDashboard = function (elem) {
		if (!elem) {
			elem = $(this);
		}
		var csrf = methods._getParam('CSRFGuardToken',parent.document.location.search);
		var dashboard = elem.dashboard({
			layoutClass: 'layout',
			json_data: {
				url: "../../change_status.jsp",
				"initial": "jsonfeed/allwidgets.json",
				"defaultWidgets": "jsonfeed/defaultwidgets.json"
			},
			stateChangeUrl: "../../change_status.jsp?CSRFGuardToken="+csrf,
			addWidgetSettings: {
				widgetDirectoryUrl: "jsonfeed/widgetcategories.json"
			},
			layouts: [{
				title: "Layout2",
				id: "layout2",
				image: "layouts/layout2.png",
				html: '<div class="layout layout-aa"><div class="column first column-first"></div><div class="column second column-second"></div></div>',
				classname: 'layout-aa'
			}]

		});
		localizePage("dashboard");

		// binding for a widgets is added to the dashboard
		$(document).on('dashboardAddWidget', dashboard.element, function (e, obj) {
			localizePage("dashboard");
			dashboard.addWidget(obj.widget, dashboard.element.find('.column.' + obj.widget.column));
		});

		$(document).on('widgetDeleted', '.widget', function (e, obj) {
			var data = obj.data;
			if (data.hasOwnProperty('refreshId')) {
				clearTimeout(data.refreshId);
			}
			if (data.highchartsObj) {
				data.highchartsObj.destroy();
			}
		});

		// load the widget content from metadata after the widget is loaded
		$(document).on('widgetLoaded', '.widget', function (e, o) {
			// l10n it
			localizePage("dashboard");
			var iww = $(this).find('.iws_common_widget');
			if (iww.length) {
				$(iww).closest('.widget').dashboardSettings('initWidget', o.widget.metadata);
			} else {}
		});
		$(document).on('widgetOpenFullScreen', '.widget', function(e,o) {
			var iww = $(this).find('.iws_common_widget');
			if (iww.length) {
				$(iww).closest('.widget').dashboardSettings('updateChart', {});
			}
		});
		$(document).on('widgetCloseFullScreen', '.widget', function(e,o) {
			var iww = $(this).find('.iws_common_widget');
			if (iww.length) {
				$(iww).closest('.widget').dashboardSettings('updateChart', {});
			}

		});
		dashboard.init();
	};

methods.initCCCWidget = function() {
	var widget = $(this);
	var init_status;
	methods.getSessionFlag.call(widget);
	var session_flag = widget.data("session_flag");
	$.ajax({
		url:"../page/jsonfeed/mywidgets_charts_ccca.json",
		type:"GET",
		dataType: "json",
		async: false,
		success: function(data) {
			init_status = data;
		},
		error: function(err) {
			console.log(err);
		}
	});

	$("#ccc").prev().find(".duration").val(init_status.default_setting_for_ccca.default_period);
	// init group information
	var group_info = methods.deviceGroup;
	var text = '';
	for(var i = 0; i < group_info.length; i++) {
		text += '<option value="' + group_info[i].GroupName + '">' + group_info[i].GroupName + "</option>"
	}
	$("#ccc").prev().find(".group").append(text);
	var cccid = null;
	$('#ccc').unbind('updateccc').bind("updateccc", function () {
		if (cccid) {
		   clearTimeout(cccid);
			cccid = null;
		}
		var restObject = $('#ccc').closest('.iws_common_widget').dashboardSettings('getRestObject', {}, "query");
		var group_devices = methods.getGroupDevice.call(widget);
		restObject.paging = {
			"skip": 0,
			"limit": 200
		};
		restObject.query.filters = [{
			"col": "CLF_MsgType",
			"value": 851969,
			"op": "=="
		}];
		if(group_devices) {
			var group_filter = {};
			group_filter.col = "CLF_DeviceName";
			group_filter.op = "eq";
			group_filter.value = group_devices;
			restObject.query.filters.push(group_filter);
		}
		restObject.column = "CLF_UTCTimeStamp,CLF_RiskLevel,CLF_UserName,CLF_ClientIP,CLF_Action";
	restObject.query.reportTemplate = "facet_internet_security";
		$.ajax({
			"url": "../../rest/commonlog/dashboard_query/dash_ccca",
			"data": JSON.stringify(restObject),
			"type": "POST",
			"dataType": "json",
			success: function (data) {
				 $('.widgetheader .timestamp',widget).remove();
					//var timestamp = methods.formatTime(+new Date());
					//var timestamp = new Date().toLocaleTimeString();
					var dt = +new Date();
					var lt = new timezoneJS.Date(dt,currentTimeZone);
					var timestamp = lt.toString('HH:mm:ss');
					$('.widgetheader',widget).append("<span class='timestamp'>"+timestamp+"</span>");

				var l = data.results;
				var html = "";
				for (var i = 0; i < l.length; i++) {
					var r = l[i];
					html += "<tr>";
					var d = new Date(r[0] * 1000);
					var q = (d.getMonth() + 1) + "-" + (d.getDate());
					html += "<td class=\"ccca_time\">" + q + ' ' + d.getHours() + ":" + (d.getMinutes() < 10 ? "0" : '') + d.getMinutes() + "</td>";

					html += "<td class=\"ccca_risk_level\">" + geti18n(r[1], "CLF_RiskLevel") + "</td>";
					//for (var j = 2; j < 4; j++) {
					//    html += "<td>" + r[j] + "</td>";
					//}
					html += "<td class=\"ccca_user_name\">" + r[2] + "</td>";
					html += "<td class=\"ccca_client_ip\">" + r[3] + "</td>";
					html += "<td class=\"ccca_action\" clf_action=\"" + r[4] + "\">" + geti18n(r[4], "CLF_Action") + "</td>";
					html += "</tr>";
				}
				cccid = setTimeout(function () {
					$('#ccc').trigger('updateccc');
				}, 60000);
				$('#ccc tbody').html(html);
				$('#ccc').closest('.iws_common_widget').css("opacity", 1);

				var f_duration = $("#ccc").prev().find("option:selected").val();


				$(".ccca_time").each(function() {
					$(this).click(function() {
						if(session_flag != 0)
						{
							window.location.href = 'facet.html?did=internet_security&d=' + f_duration + '&f={"CLF_MsgType":"851969"}';
						}
						else
						{
							window.location.href = '#';
						}
					});
				});
				$(".ccca_risk_level").each(function() {
					$(this).click(function() {
						if(session_flag != 0)
						{
							window.location.href = 'facet.html?did=internet_security&d=' + f_duration + '&f={"CLF_MsgType":"851969"}';
						}
						else
						{
							window.location.href = '#';
						}
					});
				});
				$(".ccca_user_name").each(function() {
					$(this).click(function() {
						if(session_flag != 0)
						{
							var f_user_name = $(this).html();
							window.location.href = 'facet.html?did=internet_security&d=' + f_duration + '&f={"CLF_MsgType":"851969", "CLF_UserName":"' + f_user_name  +'"}';
						}
						else
						{
							window.location.href = '#';
						}
					});
				});
				$(".ccca_client_ip").each(function() {
					$(this).click(function() {
						if(session_flag != 0)
						{
							var f_client_ip = $(this).html();
							window.location.href = 'facet.html?did=internet_security&d=' + f_duration + 'f={"CLF_MsgType":"851969", "CLF_ClientIP":"' + f_client_ip  +'"}';
						}
						else
						{
							window.location.href = '#';
						}
					});
				});
				$(".ccca_action").each(function() {
					$(this).click(function() {
						if(session_flag != 0)
						{
							var f_action = $(this).attr("clf_action");
							window.location.href = 'facet.html?did=internet_security&d=' + f_duration + '&f={"CLF_MsgType":"851969", "CLF_Action":"' + f_action  +'"}';
						}
						else
						{
							window.location.href = '#';
						}
					});

				});
			},
			error: function (a, b, c) {
				cccid = setTimeout(function () {
					$('#ccc').trigger('updateccc');
				}, 60000);
				//console.log("ERROR:", a, b, c);
			}
		});
	});

	$('#ccc').trigger('updateccc');
	$('#ccc').off('click').on('click', function () {
		if(session_flag != 0)
		{
			window.location.href = 'facet.html?did=internet_security&f={"CLF_MsgType":"851969"}';
		}
		else
		{
			window.location.href = '#';
		}

	});
	//Nico add the change status logic here.
	$('#ccc').closest('.iws_common_widget').off('change').on('change', '.duration', function () {
		var request = {"period": $("#ccc").prev().find(".duration").val()};
		init_status.default_setting_for_ccca.default_period = $("#ccc").prev().find(".duration").val();
		var csrf = methods._getParam('CSRFGuardToken',parent.document.location.search);
		$.ajax({
			url: "../../change_status_ccca.jsp?CSRFGuardToken=" + csrf,
			type: "POST",
			async: false,
			data: {settings: JSON.stringify(init_status)},
			error: function(err) {
				console.log(err);
			}
		});
		$('#ccc').trigger('updateccc');
	}).on('change', '.group', function() {
		$('#ccc').trigger('updateccc');
	});

};



	$.fn.dashboardSettings = function (method) {
		if (methods[method]) {
			return methods[method].apply(this, Array.prototype.slice.call(
			arguments, 1));
		} else {
			$.error('Method ' + method + ' does not exist on jQuery.dashboardSettings');
		}
	};


})(jQuery);

