#!/usr/bin/python
#coding:UTF-8

import os, sys
import shutil
import time
import codecs
import re
import ConfigParser
from mig_python_logger import logger

separator = r'(?<!\\),'
bandwith_policy_id = 0
url_filter_default_policy_id = 0
url_filter_guest_policy_id =0
url_filter_policy_id_list=[]

def open_file(file_name, flag):
	if not os.path.exists(file_name):
		logger.error("file not exit: " + file_name)
		return None
	real_encoding = None
	encodings = ('utf-16', 'utf-8', 'gb2312')
	for encoding in encodings:
		fd = codecs.open(file_name, flag, encoding)
		try:
			fd.readline()
		except UnicodeError:
			fd.close()
		else:
			real_encoding = encoding
			fd.close()
			break
	if not real_encoding:
		logger.error("what's the file encoding? i cannot figure out")
		return None
	fd = codecs.open(file_name, flag, real_encoding)
	return fd, real_encoding


def handle_rule(src_file, dst_file):
	logger.debug("in [handle_tb_rule] handle file: " + src_file)

	src_fd,coding = open_file(src_file, "r")
	dst_fd = codecs.open(dst_file, "w", coding)

	line = src_fd.readline()
	policyid = 0
	while line:
		elements = re.split(separator,line)
		policyid = max(int(elements[0]), policyid)
		line = line.replace("wrs_ctx_enable=yes","wrs_ctx_enable=no")
		if (int(elements[1]) == url_filter_default_policy_id) or (int(elements[1]) == url_filter_guest_policy_id):
			print elements
			l = list(elements[4])
			print l
			l[118] = '1'
			elements[4] = ''.join(l)
			line = ','.join(elements)

		dst_fd.write(line)
		line = src_fd.readline()

	if bandwith_policy_id != 0:
		policyid = policyid + 1
		line_add = str(policyid)+','+str(bandwith_policy_id)+",-1,247,bandwidthcontrol=\n"
		dst_fd.write(line_add)
		line_add = str(policyid+1)+','+str(bandwith_policy_id+1)+",-1,247,bandwidthcontrol=\n"
		dst_fd.write(line_add)

	src_fd.close()
	dst_fd.close()

def handle_policy(src_file, dst_file):
	logger.debug("in [handle_tb_policy] handle file: "+src_file)
	dst_fd,coding = open_file(dst_file, "r")
	line = dst_fd.readline()
	line_add = []
	while line:
		elements = re.split(separator,line)
		if elements[2] == "13":
			line_add.append(line)
		line = dst_fd.readline()
	dst_fd.close()

	src_fd,coding = open_file(src_file, "r")
	dst_fd = codecs.open(dst_file, "w", coding)

	line = src_fd.readline()
	policyid = 0


	
	global url_filter_default_policy_id
	global url_filter_policy_id_list
	global url_filter_guest_policy_id

	while line:
		elements = re.split(separator,line)
		policyid = max(int(elements[0]), policyid)
		if int(elements[2]) == 1 and int(elements[4]) == 1:
			url_filter_default_policy_id = int(elements[0])  
		if int(elements[2]) == 1:
			url_filter_policy_id_list.append(int(elements[0]))
		dst_fd.write(line)
		line = src_fd.readline()

	tb_prioritylist_dirname = os.path.dirname(src_file)
	tb_prioritylist_src_file = os.path.join(tb_prioritylist_dirname, "tb_prioritylist.csv")
	prioritylist_src_fd,coding = open_file(tb_prioritylist_src_file, "r")
	line=prioritylist_src_fd.readline()
	while line:
		elements = re.split(separator,line)
		if int(elements[0]) == 1 and int(elements[1]) in url_filter_policy_id_list:
			url_filter_guest_policy_id = int(elements[1])
			break
		line=prioritylist_src_fd.readline()

			

	policyid = policyid + 1
	global bandwith_policy_id
	bandwith_policy_id = policyid
	for i in range(0,len(line_add)):
		elements = re.split(separator,line_add[i])
		elements[0] = str(policyid)
		policyid = policyid + 1
		dst_fd.write(','.join(elements))

	src_fd.close()
	dst_fd.close()
	prioritylist_src_fd.close()

def handle_role(src_file, dst_file):
	logger.debug("in [handle_tb_role] handle file: "+src_file)
	src_fd,coding = open_file(src_file, "r")
	dst_fd = codecs.open(dst_file, "w", coding)
	line = src_fd.readline()
	while line:
		elements = re.split(separator,line)
		if elements[1] == "Administrator":
			elements[4] = elements[4] + "11:3;"
		elif elements[1] == "Auditor":
			elements[4] = elements[4] + "11:1;"
		dst_fd.write(','.join(elements))
		line = src_fd.readline()

	src_fd.close()
	dst_fd.close()

def handle_prioritylist(src_file, dst_file):
	logger.debug("in [handle_tb_prioritylist] handle file: "+src_file)
	src_fd,coding = open_file(src_file, "r")
	dst_fd = codecs.open(dst_file, "w", coding)
	line = src_fd.readline()
	while line:
		dst_fd.write(line)
		line = src_fd.readline()

	line="1,"+str(bandwith_policy_id+1)+",-1\n"
	dst_fd.write(line)

	src_fd.close()
	dst_fd.close()

if __name__ == "__main__":

	if len(sys.argv) < 3:
		print "Usage: " + sys.argv[0]+ " src_tb_rule.csv dst_tb_rule.csv"
		logger.error(sys.argv[0] + ": Missing the parameter")
		sys.exit(1)
	else:
		src_rule_file = sys.argv[1]
		dst_rule_file = sys.argv[2]

		src_dirname = os.path.dirname(sys.argv[1])
		dst_dirname = os.path.dirname(sys.argv[2])

		src_policy_file = os.path.join(src_dirname, "tb_policy.csv")
		dst_policy_file = os.path.join(dst_dirname, "tb_policy.csv")
		if not os.path.exists(src_policy_file):
			logger.error('Execute [db_table_convert] not find the file:' + src_policy_file)
		else:
			logger.debug('entry into [b_table_convert_6.5sp1_to_6.5sp2.py] ... ...')
			tmp_file = dst_policy_file + ".backup"
			shutil.copy2(dst_policy_file,tmp_file)
			handle_policy(src_policy_file, tmp_file)
			shutil.copy2(tmp_file, dst_policy_file)

		src_rule_file = os.path.join(src_dirname, "tb_rule.csv")
		dst_rule_file = os.path.join(dst_dirname, "tb_rule.csv")

		if not os.path.exists(src_rule_file):
			logger.error('Execute [db_table_convert] not find the file:' + src_rule_file)
		else:
			logger.debug('entry into [db_table_convert_6.5sp1_to_6.5sp2.py] ... ...')

			#backup origin files that related with policy setting
			shutil.copy2( dst_rule_file, dst_rule_file + ".backup")
			tmp_file = dst_rule_file + ".backup"
			#handle tb_rule
			handle_rule(src_rule_file, tmp_file)

			logger.debug("in [main] copy file: " + src_rule_file + " to file: " + dst_rule_file)
			shutil.copy2(tmp_file, dst_rule_file)

		src_role_file = os.path.join(src_dirname, "tb_role.csv")
		dst_role_file = os.path.join(dst_dirname, "tb_role.csv")

		if not os.path.exists(src_role_file):
			logger.error('Execute [db_table_convert] not find the file:' + src_rule_file)
		else:
			logger.debug('entry into [db_table_convert_6.5sp1_to_6.5sp2.py] ... ...')
			tmp_file = dst_role_file + ".backup"
			shutil.copy2( dst_role_file, tmp_file)
			handle_role(src_role_file, tmp_file)
			shutil.copy2(tmp_file, dst_role_file)

		src_prioritylist_file =  os.path.join(src_dirname, "tb_prioritylist.csv")
		dst_prioritylist_file =  os.path.join(dst_dirname, "tb_prioritylist.csv")

		if not os.path.exists(src_prioritylist_file):
			logger.error('Execute [db_table_convert] not find the file:' + src_prioritylist_file)
		else:
			logger.debug('entry into [db_table_convert_6.5sp1_to_6.5sp2.py] ... ...')
			tmp_file = dst_prioritylist_file + ".backup"
			shutil.copy2(dst_prioritylist_file, tmp_file)
			handle_prioritylist(src_prioritylist_file, tmp_file)
			shutil.copy2(tmp_file, dst_prioritylist_file)
