<%@ page contentType = "text/html; charset=UTF-8" %>
<%@ page import="com.trend.iwss.gui.*" %>
<%@ page import="com.trend.api.administration.*" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<i18n:bundle baseName="iwsvaHttp" id="bundleHttp" />
<i18n:bundle baseName="iwsvaCommon" id="bundleCommon" />

<%

	if(Validation.CheckUser(request,response) != 1) {
		response.sendRedirect("logon.jsp");
		return;
	}

	AdministrationAccount accountinfo = (AdministrationAccount)request.getSession().getAttribute("AccountInfo");
	AdministrationRole roleinfo = null;
	int access = 0;
	if(accountinfo != null) {
		roleinfo = accountinfo.getRole();
		access = roleinfo.getAccessRightByKeyID(401);
		if (access == 0) {
			response.sendRedirect("logon.jsp");
			return;
		}
	} else {
		response.sendRedirect("logon.jsp");
		return;
	}

	response.setHeader("Pragma","no-cache");
	response.setHeader("Cache-Control","no-cache");

%>

<%

	String intscan = IWSSInfo.GetWorkPath() + "intscan.ini";
	IWSSINI intscan_ini = new IWSSINI(intscan);
	String client_ssl_method = "";
	String server_ssl_method = "";
    String keep_client_ssl ="";

	String op = request.getParameter("op");
	if (op != null && op.equals("save")) {
		client_ssl_method = request.getParameter("clientSSLMethod");
		server_ssl_method = request.getParameter("serverSSLMethod");
        keep_client_ssl = request.getParameter("serverSSL");
        
		intscan_ini.SetKeyValue("https-scanning", "client_ssl_method", client_ssl_method);
		intscan_ini.SetKeyValue("https-scanning", "server_ssl_method", server_ssl_method);
        intscan_ini.SetKeyValue("https-scanning", "keep_ssl_version", keep_client_ssl);
		intscan_ini.WriteConfig(intscan);

		if (client_ssl_method.isEmpty()) {
			client_ssl_method = "default method";
		}

		if (server_ssl_method.isEmpty()) {
			server_ssl_method = "default method";
		}
        
		if (keep_client_ssl.isEmpty()) {
			keep_client_ssl = "1";
		}

		String audit_msg = "Client SSL Method set to " + client_ssl_method + "; Server SSL Method set to " + server_ssl_method;
		AuditTrailLogger.getInstance().log(request, audit_msg);

		String action = request.getParameter("daemonaction");
		DaemonAction.TakeAction(Integer.parseInt(action));
	}

	client_ssl_method = intscan_ini.GetKeyValue("https-scanning", "client_ssl_method");
	server_ssl_method = intscan_ini.GetKeyValue("https-scanning", "server_ssl_method");
    keep_client_ssl= intscan_ini.GetKeyValue("https-scanning", "keep_ssl_version");
    if (keep_client_ssl.isEmpty()) {
        keep_client_ssl = "1";
    }

%>

<html>
<head>
<meta HTTP-EQUIV="content-type" CONTENT="text/html; charset=UTF-8">
<title>Trend Micro InterScan Web Security Virtual Appliance</title>

<link href="html/trend-style.css" rel="stylesheet" type="text/css">
<script language="javascript" src="html/func.js"></script>
<script language="javascript" src="html/i18n_warnmsg.js"></script>
<script language="javascript" type="text/javascript" src="html/mouseover_help.js"></script>
<script type="text/javascript" src="html/jquery1.3.2.js"></script>
</head>

<body bgcolor="#FFFFFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
	<form name="saveform" method="post" action="httpsdecrypt_ssl_method.jsp">
		<input type="hidden" name="clientSSLMethod" value="" />
		<input type="hidden" name="serverSSLMethod" value="" />
		<input type="hidden" name="op" value="save" />
		<input type="hidden" name="daemonaction" value="0" />

		<table width="700" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td width="507">
					<table width="507" border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td width="238" class="content-title"><i18n:message bundleRef="bundleHttp" key="https.setting.title" /></td>
							<td width="269" valign="bottom" class="data1">&nbsp; </td>
						</tr>
					</table>
				</td>

				<td width="33" valign="bottom">
					<div align="right"><a href="javascript:openhelpwin('specifying_tls_ssl_methods.htm');">
					<img src="images/question.gif" width="18" height="18" border="0"></a></div>
				</td>
			</tr>

			<tr>
				<td colspan="2" class="hor-dotted-line"><img src="images/1space_cui.gif" alt="" width="1" height="10"></td>
			</tr>
			<tr>
			  <td colspan="2"><img src="images/1space_cui.gif" alt="" width="1" height="10"></td>
			</tr>
		</table>

		<table width="700" border="0" cellspacing="0" cellpadding="0">
			<tr>
		<!-- TABS -->
				<td background="images/tab_background_cui.gif">
					<table cellpadding="0" cellspacing="0" border="0">
						<tr>

							<td><img src="images/tab_inactive1_left_cui.gif" width="11" height="23" alt="" border="0"></td>
							<td background="images/tab_inactive_background_cui.gif" class="tabinactive" valign="top" nowrap>
								<a onMouseOver="this.style.color='#FF0000';" style="COLOR: #000000; TEXT-DECORATION: none" onmouseout="this.style.color='#000000';" href="httpsdecrypt_server_certificate_validation.jsp" ><i18n:message bundleRef="bundleHttp" key="https.setting.server_certificate" /></a>
							</td>
							<td><img src="images/tab_inactive_right_cui.gif" width="23" height="23" alt="" border="0"></td>

							<td><img src="images/tab_inactive2_left_cui.gif" width="11" height="23" alt="" border="0"></td>
							<td valign="top" background="images/tab_inactive_background_cui.gif" class="tabinactive" nowrap>
								<a onMouseOver="this.style.color='#FF0000';" style="COLOR: #000000; TEXT-DECORATION: none" onmouseout="this.style.color='#000000';" href="httpsdecrypt_client_certificate_handling.jsp" ><i18n:message bundleRef="bundleHttp" key="https.setting.client_certificate" /></a>
							</td>
							<td><img src="images/tab_inactive_right_cui.gif" width="23" height="23" alt="" border="0"></td>

							<td><img src="images/tab_inactive2_left_cui.gif" width="11" height="23" alt="" border="0"></td>
							<td valign="top" background="images/tab_inactive_background_cui.gif" class="tabinactive" nowrap>
							<a onMouseOver="this.style.color='#FF0000';" style="COLOR: #000000; TEXT-DECORATION: none" onmouseout="this.style.color='#000000';" href="httpsdecrypt_root_ca.jsp"><i18n:message bundleRef="bundleHttp" key="https.setting.server_ctf.root_ctf_authority" /></a>
							</td>
							<td><img src="images/tab_inactive_right_cui.gif" width="23" height="23" alt="" border="0"></td>

							<td><img src="images/tab_active2_left_cui.gif" width="11" height="23" alt="" border="0"></td>
							<td background="images/tab_active_background_cui.gif" class="tabactive" valign="top" nowrap><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.title" /></td>
							<td><img src="images/tab_active_right_cui.gif" width="23" height="23" alt="" border="0"></td>
						</tr>
					</table>
				</td>

				<td background="images/tab_background_cui.gif" align="right">
					<img src="images/tab_right_corner_cui.gif" width="6" height="23" alt="" border="0">
				</td>
			</tr>
		</table>
		<!-- /TABS -->
        
        <table cellSpacing=0 cellPadding=0 width="700" border=0 class="border">
        
            <tr>
                
                <td><input type="radio" name="serverSSL" value="1" onclick="disableServerSSL()" />Connect https server with the same SSL version from client</td>
            </tr>

            <tr>
                
                <td><input type="radio" name="serverSSL" value="0" onclick="enableServerSSL()" />Customize SSL setting </td>
            </tr>
			<tr>
				<td style="padding:5px">
					<table width="528" border="0" cellspacing="0" cellpadding="0">
					<!-- client side ssl method -->
						<tr>
							<td colspan=3 class="data1">
								<i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.client_ssl_method" />
							</td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="client_ssl_method_sslv3_3" value="sslv3_3"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv3_3" /></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="client_ssl_method_sslv3_2" value="sslv3_2"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv3_2" /></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="client_ssl_method_sslv3_1" value="sslv3_1"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv3_1" /></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="client_ssl_method_sslv3_0" value="sslv3_0"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv3" /><sup>*</sup></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="client_ssl_method_sslv2" value="sslv2"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv2" /><sup>*</sup></td>
						</tr>

						<tr>
							<td colspan="3">
								<img src="images/1space_cui.gif" width="1" height="10">
							</td>
						</tr>

					<!-- server side ssl method -->
						<tr>
							<td colspan=3 class="data1">
								<i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.server_ssl_method" />
							</td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="server_ssl_method_sslv3_3" value="sslv3_3"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv3_3" /></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="server_ssl_method_sslv3_2" value="sslv3_2"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv3_2" /></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="server_ssl_method_sslv3_1" value="sslv3_1"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv3_1" /></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="server_ssl_method_sslv3_0" value="sslv3_0"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv3" /><sup>*</sup></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td width=32 class="data1">
								<input type="checkbox" name="server_ssl_method_sslv2" value="sslv2"></input>
							</td>
							<td class="data1"><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.sslv2" /><sup>*</sup></td>
						</tr>

						<tr>
							<td colspan="3"><img src="images/1space_cui.gif" alt="" width="1" height="10"></td>
						</tr>

						<tr>
							<td colspan="3" class="data1">
								<sup>*</sup>&nbsp;<i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.note" />
							</td>
						</tr>

						<tr>
							<td colspan="3"><img src="images/1space_cui.gif" alt="" width="1" height="10"></td>
						</tr>
					</table>
				</td>
			</tr>
		</table>

<%
if (access == 3) {
%>
		<table width="700" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td height="28" valign="bottom">
					<input name="save" type="button" class="button" value="<i18n:message bundleRef='bundleCommon' key='button.save' />" disabled>
					<input name="cancel" type="button" class="button" value="<i18n:message bundleRef='bundleCommon' key='button.cancel' />" onclick="javascript:self.location.replace('httpsdecrypt_server_certificate_validation.jsp')">
				</td>
			</tr>
		</table>
<%
}
%>

</form>

<script>
	$(function () {
		var origClientSSLMethod = "<%=client_ssl_method%>".trim();
		var origServerSSLMethod = "<%=server_ssl_method%>".trim();
        var origKeepClientSSL = "<%=keep_client_ssl%>".trim();

		function doInit() {
			var origCArr = origClientSSLMethod.split(",");
			var origSArr = origServerSSLMethod.split(",");

			if (origCArr[0]) {
				origCArr = origCArr.map(function(item, index, array) {
					return "client_ssl_method_" + item;
				});

				for (var i = 0; i < origCArr.length; i++) {
					var selector = "input[name=" + origCArr[i] + "]";
					$(selector).attr("checked", true);
				}
			}

			if (origSArr[0]) {
				origSArr = origSArr.map(function(item, index, array) {
					return "server_ssl_method_" + item;
				});

				for (i = 0; i < origSArr.length; i++) {
					var selector = "input[name=" + origSArr[i] + "]";
					$(selector).attr("checked", true);
				}
			}
            if (origKeepClientSSL=="0") {
                $("input[name=serverSSL]:eq(1)").attr("checked",'checked');
            }else{
                $("input[name=serverSSL]:eq(0)").attr("checked",'checked');
                disableServerSSL();
            }
		}

		$('input[name^=client_ssl_method]').click(function() {
			$('input[name=save]').attr('disabled', false);
		});

		$('input[name^=server_ssl_method]').click(function() {
			$('input[name=save]').attr('disabled', false);
		});
        
        $('input[name=serverSSL]').click(function() {
			$('input[name=save]').attr('disabled', false);
		});

		$('input[name=save]').click(function() {
			var clientSSLMethod = "";
			var serverSSLMethod = "";
            var keepClientSSL = "";

			$('input[name^=client_ssl_method_]:checked').each(function() {
				clientSSLMethod += $(this).val() + ",";
			});

			$('input[name^=server_ssl_method_]:checked').each(function() {
				serverSSLMethod += $(this).val() + ",";
			});
            
            $('input[name=serverSSL]:checked').each(function(){
            keepClientSSL = $(this).val();
            });

			if (clientSSLMethod) {
				clientSSLMethod = clientSSLMethod.substring(0, clientSSLMethod.length - 1);
			}

			if (serverSSLMethod) {
				serverSSLMethod = serverSSLMethod.substring(0, serverSSLMethod.length - 1);
			}

			if (clientSSLMethod === origClientSSLMethod && serverSSLMethod === origServerSSLMethod && keepClientSSL == origKeepClientSSL) {
				alert(i18n_ssl_method_no_change);
				return;
			}

			if (!clientSSLMethod) {
				if (!confirm(i18n_ssl_method_client_ssl_method_default)) {
					return;
				}
				clientSSLMethod = "sslv3_3,sslv3_2,sslv3_1";
			}

			if (!serverSSLMethod) {
				if (!confirm(i18n_ssl_method_server_ssl_method_default)) {
					return;
				}
				serverSSLMethod = "sslv3_3,sslv3_2,sslv3_1";
			}

			$('input[name=clientSSLMethod]').val(clientSSLMethod);
			$('input[name=serverSSLMethod]').val(serverSSLMethod);
			$('input[name=op]').val("save");
			$('input[name=daemonaction]').val(1);

			$('form[name=saveform]').submit();
		});

		doInit();

	});

    function disableServerSSL()
    {
        $('input[name^=server_ssl_method_]').attr('disabled', true);
        $('input[name^=server_ssl_method_]').hide();
        
}

    function enableServerSSL()
    {
        $('input[name^=server_ssl_method_]').attr('disabled', false);
        $('input[name^=server_ssl_method_]').show();
    }

</script>
</body>
</html>
