var report_data = i18n.report_action.report_data;
var report_title = i18n.report_action.report_title;
var report_chart_types = {};
var report_chart_names = {};
$.each(report_data.reports, function(k,v) {
    report_chart_types[k] = {};
    report_chart_names[k] = {};
    $.each(v,function(i,j) {
        report_chart_types[k][j[0]] = j[4];
        report_chart_names[k][j[0]] = j[5];
        report_data.reports[k][i].splice(4,2);
    });
});

$.datepicker.regional[''] = {
	closeText: 'Done',
       currentText: 'Today',
	monthNamesShort: ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'],
	dayNames: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
	dayNamesMin: ['Su','Mo','Tu','We','Th','Fr','Sa'],
	firstDay: 1,
	isRTL: false,
	showMonthAfterYear: false,
	yearSuffix: ''
};
$.datepicker.setDefaults($.datepicker.regional['']);


$.ajax({
	url: "rest/commonlog/log_favorite",
	type: "GET",
	dataType: "json",
	async: false,
	success: function(data) {
		report_data.reports.custom_report = new Array();
		for(var i = 0; i < data.length; i++) {
			var item = new Array();
			item[0] = data[i][1];
			item[1] = data[i][0];
			item[2] = true;
			item[3] = 5;
			report_data.reports.custom_report.push(item);
			report_chart_types.custom_report = new Object();
			report_chart_types.custom_report[data[i][1]] = data[i][3];
			report_chart_names.custom_report = new Object();
			report_chart_names.custom_report[data[i][1]] = data[i][1];
		}
	},
	error: function(err) {
		console.log(err);
	}
});

$.ajax({
	url: "rest/commonlog/central/getallgroup",
	type:"POST",
	async: false,
	dataType: "json",
	success: function(data) {
	var json_data = eval(data);
		var device_info;
		$.ajax({
			url: "rest/commonlog/central/getalldevice",
			type: "POST",
			async: false,
			dataType: "json",
			success: function(data) {
				device_info = eval(data);
				$.ajax({
					url: "rest/commonlog/central/getlocaladdr",
					type: "POST",
					async: false,
					success: function(data) {
						var local_addr = JSON.parse(data);
						device_info.push(local_addr);
					},
					error: function(err_msg) {
						console.log(err_msg);
					}
				});
			}
		});
		for(var i = 0; i < json_data.length; i++) {
			var devices = json_data[i].GroupDevices;
			var device_ip_list = devices.split(";");
			var device_name_list = [];
			if((device_ip_list.length == 1) && device_ip_list[0] == '') {
				device_ip_list = [];
			}
			for(var j = 0; j < device_ip_list.length; j++) {
				var dup_flag = false;
				for(var k = 0; k < device_info.length; k++) {
					if(device_info[k].DeviceAddr == device_ip_list[j]) {
						for(var l = 0; l < device_name_list.length; l++) {
							if(device_name_list[l] == device_info[k].DeviceName) {
								dup_flag = true;
								break;
							}
						}
						if(!dup_flag) {
							device_name_list.push(device_info[k].DeviceName)
						}
						break;
					}
				}
			}
			var device_name_list_str = ""
			for(var m = 0; m < device_name_list.length; m++) {
				device_name_list_str += device_name_list[m];
				if(m != (device_name_list.length - 1)) {
					device_name_list_str += ";";
				}
			}
			json_data[i].GroupDevicesName = device_name_list_str;
		}
		var text = '';
		for(var i = 0; i < json_data.length; i++) {
			//text += '<option value="' + json_data[i].GroupName + '">' + json_data[i].GroupName + "</option>"
			text += '<option value="' + json_data[i].GroupDevicesName + '">' + json_data[i].GroupName + "</option>"
		}
		$('#json-report-device_group').append(text);
	},
	error: function(err_msg) {
		console.log(err_msg);
	}
});

(function( $ ){
  $(this).data("custom_report", report_data.reports.custom_report);

  function get_query_by_name(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(window.location.search);
    if(results == null)
      return "";
    else
      return decodeURIComponent(results[1].replace(/\+/g, " "));
  }
  var today = new Date();
  var t1 = (new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0));
  t1 = new timezoneJS.Date(t1, currentTimeZone);
  var t2 = (new Date(today.getFullYear(), today.getMonth(), today.getDate(), 3, 12, 0));
  t2 = new timezoneJS.Date(t2, currentTimeZone);
  function encode_runtime(list) {
    var el_runtime = $("#json-report-runtime");
    if ( el_runtime.val().indexOf(":") < 0 ) { el_runtime.val("0:0:0"); }
    var runtime_val = el_runtime.val().split(":");
    //runtime_val[0] = "0";
    if (list["day_of_week"]) {
      runtime_val[0] = list["day_of_week"];
    }
    if (list["day_of_month"]) {
      runtime_val[0] = list["day_of_month"];
    }
    if (list["hours"] && list["minutes"]) {
      runtime_val[1] = parseInt( String(list["hours"]) );
      runtime_val[2] = parseInt( String(list["minutes"]) );
    }
    el_runtime.val(runtime_val.join(":"));
  }

  function report_modification_mode() {
    var mode = get_query_by_name("mode");
    var tid = get_query_by_name("tid");
    if ((mode != "add" && mode != "edit") || !tid) { mode = "add"; }
    if (mode == "edit") {
      $("#help_link").attr("href", "javascript:openhelpwin('reports_modify.htm');")
      $("#content-title").text(i18n.report_action.PAGE_TITLE.MODIFY);
      $("#report_name").text(i18n.common.NO_DATA);
      load_report_from_template_id(tid);
    } else {
      $("#help_link").attr("href", "javascript:openhelpwin('reports_add.htm');")
      $("#content-title").text(i18n.report_action.PAGE_TITLE.ADD);
      $("#report_name").text(i18n.report_action.PAGE_TITLE.NEW_REPORT);
    }
  }
  function load_report_from_template_id(tid) {
    $.get("./rest/commonlog/report/template?tid="+tid, function(report) {
      if (report) {
        function apply_obj_prop(el,type) {
          function get_obj_prop() {
            var obj_prop = el.attr(type).replace("json-","").split("-");
            return report_data[obj_prop[1]];
          }
          if (el.is('input:text') || el.is('input:hidden') || el.is('textarea')) {
            var obj_str = get_obj_prop();
            el.val( String(obj_str) );
          }
          if (el.is('select')) {
            var obj_str = get_obj_prop();
            obj_str = String(obj_str)
            el.val( obj_str ).trigger("change");
          }
          if (el.is('input:checkbox')) {
            var obj_str = get_obj_prop();
            el.prop('checked', obj_str).trigger("change");
          }
          if (el.is('input:radio')) {
            var obj_str = get_obj_prop();
            el.prop('checked', (el.val() == obj_str)).trigger("change");
          }
        }
        loader(0);
		report.reports.custom_report = new Array();
		report.reports.custom_report = report_data.reports.custom_report;
        report_data = report;
        function align_with_client_tz(timestamp) {
          if (timestamp != 0) {
            console.log("t1: "+timestamp);
            t1 = new timezoneJS.Date(timestamp*1000, currentTimeZone);
            t2 = new Date(t1.getFullYear(), t1.getMonth(), t1.getDate(), t1.getHours(), t1.getMinutes(), t1.getSeconds());
            console.log("t2: "+t2.getTime() / 1000);
            return t2.getTime() / 1000;
          }
        }
        $.each(["start_date", "from", "to"], function(i,f) {
          report_data[f] = align_with_client_tz(report_data[f]);
        });
        if (report_data.report_by > 1) {
          report_data.report_by = 1;
        }
        $('[id^="json-report-"]').each(function(index,el) {
          apply_obj_prop($(el), "id");
        });
        $('[name^="json-report-"]').each(function(index,el) {
          apply_obj_prop($(el), "name");
        });
        $("#report_name").text(report_data.name);
        $("#report_mail_to").val( report_data.mail_to );
        $("#report_fail_mail_to").val( report_data.fail_mail_to );
        load_report_chart_types(report_data.reports);
        load_generate_report( String(report_data.frequency) );
        load_report_period( report_data.period );
        load_report_by_list( report_data.report_by_list );
        loader(1);
      }
    });
  }
  function load_report_chart_types(reports) {
    var treeData = [{ title: "All Reports", isFolder: true, key: "reports", expand: true, children: [] }];
	$.each(reports, function(k1,v1) {
		if(k1 == "custom_reports") {
			reports.custom_report = report_data.reports.custom_report;
			for(var i = 0; i < reports.custom_report.length; i++) {
				var report_item = reports.custom_report[i];
				for(var j = 0; j < reports.custom_reports.length; j++)
					if(report_item[1] == reports.custom_reports[j])
						break;
				if(j == reports.custom_reports.length)
					report_item[2] = false;
			}
			delete reports.custom_reports
		}
	});
    $.each(reports, function(k1,v1) {
      var r = {title: report_title[k1], isFolder: true, key: k1, expand: true, children: []};
      $.each(v1, function(k2,v2) {
      	if(k1 == "custom_report")
        	var text = v2[0];
		else
			var text = report_chart_names[k1][v2[0]];
        if (text) {
	   if($("#full_report").val() == "yes")
	   {
	   	var value_box = "<input type='text' style='width:0px;display:none' class='report_count' value='"+v2[1]+"' maxlength=2 />ALL";
	   }
	   else
	   {
          	var value_box = "<input type='text' style='width:30px;' class='report_count' value='"+v2[1]+"' maxlength=2 />";
	   }
          /*function is_chart_active(num) {
            return ((num == v2[3]) ? " active" : "");
          }*/
		  function is_chart_active(num) {
			if(($.inArray(num, v2[3]) != -1) || num == v2[3]) {
				return " active";
			} else {
				return "";
			}
			//return $.inArray(num, v2[3]) != -1 ? " active" : "";
          }
          function is_chart_available(num) {
            return ($.inArray(num, report_chart_types[k1][v2[0]]) >= 0);
          }
          var charts_text = '<div class="btn-group chart_type" style="display: inline-block;">';
          if (is_chart_available(0)) {
            charts_text    += '  <button title="Bar Chart"   class="btn btn-mini'+is_chart_active(0)+'" value="0"><i class="icon-signal"></i></button>';
          }
          if (is_chart_available(1)) {
            charts_text    += '  <button title="Pie Chart"   class="btn btn-mini'+is_chart_active(1)+'" value="1"><i class="icon-adjust"></i></button>';
          }
          if (is_chart_available(2)) {
            charts_text    += '  <button title="Table Chart" class="btn btn-mini'+is_chart_active(2)+'" value="2"><i class="icon-list-alt"></i></button>';
          }
          if (is_chart_available(3)) {
            charts_text    += '  <button title="Line Chart"  class="btn btn-mini'+is_chart_active(3)+'" value="3"><i class="icon-align-center"></i></button>';
          }
		  //nico add stack column here, the image is needed
		  if (is_chart_available(4)) {
	        charts_text	   += '	 <button title="Stacked Column Chart" class="btn btn-mini'+is_chart_active(4)+'" value="4"><i class="icon-signal"></i></button>';
		  }
          if (is_chart_available(5)) {
            charts_text    += '  <button title="Multiple Line Chart" class="btn btn-mini'+is_chart_active(5)+'" value="5"><i class="icon-signal"></i></button>';
          }
          charts_text    += '</div>';

          var table = "<table style='padding:0;margin:0;margin-top:-6px;border-bottom:1px solid #CCC;'><tr>";
          if (v2[0].indexOf("top") >=0 && k1 != "custom_report"){
            table += "<td style='padding:0;margin:0;width:500px;'>" + value_box + " " +  text + "</td>";
          }else{
            table += "<td style='padding:0;margin:0;width:500px;'>" + " " +  text + "</td>";
          }
          table += "<td style='padding:0;margin:0;'>" + charts_text + "</td>";
          table += "</tr></table>";

          sr = {title: table, key: v2[0], select: v2[2], noLink: true};
          r.children.push(sr);
        }
      });
      treeData[0].children.push(r);
    });
    $("#report_selector").dynatree();
    $("#report_selector").dynatree("destroy");
    $.ui.dynatree.nodedatadefaults["icon"] = false;
    $("#report_selector").dynatree({
        checkbox: true,
        selectMode: 3,
        children: treeData,
        debugLevel: 0
    });

    $("html, body").animate({ scrollTop: 0 }, "fast");

  }
  function load_report_period(period) {
    $("#json-report-period").val(period);
    if (period == "0") {
      $("#report_period").enhanced_datetimepicker("set_values", {
        "form_period": "#json-report-period",
        "form_from": "#json-report-from",
        "form_to": "#json-report-to"
      });
      $("input[name=period_type][value=custom]").prop("checked", true);
    } else {
      var cn = period.split("")[0];
      var ct = period.split("")[1];
      $("select#canned_period_number").val(cn);
      $("select#canned_period_type").val(ct).trigger("change");
    }
  }
  function load_generate_report(frequency) {
    var start_date = new Date($("#json-report-start_date").val() * 1000);
    //start_date = new timezoneJS.Date(start_date, currentTimeZone);
    $('#report_start_datetime').datetimepicker('setDate', start_date);
    $('#report_start_date').datepicker('setDate', start_date);

    var el_runtime = $("#json-report-runtime");
    if ( el_runtime.val().indexOf(":") < 0 ) {
      encode_runtime({
        "hours": "3",
        "minutes": "12"
      });
    }
    var runtime_val = el_runtime.val().split(":");
    if ( frequency == "3") { $("#report_day_of_week").val( runtime_val[0] ); }
    if ( frequency == "4") { $("#report_day_of_month").val( runtime_val[0] ); }

    $("#json-report-frequency").val(frequency).trigger("change");
    load_report_start_time( el_runtime.val() );

    var el_exec = $("#json-report-max_exec_number");
    var el_exec_container = $("#report_generate_occurrences_container");
    var rsg = $("#report_stop_generate");
    if (el_exec.val() == 0) {
      el_exec_container.hide();
      rsg.val("0");
    } else {
      el_exec_container.show();
      rsg.val("1");
    }
  }
  function load_report_start_time(runtime) {
    var runtime_val = runtime.split(":");
    var t3 = (new Date(today.getFullYear(), today.getMonth(), today.getDate(), runtime_val[1], runtime_val[2], 0));
    //t3 = new timezoneJS.Date(t3, currentTimeZone);
    $('#report_start_time').timepicker('setDate', t3);
  }
  function load_report_by_list(report_by_list) {
    $.each(report_by_list, function(k,v) {
      $.each(v, function(i,name) {
        if (k == "user" || k == "group") {
          insertSortOption(name, k, "right");
        } else {
          insertEntity(k.toUpperCase(), name);
        }
      });
    });
  }
  function load_report_start_date(date) {
    $("#json-report-start_date").val( (date.getTime() / 1000) );
    encode_runtime({
      "hours": String(date.getHours()),
      "minutes": String(date.getMinutes())
    });
  }

  function init_page() {
    //
    // Generate Report Section Start
    // Start Date default is Current Time
    $("#json-report-start_date").val( (t2.getTime() / 1000) );
    // List Ordinal Days of the Month
    for (var i = 1; i <= 31; i++) {
      $("#report_day_of_month").append('<option value="'+i+'">'+Number.getOrdinalFor(i,true)+'</option>');
    }
    // Default Run Time (0:3:12)
    encode_runtime({
      "hours": "3",
      "minutes": "12"
    });
    // Once in Future (Date Time Picker)
    $('#report_start_datetime').datetimepicker({
      dateFormat: 'M d, yy',
      timeFormat: 'hh:mm tt',
      showButtonPanel: true,
      changeMonth: true,
      changeYear: true,
      onSelect: function (selectedDateTime){
        var date = $(this).datetimepicker('getDate');
        load_report_start_date(date);
      }
    }).datetimepicker('setDate', t2);
    // Start Generating On (Date Picker)
    $('#report_start_date').datepicker({
      dateFormat: 'M d, yy',
      showButtonPanel: true,
      changeMonth: true,
      changeYear: true,
      minDate: 0,
      onSelect: function (selectedDate){
        var date = $(this).datepicker('getDate');
        $("#json-report-start_date").val( (date.getTime() / 1000) );
      }
    }).datepicker('setDate', t2);
    // Start Generating At (Time Picker)
    $('#report_start_time').timepicker({
      timeFormat: 'hh:mm tt',
      showButtonPanel: true,
      onSelect: function (selectedTime){
        var date = $(this).datetimepicker('getDate');
        encode_runtime({
          "hours": String(date.getHours()),
          "minutes": String(date.getMinutes())
        });
      }
    }).timepicker('setDate', t2);
    $("#json-report-frequency").bind("change", function() {
      var frequency = $(this).val();
      $("#report_scheduled").hide();
      $("#report_day_of_week_container").hide();
      $("#report_day_of_month_container").hide();
      $("#report_on_demand_container").hide();
      if ( frequency == "0" ) {
        $("#json-report-scheduled").val("false");
      } else {
        $("#json-report-scheduled").val("true");
        $("#report_scheduled").show();
        if ( frequency == "1") {
          $("#report_scheduled").hide();
          $("#report_on_demand_container").show();
          var date = $("#report_start_datetime").datetimepicker('getDate');
          load_report_start_date(date);
        } else if ( frequency == "2") {
          $("#json-report-period").val("1D");
        } else if ( frequency == "3") {
          $("#report_day_of_week_container").show();
          $("#report_day_of_week").trigger("change");
          $("#json-report-period").val("1W");
        } else if ( frequency == "4") {
          $("#report_day_of_month_container").show();
          $("#report_day_of_month").trigger("change");
          $("#json-report-period").val("1M");
        }
        if ( frequency == "2" || frequency == "3" || frequency == "4" ) {
          load_report_start_time( $("#json-report-runtime").val() );
          load_report_period( $("#json-report-period").val() );
        }
      }
    }).trigger("change");
    $("#report_stop_generate").bind("change", function() {
      var i = $(this).val();
      var el_original = $("#report_generate_occurrences_original");
      var el_real = $("#json-report-max_exec_number");
      var el_container = $("#report_generate_occurrences_container");
      if (el_original.val() == i18n.common.NO_DATA) {
        el_original.val( el_real.val() );
      }
      if (i==0) {
        el_real.val("0");
        el_container.hide();
      } else {
        if (el_original.val() == i18n.common.NO_DATA) {
          el_real.val("100");
        } else {
          el_real.val( el_original.val() );
        }
        el_container.show();
      }
    });
    $("#report_day_of_week").bind("change", function() {
      encode_runtime({
        "day_of_week": $(this).val()
      });
    });
    $("#report_day_of_month").bind("change", function() {
      encode_runtime({
        "day_of_month": $(this).val()
      });
    });
    // Generate Report Section End

    //
    // Report Period Start
    $("#report_period").enhanced_datetimepicker({
      "custom_start": {
        showMinute: false,
        timeFormat: "HH:mm"
       },
      "custom_end": {
        showMinute: false,
        timeFormat: "HH:mm"
      },
      "customized_value": "0",
      "customized_label": "Customized time range",
      "range_start_label": "From: ",
      "range_end_label": "To: ",
      "form_period": "#json-report-period",
      "form_from": "#json-report-from",
      "form_to": "#json-report-to"
    });
    $("input[name=period_type]").bind("change", function(){
      var that = $(this);
      if (that.val() == "canned") {
        var pn = $("#canned_period_number").val();
        var pt = $("#canned_period_type").val();
        $("#json-report-period").val(pn+pt);
      } else {
        load_report_period("0")
      }
    });
    $("input[name=period_type]:first").trigger("change");
    $("#canned_period_number, #canned_period_type").bind("change", function() {
      $("input[name=period_type][value=canned]").prop('checked', true).trigger("change");
    });
    $(document).bind("mousedown", function(e) {
      var el = "#report_period > .timeRangeContainer";
      if($(e.target).parents(el).length > 0 || $(el)[0] == e.target) {
        $("input[name=period_type][value=custom]").prop('checked', true);
      }
    });
    // Report Period End

    //
    // Report By Start
    $("[name=json-report-report_by]").bind("change", function() {
      var that = $(this);
      if (that.is(":checked") && that.val() == 1) {
        $("form[name=saveform]").show();
      } else {
        $("form[name=saveform]").hide();
      }
    });
    // Report By End

    //
    // Report Save Start
    function get_report_list_for_save() {
      var cus_arr = new Array();
      var new_reports = {};
      var root = $("#report_selector").dynatree("getRoot").childList[0];

      $.each(root.childList, function(i1,l1) {
        new_reports[l1.data.key] = [];
if(l1.childList) {
        $.each(l1.childList, function(i2,l2) {
          var cc = 0;
          var el_count = $(".report_count", $(l2.li));
          if ( el_count .length > 0) {
            cc = parseInt( el_count.val() );
          }
					var ct_arr = [];
					$(".chart_type > button.active", $(l2.li)).each(function() {
						var ct = parseInt($(this).val());
						ct_arr.push(ct);
					});
          var ct = parseInt( $(".chart_type > button.active", $(l2.li)).val() );
	if(l1.data.key != "custom_report") {
          				//new_reports[l1.data.key].push([l2.data.key, cc, l2.bSelected, ct]);
          				new_reports[l1.data.key].push([l2.data.key, cc, l2.bSelected, ct_arr]);
	} else {
		var str = l2.data.key
		if(l2.bSelected) {
			cus_arr.push(str);
		}
	}
        });
}
      });
if(report_data.reports.custom_reports) {
	delete report_data.reports.custom_reports;
	report_data.reports.custom_report = $(this).data("custom_report");
}
	  new_reports.custom_reports = new Array();
	for(var i = 0; i < cus_arr.length; i++) {
		for(var j = 0; j < report_data.reports.custom_report.length; j++) {
			if(cus_arr[i] == report_data.reports.custom_report[j][0]) {
				new_reports.custom_reports.push(report_data.reports.custom_report[j][1]);
				break;
			}
		}
	  }
	  delete new_reports.custom_report;
      return new_reports;
    }
    function get_user_groups_for_save() {
      var report_by_list = {};
      $.each($("#account_list ul.right_list li"), function(i, row) {
        var key = $(row).attr("stype").toLowerCase();
        var value = $(row).attr("sval");
        if ($.trim(key) != "") {
          var pair = report_by_list[key];
          if (!$.isArray( report_by_list[key] )) {
            report_by_list[key] = [];
          }
          report_by_list[key].push(value);
        }
      });
      $("#EntityTable tr").each(function(i,row) {
        if (i > 0) {
          var key = $("td", row).eq(0).text().toLowerCase();
          var value = $("td", row).eq(1).text();
          if ($.trim(key) != "") {
            var pair = report_by_list[key];
            if (!$.isArray( report_by_list[key] )) {
              report_by_list[key] = [];
            }
            report_by_list[key].push(value);
          }
        }
      });
      return report_by_list;
    }
    function save_obj_prop(el,type) {
      if (el.is('input:text') || el.is('input:hidden') || el.is('textarea') || el.is('select') || el.is('input:checkbox') || el.is('input:radio:checked')) {
        var obj_prop = el.attr(type).replace("json-","").split("-");
        var el_val = el.val().trim();
        // Boolean Values
        if (el_val.match(/^(true|false|on|off)$/)) {
          el_val = (el_val.match(/^(true|on)$/) != null);
        }
        // Numeric Values
        if (obj_prop[1].match(/^(from|to|frequency|start_date|max_exec_number|list_number|report_by)$/)) {
          el_val = parseInt(el_val);
        }
        if (el.is('input:checkbox')) {
          el_val = el.is(':checked')
        }
        report_data[obj_prop[1]] = el_val;
      }
    }
    function save_report() {
      var original_report_name = report_data.name;
      report_data.mail_to      = $.map( $("#report_mail_to").val().replace(/\;/g,",").split(","),      $.trim);
      report_data.fail_mail_to = $.map( $("#report_fail_mail_to").val().replace(/\;/g,",").split(","), $.trim);
      report_data.description = $.map( $("#json-report-description").val().replace(/\;/g,",").split(","), $.trim);
      $('[id^="json-report-"]').each(function(index,el) {
        save_obj_prop($(el), "id");
      });
      $('[name^="json-report-"]').each(function(index,el) {
        save_obj_prop($(el), "name");
      });
      function align_with_server_tz(timestamp) {
        if (timestamp != 0) {
          console.log("t1: "+timestamp);
          t1 = new Date(timestamp*1000);
          t2 = new timezoneJS.Date(t1.getFullYear(), t1.getMonth(), t1.getDate(), t1.getHours(), t1.getMinutes(), t1.getSeconds(), currentTimeZone);
          console.log("t2: "+t2.getTime() / 1000);
          return t2.getTime() / 1000;
        }
      }
      $.each(["start_date", "from", "to"], function(i,f) {
        report_data[f] = align_with_server_tz(report_data[f]);
      });
      function verify_fields_blank(fields) {
        var ret = false;
        $.each(fields, function(k,v) {
           if (!ret && report_data[k] == "") {
             if (k=="description" || ( k == "fail_mail_to" && !report_data.fail_notice)) {
               ret = false;
             } else {
               var msg = "'" + v + i18n.half_part.HALF_BLANK_WARN;
               alert(msg);
               ret = true;
             }
           }
        });
        return ret;
      }
      function verify_fields_valid(fields) {
        var ret = false;
         $.each(fields, function(k,v) {
           if (!ret && report_data[k] != "") {
                var objRegExp = new RegExp("[<>&\?]");
             if (objRegExp.test(report_data[k]) == true) {
               var msg = "'" + v + i18n.half_part.HALF_VALID_WARN;
               alert(msg);
               ret = true;
             }
           }
        });
        return ret;
      }
      function verify_fields_bad_email(fields) {
        var ret = false;
        $.each(fields, function(k,v) {
          if (!ret) {
            var emails = report_data[k];
            if (!$.isArray(emails)) {
              emails = [emails];
            }
            $.each(emails, function(i,e) {
              if (!ret && !simple_email_test(e)) {
                if (k == "fail_mail_to" && !report_data.fail_notice) {
                  ret = false;
                } else {
                  var msg = "'" + v + i18n.half_part.HALF_VALID_EMAIL_WARN;
                  alert(msg);
                  ret = true;
                }
              }
            });
          }
        });
        return ret;
      }
      function check_reports(reports) {
        var i;
        var flag = false;
        for(i = 0; i < reports["internet_security"].length; i++) {
          if(reports["internet_security"][i][2] == true) {
            flag = true;
            break;
          }
        }
        if(!flag) {
          for(i = 0; i < reports["internet_access"].length; i++) {
            if(reports["internet_access"][i][2] == true) {
              flag = true;
              break;
            }
          }
        }
        if(!flag) {
          for(i = 0; i < reports["bandwidth"].length; i++) {
            if(reports["bandwidth"][i][2] == true) {
              flag = true;
              break;
            }
          }
        }
        if(!flag) {
          for(i = 0; i < reports["policy_enforcement"].length; i++) {
            if(reports["policy_enforcement"][i][2] == true) {
              flag = true;
              break;
            }
          }
        }
        if(!flag) {
          for(i = 0; i < reports["data_security"].length; i++) {
            if(reports["data_security"][i][2] == true) {
              flag = true;
              break;
            }
          }
        }
	if(!flag) {
	  if(reports.custom_reports.length > 0)
		flag = true;
	}
        return flag;
      }
      function check_top_N(reports) {
        var i;
        var flag = true;
        for(i = 0; i < reports["internet_security"].length; i++) {
          if(reports["internet_security"][i][0] != "c&c_contact_alert_count_by_date" &&
            reports["internet_security"][i][0] != "malicious_sites_blocked_by_date" &&
            reports["internet_security"][i][0] != "malware_spyware_detection_by_date" &&
            reports["internet_security"][i][0] != "malware_spyware_detection_trend" &&
	        reports["internet_security"][i][0] != "most_violation_for_http_malware_scan_policy")
          {
            if(isNaN(reports["internet_security"][i][1]) || reports["internet_security"][i][1] <= 0) {
              flag = false;
              break;
            }
          }
        }
        if(flag) {
          for(i = 0; i < reports["internet_access"].length; i++) {
			if(reports["internet_access"][i][0] != "activity_level_by_days")
			{
				if(isNaN(reports["internet_access"][i][1]) || reports["internet_access"][i][1] <= 0) {
				  flag = false;
				  break;
				}
			}
          }
        }
        if(flag) {
          for(i = 0; i < reports["bandwidth"].length; i++) {
			  if(reports["bandwidth"][i][0] != "total_traffic_by_days") {
				if(isNaN(reports["bandwidth"][i][1]) || reports["bandwidth"][i][1] <= 0) {
				  flag = false;
				  break;
				}
			  }
          }
        }
        if(flag) {
          for(i = 0; i < reports["policy_enforcement"].length; i++) {
			if(reports["policy_enforcement"][i][0] != "most_violation_for_access_quota_control_policy" &&
			   reports["policy_enforcement"][i][0] != "most_violation_for_applets_and_activex_policy" &&
			   reports["policy_enforcement"][i][0] != "most_violation_for_http_inspection_policy" &&
			   reports["policy_enforcement"][i][0] != "most_violation_for_url_filtering_policy" &&
			   reports["policy_enforcement"][i][0] != "most_violation_for_application_control_policy")
			{
				if(isNaN(reports["policy_enforcement"][i][1]) || reports["policy_enforcement"][i][1] <= 0) {
				  flag = false;
				  break;
				}
			}
          }
        }
        if(flag) {
          for(i = 0; i < reports["data_security"].length; i++) {
			if(reports["data_security"][i][0] != "most_violation_for_data_loss_prevention_policy") {
				if(isNaN(reports["data_security"][i][1]) || reports["data_security"][i][1] <= 0) {
				  flag = false;
				  break;
				}
			}
          }
        }
        return flag;
      }
      var fields1 = {
        "name": "Report Name",
        "description": "Report Description"
      }
      var fields2 = {
        "subject": "Email Subject"
      }
      var fields3 = {
        "mail_to": "Email Recipients",
        "fail_mail_to": "Failure Notice Recipients",
        "mail_from": "Email From"
      }
      if ( verify_fields_blank( fields1 ) ) {
        return false;
      }
      if (verify_fields_valid(fields1))
      {
      	 return false;
      }
      if ( report_data.mail_enable && verify_fields_blank( fields2 ) ) {
        return false;
      }
      if ( report_data.mail_enable && verify_fields_bad_email( fields3 ) ) {
        return false;
      }
      report_data.report_by_list = get_user_groups_for_save();
      if ($.isEmptyObject(report_data.report_by_list)) {
        report_data.report_by = 0;
      }
      report_data.reports = get_report_list_for_save();
      if(!check_reports(report_data.reports)) {
        alert(i18n.reports.MESSAGE.REPORT_TYPE_NONE);
        return;
      }
      if(!check_top_N(report_data.reports)) {
        alert(i18n.reports.MESSAGE.REPORT_TOPN_RANGE);
        return;
      }
      loader(0);
      var mode = get_query_by_name("mode");
      var mode_value = "add";
      var check_name = true;
      var confirm_good_name = true;
      var success_message = i18n.reports.MESSAGE.REPORT_SUCCESS_CREATED;
      var request = {};
      request["action"] = "add";
      if (mode == "edit") {
        request["action"] = "modify";
        request["tid"] = report_data.tid;
        check_name = (original_report_name != report_data.name);
        success_message = i18n.reports.MESSAGE.REPORT_SUCCESS_UPDATED;
      }
      request['template'] = report_data;
      if (check_name) {
        var badname = report_data.name;
        var goodname = check_report_name(badname);
        if(goodname.length >=256) {
          alert(i18n.reports.MESSAGE.NAME_LENGTH_CONTROL);
          return;
        }
        if (goodname != badname) {
          report_data.name = goodname;
          var confirm_msg = i18n.half_part.HALF_REPORT_WITH_NAME + badname + i18n.half_part.HALF_REPORT_RENAME + goodname + "' ?";
          confirm_good_name = confirm(confirm_msg);
        }
      }
      if (confirm_good_name) {
        $.ajax({
          url: "./rest/commonlog/report/template",
          dataType: "json",
          async: false,
          type: "POST",
          data: JSON.stringify(request),
          success: function(data) {
            alert(success_message);
            document.location.href="./reports.jsp";
          },
          error: function(a, b, c) {
            loader(1);
            if (a.statusText == "Created") {
                alert(success_message);
                document.location.href="./reports.jsp";
            } else {
                $("html, body").animate({ scrollTop: 0 }, "fast");
                $("#alert_div").empty().append('<div class="alert alert-error"><strong>Unable to Save Report: </strong> Change a few things up and try submitting again.</div>');
            }
          }
        });
      }
    }
    $("#save_report").bind("click", function(e) {
      save_report();
    });
    $("#save_report").bind("keyup", function(e) {
      if (e.keyCode == 13) {
        $(this).click();
      }
    });
    // Report Save End

    //
    // Report Chart Type Start
    $(".chart_type > button").live("click", function(e) {
      var that = $(this);
      //$("button", that.parent()).removeClass("active");
      if(that.attr("class").indexOf("active") != -1) {
		that.removeClass("active");
	  } else {
      that.addClass("active");
	  }
    });
    $(".chart_type > button").live("keyup", function(e) {
      if (e.keyCode == 13) {
        $(this).click();
      }
    });
    load_report_chart_types( report_data.reports );
    // Report Chart Type End

    //
    // Report Add / Edit Initialization
    report_modification_mode();
  }
  init_page();

})( jQuery );
