(function( $ ){

/* log offload start */
/*0: purge
 *1: log offload
 *2: historical mode
 */
var log_setting_status = 0;
/*
 * 0: no device is mounted
 * 1: device is mounted
 */
var mount_status = 0;
function disable_purge_settings() {
	$("#json-purge_days").attr("disabled", "disabled");
	$("#json-purge_size").attr("disabled", "disabled");
}
function enable_purge_settings() {
	$("#json-purge_days").attr("disabled", false);
	$("#json-purge_size").attr("disabled", false);
}
function disable_log_offload_settings() {
	$("#offload_logs").attr("disabled", "disabled");
}
function enable_log_offload_settings() {
	$("#offload_logs").attr("disabled", false);
}
function disable_log_retrieval_settings() {
	$('.lr').hide();
}
function enable_log_retrieval_settings() {
	$('.lr').show();
}
function enable_mount() {
	$('.on_mount').show();
	$('.off_mount').hide();
}
function disable_mount() {
	$('.on_mount').hide();
	$('.off_mount').show();
}
  function update_form() {
	var retrieval_files;
	$.ajaxSetup({
		async: false
	});

	$.get("/rest/commonlog/log_setting/purge", function(purge) {
		loader(0);
		if (purge) {
			retrieval_files = purge.retrieval_files;
			log_setting_status = 0;
			$("#json-purge_days").val( purge.purge_days );
			$("#json-purge_size").val( purge.purge_size );

			if(purge.mount_device) {
				disable_mount();
				mount_status = 1;
			} else {
				enable_mount();
				mount_status = 0;
			}

			if(Number(purge.last_log_offload_time)) {
				var int_time = parseInt(purge.last_log_offload_time);
				var date_time = new Date(int_time * 1000);
				var string_year = date_time.getFullYear();
				var string_month = date_time.getMonth();
				var string_day =  date_time.getDate();
				if((parseInt(string_month) + 1) < 10) {
					string_month = 0 + (parseInt(string_month) + 1);
				}
				if(parseInt(string_day) < 10) {
					string_day = "0" + string_day;
				}
				if(parseInt(string_month) < 10) {
					string_month = "0" + string_month;
				}
				var string_time = string_year + "-" + string_month + "-" + string_day;
				$("#llut").text(string_time);
			}

			enable_purge_settings();
			enable_log_offload_settings();
			disable_log_retrieval_settings();
			if(purge.enable_log_offload == "1") {
				$("#offload_logs").attr("checked", true);
				log_setting_status = 1;
			}

			if(purge.enable_historical_report_mode == "1") {
				$("#historical_report_mode").attr("checked", true);
				disable_purge_settings();
				disable_log_offload_settings();
				enable_log_retrieval_settings();
				log_setting_status = 2;
				if(purge.retrieval_files) {
					ui_show_retrieval_files(purge.retrieval_files);
				} else{
					$("#log_retrieval_container .dynamical_item").remove();
				}
			}
		}
		loader(1);
	});

	$.ajax({
		url: "rest/commonlog/log_setting/get_log_dir",
		async: false,
		type: "GET",
		dataType: "json",
		success: function(data) {
			var folders = data.dirs;
			folders.sort(folder_sort);
			var i, j;
			var html = '<option value="" selected>' + i18n.report_logsetting.MESSAGE.RETRIEVAL_LOGS + '</option>';
			retrieval_files_arr = retrieval_files.split(",");
			for(i = 0; i < folders.length; i++) {
				var insert_flag = true;
				var date = folders[i].split("_")[0];
				//do a formate_date
				for(j = 0; j < retrieval_files_arr.length; j++) {
					if(folders[i] == retrieval_files_arr[j]){
						insert_flag = false;
						break;
					}
				}
				if(insert_flag) {
					html += '<option value="' + folders[i] + '">' + date + "</option>";
				}
			}
			$("#log_retrieval_list").html(html);
			if(2 == log_setting_status && 0 == folders.length) {
				$('#log_retrieval_warn').show();
			}
		},
		error: function(err) {
			console.log(err);
		}
	});
}
function folder_sort(a, b) {
	var inta = parseInt(a.split("_")[0]);
	var intb = parseInt(b.split("_")[0]);
	if(inta < intb)
		return -1;
	else if(inta > intb)
		return 1;
	else
		return 0;
}
function ui_show_retrieval_files(files) {
	$("#log_retrieval_container .dynamical_item").each(function() {
		$(this).remove();
	});
	var file_arr = files.split(",");
	var i, file_name, file_size, file_attr;
	var html = "";
	for(i = 0; i < file_arr.length; i++) {
		file_attr = file_arr[i].split("_");
		file_name = file_attr[0];
		file_size = file_attr[1];
		html += '<tr id="' + file_arr[i] + '" class="dynamical_item">';
		html +=		'<td class="data' + (i % 2 + 1) + 'b">' + file_name + "</td>";
		html +=		'<td class="data' + (i % 2 + 1) + 'b">' + file_size + "</td>";
		html +=		'<td class="data' + (i % 2 + 1) + 'b"><img src="images/icon_remove_file.png" style="cursor:pointer;" /></td>';
		html += '</tr>';
	}
	$("#log_retrieval_container").append(html);
	$("#log_retrieval_container img").click(function() {
		var file_id = $(this).parent().parent().attr("id");
		var request = {"file": file_id};
		loader(0);
		$.ajax({
			url: "rest/commonlog/log_setting/delete_retrieval_log_file",
			dataType: "json",
			async: false,
			type: "POST",
			data: JSON.stringify(request),
			success: function(data) {
				if(data.success) {
					loader(1);
					update_form();
				} else {
					loader(1);
					alert("Internal error happened!");
				}
			},
			error: function(error) {
				loader(1);
				console.log(error);
			}
		});
	});
}
function check_mount_device(path) {
	var reg = /[<>;|]/;
	if(reg.test(path))
		return false;
	return true;
}
/* log offload utility end */

  function update_anonymous() {
	$.ajaxSetup({
		async: false
	});
	$.get("rest/commonlog/log_setting/anonymous", function(value) {
		loader(0);
		if (value) {
			state=value.isEnable;
			if(state == "yes")
			{
				document.getElementById("anonymous_button").value = "Disable";
				document.getElementById("anonymous_state").innerHTML ="Enabled";
			}else{

			document.getElementById("anonymous_button").value = "Enable";
			document.getElementById("anonymous_state").innerHTML ="Disabled";
			}
		}
	  loader(1);
	});
  }

  function update_interrupted() {
	$.ajaxSetup({
		async: false
	});
	$.get("rest/commonlog/log_setting/interrupted", function(value) {
		loader(0);
		if (value) {
			state=value.isEnable;
			if(state == "yes")
			{
				document.getElementById("interrupted_button").value = "Disable";
				document.getElementById("interrupted_state").innerHTML ="Enabled";
			}else{

			document.getElementById("interrupted_button").value = "Enable";
			document.getElementById("interrupted_state").innerHTML ="Disabled";
			}
		}
	  loader(1);
	});
  }



  function update_filter() {
	$.ajaxSetup({
		async: false
	});
	$.get("rest/commonlog/log_setting/filter", function(filter) {
	  loader(0);
	  var scope = document.getElementById("logType_0");
	  scope.options[1].selected = true;
	  if (filter) {
				jsIniFirstRow(filter);
				for(var i=1; i<filter.length;i++)
				{
					jsAppendRow(filter);
				}
	  }
	  loader(1);
	});
  }


function jsAppendRow(filter)
{
   var RowLength = document.getElementsByName("Plus_icon").length;
   var Ptable = document.getElementById("tblDefineTemp");
   var row=Ptable.getElementsByTagName("tr");
   var rLen=row.length;
   var BlankRow=Ptable.insertRow(rLen); //seperate
   var BlankCell = BlankRow.insertCell(0);
   BlankCell.colspan = "7";
   BlankCell.style.height = "3px";
   var oRow=Ptable.insertRow(rLen+1);
   for(var t=0;t<6;t++)
   {
	   var oCell=oRow.insertCell(t);
	   oCell.className="Filter";
	   oCell.innerHTML = row[0].cells[t].innerHTML;
   }
   oRow.cells[0].firstChild.style.visibility="visible";
   oRow.cells[0].firstChild.id = RowLength;
   oRow.cells[2].firstChild.style.visibility = "visible";
   oRow.cells[3].firstChild.id = "logType_"+RowLength;
   oRow.cells[3].firstChild.options[0].selected = true;
   i = parseInt(filter[RowLength].type);
   oRow.cells[3].firstChild.options[i].selected = true;

   scope_option = oRow.cells[4].firstChild;
   if(0 == i)
   {
		for(var i=0;i<scope_option.options.length;)
	{
		scope_option.removeChild(scope_option.options[i]);
	}
		scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_user,"user"));
   }else
   {
		for(var i=0;i<scope_option.options.length;)
	{
		scope_option.removeChild(scope_option.options[i]);
	}
		scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_user,"user"));
		scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_dom,"dom"));
   }

   oRow.cells[4].firstChild.id = "scope_"+RowLength;
   if( "" == filter[RowLength].user){
	   oRow.cells[4].firstChild.options[1].selected = true;
	   oRow.cells[5].firstChild.value=filter[RowLength].dom;
   }
   else{
	   oRow.cells[4].firstChild.options[0].selected = true;
	   oRow.cells[5].firstChild.value=filter[RowLength].user;
   }
   oRow.cells[5].firstChild.id="value_"+RowLength;


}



  function jsIniFirstRow(filter)
  {

   i = parseInt(filter[0].type)
   var type = document.getElementById("logType_0");
   type.options[i].selected = true;
   //remove dom options for bandwith
   if (0 == i)
   {
	   var scope = document.getElementById("scope_0");
	   if( 2 == scope.options.length )
	   {
		   scope.removeChild(scope.options[1]);
	   }
   }

   if( "" == filter[0].user){
	   var scope = document.getElementById("scope_0");
	   scope.options[1].selected = true;
	   var value = document.getElementById("value_0");
	   value.value = filter[0].dom;
   }else{
	   var scope = document.getElementById("scope_0");
	   scope.options[0].selected = true;
	   var value = document.getElementById("value_0");
	   value.value = filter[0].user;
   }
  }

/* all parts init */
function init_page() {
	update_form();
	update_filter();
	update_anonymous();
	update_interrupted();

	$("#mount_button").click(function() {
		var mount_input = $.trim($("#mount_dev").val());
		if(!check_mount_device(mount_input)) {
			alert(i18n.report_logsetting.MESSAGE.MOUNT_DEVICE_ERROR);
			return ;
		}

		var mount_device = "mount " + mount_input + " /var/offload";
		var request = {"mount_device": mount_device, "cmd": "mount"};
		$.ajax({
			url: "rest/commonlog/log_setting/mount_device",
			dataType: "json",
			async: false,
			type: "POST",
			data: JSON.stringify(request),
			success: function(data) {
				if(data.success) {
					alert(i18n.report_logsetting.MESSAGE.MOUNT_ACTION_SUCCESS);
				} else {
					alert(i18n.report_logsetting.MESSAGE.MOUNT_ACTION_UNSUCCESS);
				}
				update_form();
			},
			error: function(err) {
				console.log(err);
			}
		});
	});

	$("#unmount_button").click(function() {
		$('#mount_dev').val("");
		var mount_device = "umount /var/offload";
		var request = {"mount_device": mount_device, "cmd": "umount"};
		$.ajax({
			url: "rest/commonlog/log_setting/mount_device",
			dataType: "json",
			async: false,
			type: "POST",
			data: JSON.stringify(request),
			success: function(data) {
				if(data.success) {
					alert(i18n.report_logsetting.MESSAGE.UNMOUNT_ACTION_SUCCESS);
				} else {
					alert(i18n.report_logsetting.MESSAGE.UNMOUNT_ACTION_UNSUCCESS);
				}
				update_form();
			},
			error: function(err) {
				console.log(err);
			}
		});
	});

	$("#log_retrieval").click(function() {
		if(!$("#log_retrieval_list").val()) {
			alert(i18n.report_logsetting.MESSAGE.CHOOSE_FOLDER_FIRST);
			return ;
		}

		var request = {"file": $("#log_retrieval_list").val()};
		$("#log_retrieval_list").find("option:selected").remove();
		loader(0);
		$.ajax({
			url: "rest/commonlog/log_setting/log_retrieval",
			async: false,
			type: "POST",
			data: JSON.stringify(request),
			dataType: "json",
			success: function(data) {
				loader(1);
				if(data.success)
					update_form();
				else
					alert("Internal error happened!");
			},
			error: function(err) {
				loader(1);
				console.log(err);
			}
		});
	});

	$("#save_log_setting").bind("click", function(e) {
		var pd = String(parseInt( $("#json-purge_days").val() ));
		var ps = String(parseInt( $("#json-purge_size").val() ));

		if(isNaN(pd) || isNaN(ps) || pd <= 0 || ps <= 0) {
			alert( i18n.report_logsetting.MESSAGE.PURGE_SETTINGS_INPUT_INVALID );
			return;
		}

// need modify
		if($("#offload_logs").attr("checked") && log_setting_status != 1 && 0 == mount_status) {
			alert(i18n.report_logsetting.MESSAGE.WARN_MOUNT_DEVICE_FIRST);
			return;
		}

		if($("#offload_logs").attr("checked") && parseInt($("#json-purge_days").val()) < 45) {
			alert(i18n.report_logsetting.MESSAGE.WARN_ENABLE_LOG_OFFLOAD);
			return;
		}

		if(!$("#historical_report_mode").attr("checked")  && log_setting_status == 2 && $("#log_retrieval_container").find("tr").length > 1) {
			alert(i18n.report_logsetting.MESSAGE.WARN_DISABLE_HISTORICAL_REPORT_MODE);
			return;
		}

		var enable_log_offload = 0;
		var enable_historical_report_mode = 0;

		if($("#offload_logs").attr("checked"))
			enable_log_offload = 1;

		if($("#historical_report_mode").attr("checked"))
			enable_historical_report_mode = 1;

		request = {"purge_days": pd,"purge_size": ps, "enable_log_offload": enable_log_offload, "enable_historical_report_mode": enable_historical_report_mode};
		loader(0);
		$.ajax({
			url: "rest/commonlog/log_setting/purge",
			dataType: "json",
			async: false,
			type: "POST",
			data: JSON.stringify(request),
			success: function(data) {
				alert( i18n.report_logsetting.MESSAGE.SAVE_PURGE_SETTINGS_SUCCESS );
				loader(1);
			},
			error: function(a, b, c) {
				alert( i18n.report_logsetting.MESSAGE.PURGE_SETTINGS_INPUT_INVALID_SIZE );
				loader(1);
				$("html, body").animate({ scrollTop: 0 }, "slow");
				console.log("ERROR:", a, b, c);
			}
		});

		update_form();
	}).bind("keyup", function(e) {
		if (e.keyCode == 13) {
			$(this).click();
		}
	});

	$("#save_filter_setting").bind("click", function(e) {

		var array = [];
		var RowLength = document.getElementsByName("Plus_icon").length;

		var ruleValue = document.getElementById("value_"+(RowLength-1)).value;
      	var logTypeValue = document.getElementById("logType_"+(RowLength-1)).value;
     	var scopeValue = document.getElementById("scope_"+(RowLength-1)).value;
        for(var t=0;t<(RowLength-1);t++)
        {
			var ruleValue_before = document.getElementById("value_"+t).value;
			var logTypeValue_before = document.getElementById("logType_"+t).value;
			var scopeValue_before = document.getElementById("scope_"+t).value;
			if( ruleValue_before == ruleValue
				&& logTypeValue_before == logTypeValue
				&& scopeValue_before == scopeValue)
			{
				alert( i18n.report_logsetting.MESSAGE.RULE_ALREADY_EXIST );
				document.getElementById("value_"+(RowLength-1)).focus();
				return;
			}
		}
		for(var i=0; i < RowLength; i++) {
			var logType=document.getElementById("logType_"+i).value;
			var scope=document.getElementById("scope_"+i).value;
			var value=document.getElementById("value_"+i).value;
			String.prototype.Trim = function() {
				return this.replace(/(^\s*)|(\s*$)|(\n)/g, "");
			}
			value = value.Trim();
			if("" == value) {
				alert( i18n.report_logsetting.MESSAGE.VALUE_NOT_EMPTY );
				document.getElementById("value_"+i).focus();
				return;
			}

			if(scope == "dom") {
				user="";
				dom=value;
			} else {
				dom="";
				user=value
			}
			request = {"type": logType,"user": user,"dom": dom};
			array.push(request);
		}

		loader(0);
		$.ajax({
			url: "rest/commonlog/log_setting/filter",
			dataType: "json",
			async: false,
			type: "POST",
			data: JSON.stringify(array),
			success: function(data) {
				alert( i18n.report_logsetting.MESSAGE.SAVE_FILTER_SETTINGS_SUCCESS );
				loader(1);
			},
			error: function(a, b, c) {
				loader(1);
				$("html, body").animate({ scrollTop: 0 }, "slow");
				console.log("ERROR:", a, b, c);
			}
		});
	}).bind("keyup", function(e) {
		if (e.keyCode == 13) {
			$(this).click();
		}
	});




   $("#clear_filter_setting").bind("click", function(e) {
	if($('#clear_flag').val() == "clear") {
	  loader(0);
	  $.ajax({
		url: "rest/commonlog/log_setting/filter_clear",
		dataType: "json",
		async: false,
		type: "POST",
		data: "",
		success: function(data) {
		  alert( i18n.report_logsetting.MESSAGE.CLEAR_FILTER_SETTINGS_SUCCESS );
		  loader(1);
		  $('#clear_flag').val("");
		},
		error: function(a, b, c) {
		  loader(1);
		  $("html, body").animate({ scrollTop: 0 }, "slow");
		  console.log("ERROR:", a, b, c);
		  $('#clear_flag').val("");
		}
	  });
	}
	}).bind("keyup", function(e) {
	  if (e.keyCode == 13) {
		$(this).click();
	  }
	});


	$("#anonymous_button").bind("click", function(e) {

	  op= document.getElementById("anonymous_button").value;
	  if(op == "Enable")
	  {
		  request = {"isEnable":"yes"};
	  }else{

		  request = {"isEnable":"no"};
	  }
	  loader(0);
	  $.ajax({
		url: "rest/commonlog/log_setting/anonymous",
		dataType: "json",
		async: false,
		type: "POST",
		data: JSON.stringify(request),
		success: function(data) {
		  alert( i18n.report_logsetting.MESSAGE.ANONYMOUS_SUCESS );
		  if(op == "Enable")
		  {
			document.getElementById("anonymous_button").value = "Disable";
			document.getElementById("anonymous_state").innerHTML ="Enabled";
		  }else{
			document.getElementById("anonymous_button").value = "Enable";
			document.getElementById("anonymous_state").innerHTML ="Disabled";
		  }

		  loader(1);
		},
		error: function(a, b, c) {
		  loader(1);
		  $("html, body").animate({ scrollTop: 0 }, "slow");
		  console.log("ERROR:", a, b, c);
		}
	  });
	}).bind("keyup", function(e) {
	  if (e.keyCode == 13) {
		$(this).click();
	  }
	});

	$("#interrupted_button").bind("click", function(e) {

	  op= document.getElementById("interrupted_button").value;
	  if(op == "Enable")
	  {
		  request = {"isEnable":"yes"};
	  }else{

		  request = {"isEnable":"no"};
	  }
	  loader(0);
	  $.ajax({
		url: "rest/commonlog/log_setting/interrupted",
		dataType: "json",
		async: false,
		type: "POST",
		data: JSON.stringify(request),
		success: function(data) {
		  alert( i18n.report_logsetting.MESSAGE.ANONYMOUS_SUCESS );
		  if(op == "Enable")
		  {
			document.getElementById("interrupted_button").value = "Disable";
			document.getElementById("interrupted_state").innerHTML ="Enabled";
		  }else{
			document.getElementById("interrupted_button").value = "Enable";
			document.getElementById("interrupted_state").innerHTML ="Disabled";
		  }

		  loader(1);
		},
		error: function(a, b, c) {
		  loader(1);
		  $("html, body").animate({ scrollTop: 0 }, "slow");
		  console.log("ERROR:", a, b, c);
		}
	  });
	}).bind("keyup", function(e) {
	  if (e.keyCode == 13) {
		$(this).click();
	  }
	});



  }
  init_page();

})( jQuery );
