<%@ page contentType = "text/html; charset=UTF-8" %>
<%@ page import="com.trend.iwss.gui.*" %>
<%@ page import="com.trend.api.administration.*" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<i18n:bundle baseName="iwsvaLogs" id="bundleLog" />

<%
	if(Validation.CheckUser(request,response)!=1){
		response.sendRedirect("logon.jsp?accessquota_policy");
		return;
	}

	AdministrationAccount accountinfo = (AdministrationAccount)request.getSession().getAttribute("AccountInfo");
	AdministrationRole roleinfo = null;
	int access = 0;
	if(accountinfo != null)
	{
		roleinfo = accountinfo.getRole();
		access = roleinfo.getAccessRightByKeyID(6);
		if (access == 0)
		{
			response.sendRedirect("logon.jsp");
			return;
		}
	}
	else
	{
		response.sendRedirect("logon.jsp");
		return;
	}

	boolean is_log_source = false;
//0: normal, 1: log server, 2: log source
	is_log_source = (Integer.parseInt(IWSSInfo.GetKeyValue("CommonLog","ServerRole"))==2);

	response.setHeader("Pragma","no-cache");
	response.setHeader("Cache-Control","no-cache");

	String strPostType = request.getParameter("PostType");
	String strRemoveList = request.getParameter("RemoveList");
	String logEntry = "";

	//Fix the maximum support limition for external syslog server.
	int iMaxServer = 4, iMaxEventfilter = 10, line = 0, iCandidate=-1;

	//out.println("PostType="+strPostType+", RemoveList="+strRemoveList);
	if ((strPostType != null) && (true == strPostType.equals("remove")) && (strRemoveList != null) && (strRemoveList.length()>0))
	{
		logEntry = "Remove Syslog server ";
		for(int i=0; i < iMaxServer; i++)
		{
			 if (-1 != strRemoveList.indexOf(String.valueOf(i))){
				   IWSSUtil.SetSyslogRemove(i);
				   logEntry += i + " ";
			 }
		}
		if(request.getParameter("daemonaction") != null)
			 DaemonAction.TakeAction(Integer.parseInt(request.getParameter("daemonaction")));

		if(request.getParameter("app_daemonaction") != null)
		{
			 DaemonAction.TakeAction(Integer.parseInt(request.getParameter("app_daemonaction")));
		}

		try {
			 AuditTrailLogger.getInstance().log(request, logEntry );
			 System.out.println(logEntry);
		} catch (Exception e){
			 System.out.println("SyslogRemove Error in Audit Log: " + e.getMessage());
		}
	}

	String [] strEnable = {"true", "true", "true", "true"};

	//Find the last room for adding new settings.
	for(int i=0; i < iMaxServer; i++)
	{
	   strEnable[i] = IWSSUtil.GetSyslogEnable(i);
	//out.println("Enable."+i+"="+strEnable[i]+"\n");

		if ((-1 == iCandidate) && (strEnable[i] != null) && strEnable[i].equals("remove"))
		{
			iCandidate = i;
	   //out.println("iCandidate="+i+"\n");
		}
	}

	String[] strSyslogServer =
	{
		"127.0.0.1","127.0.0.1","127.0.0.1","127.0.0.1"
	};

	String[] strSyslogServerPort =
	{
		"514","514","514","514"
	};

	String[] strEnableSyslog =
	{
		"","","",""
	};

	//For duplicated checking.
	String strSelectedIPList = "";
	String strSelectedPortList = "";
	for(int i=0; i < iMaxServer; i++)
	{
		strSyslogServer[i] = IWSSUtil.GetSyslogServerIP(i);
		if ((null == strSyslogServer[i]) || ( strSyslogServer[i].length()==0))
			strSyslogServer[i]="N/A";
		else if (!IWSSUtil.GetSyslogEnable(i).equals("remove"))
			strSelectedIPList += strSyslogServer[i] + ";";

		strSyslogServerPort[i] = "" + IWSSUtil.GetSyslogServerPort(i);
		if ((null == strSyslogServerPort[i]) || ( strSyslogServerPort[i].length()==0))
			strSyslogServerPort[i]="N/A";
		else if (IWSSUtil.GetSyslogEnable(i).equals("true"))
			strSelectedPortList += strSyslogServerPort[i] + ";";

		strEnableSyslog[i] = IWSSUtil.GetSyslogEnable(i);
		if ((null == strEnableSyslog[i]) || ( strEnableSyslog[i].length()==0))
			strSyslogServerPort[i]="N/A";
	 }
         boolean isInterruptedEnable = false;
         IWSSINI intscan = new IWSSINI(IWSSInfo.GetWorkPath() + "IWSSPIProtocolHttpProxy.pni");
         String Interrupted_Log_enable = intscan.GetKeyValue("http", "enable_interrupted_log");
         if(Interrupted_Log_enable.equals("yes"))
         {
                isInterruptedEnable = true;
         }
%>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge" >
<title i18n="PRODUCT.FULL_NAME"></title>
<link href="html/trend-style.css" rel="stylesheet" type="text/css">
<link href="lib/tmPlugins/styles.css" rel="stylesheet" type="text/css">
<style type="text/css" title="currentStyle">
	@import "log/themes/jquery-ui-1.10.2/jquery-ui-1.10.2.custom.css";
</style>
<script type="text/JavaScript">

var iMaxServer=4;
function doSubmit()
{
	alert(i18n_post_type+PostType.value+i18n_server_no+ServerNo.value);
	return true;
}

function generate_deletelist()
{
	var num_cb;
	var tmp_cb;
	var strdeletelist="";

	for(var i=0; i < iMaxServer; i++)
	{
		num_cb = "cb_" +i;
		tmp_cb = document.getElementById(num_cb);

		if(tmp_cb)
		{
			if(tmp_cb.checked == 1)
			{
				if (strdeletelist.length)
					strdeletelist += ","+i;
				else
					strdeletelist += i;
			}
		}
	}

	return strdeletelist;
}

function do_delete()
{
	if(confirm(i18n_confirm_del_syslog_settings)==false) return;

	var strdeletelist=generate_deletelist();

	if (strdeletelist.length)
	{
		document.saveform.PostType.value = "remove";
		document.saveform.RemoveList.value = strdeletelist;
		document.saveform.daemonaction.value = httpftpreload+haagentreload;
		setTimeout( "document.saveform.submit()", 100 );
	}
}


function jsAddRow()
{
	var RowLength = document.getElementsByName("Plus_icon").length;
	var ruleValue = document.getElementById("value_"+(RowLength-1)).value;
	var logTypeValue = document.getElementById("logType_"+(RowLength-1)).value;
	var scopeValue = document.getElementById("scope_"+(RowLength-1)).value;
	if (ruleValue == "")
	{
		alert( i18n.report_logsetting.MESSAGE.VALUE_NOT_EMPTY );
		document.getElementById("value_"+(RowLength-1)).focus();
		return;
	}
	for(var t=0;t<(RowLength-1);t++)
	{
		var ruleValue_before = document.getElementById("value_"+t).value;
		var logTypeValue_before = document.getElementById("logType_"+t).value;
		var scopeValue_before = document.getElementById("scope_"+t).value;
		if( ruleValue_before == ruleValue
			&& logTypeValue_before == logTypeValue
			&& scopeValue_before == scopeValue)
		{
			alert( i18n.report_logsetting.MESSAGE.RULE_ALREADY_EXIST );
			document.getElementById("value_"+(RowLength-1)).focus();
			return;
		}				
	}

	var Ptable = document.getElementById("tblDefineTemp");
	var row=Ptable.getElementsByTagName("tr");
	var rLen=row.length;
	var BlankRow=Ptable.insertRow(rLen); //seperate
	var BlankCell = BlankRow.insertCell(0);
	BlankCell.colspan = "7";
	BlankCell.style.height = "3px";
	var oRow=Ptable.insertRow(rLen+1);
	for(var t=0;t<6;t++)
	{
		var oCell=oRow.insertCell(t);
		oCell.className="Filter";
		oCell.innerHTML = row[0].cells[t].innerHTML;
	}
	if(1 == oRow.cells[4].firstChild.options.length)
	{
		oRow.cells[4].firstChild.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_dom,"dom"));
	}
	oRow.cells[0].firstChild.style.visibility="visible";
	oRow.cells[0].firstChild.id = RowLength;
	oRow.cells[2].firstChild.style.visibility = "visible";
	oRow.cells[3].firstChild.id = "logType_"+RowLength;
	oRow.cells[3].firstChild.options[1].selected = true;
	oRow.cells[4].firstChild.id = "scope_"+RowLength;
	oRow.cells[4].firstChild.options[0].selected = true;
	oRow.cells[5].firstChild.id="value_"+RowLength;
}

function jsDelRow(RowIndex)
{
	var index = parseInt(RowIndex);
	var Ptable = document.getElementById("tblDefineTemp");
	Ptable.deleteRow(2*index-1);
	Ptable.deleteRow(2*index-1);

	var MinusImagesArray = document.getElementsByName("Minus_icon");
	var logtype = document.getElementsByName("logType");
	var value = document.getElementsByName("value");
	var scope = document.getElementsByName("scope");

	for(var i=index;i<MinusImagesArray.length;i++)
	{
		MinusImagesArray[i].id = i;
		logtype[i].id = "logType_" + i;
		value[i].id = "value_" + i;
		scope[i].id = "scope_" + i;
	}

}


function jsClearContent()
{
	if(confirm(i18n_confirm_global_log_filter_clear)) {
		var Ptable = document.getElementById("tblDefineTemp");
		var rowLenght=Ptable.getElementsByTagName("tr").length;
		for(var i =rowLenght-1;i>0;i--)
			Ptable.deleteRow(i);
		document.getElementById("value_0").value = "";
		document.getElementById('clear_flag').value = "clear";
	} else {
		return false;
	}
}

function getvalue(obj)
{
	var m=obj.options[obj.selectedIndex].value
	var n=obj.options[obj.selectedIndex].text
	index = getEnd(obj.id,"logType_");
	scope_option = document.getElementById("scope_" + index);
	if(m == "0")
	{
		for(var i=0;i<scope_option.options.length;)
	{
		scope_option.removeChild(scope_option.options[i]);
	}
		scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_user,"user"));
	}else
	{
		for(var i=0;i<scope_option.options.length;)
	{
		scope_option.removeChild(scope_option.options[i]);
	}
		scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_user,"user"));
		scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_dom,"dom"));
	}

}

function getEnd(mainStr,searchStr)
{
	foundOffset=mainStr.indexOf(searchStr);
	if(foundOffset==-1){
	   return null;
	}
	return mainStr.substring(foundOffset+searchStr.length,mainStr.length);
}

</script>
</head>
<script language="javascript" type="text/javascript" src="html/checkall.js"></script>
<script language="Javascript" type="text/javascript" src="html/func.js"></script>
<script language="JavaScript" type="text/javascript" src="html/i18n_warnmsg.js"></script>
<script language="javascript" type="text/javascript" src="html/mouseover_help.js"></script>
<body bgcolor="#FFFFFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<div id="object1" style="position:absolute; background-color:white;color:black;border-color:black;border-width:20; visibility:show; left:25px; top:-50px; z-index:+1" onMouseOver="overdiv=1;"	onmouseout="overdiv=0; setTimeout('hideLayer()',1000)"> pop up description layer </div>
<form>
	<input type="hidden" name="dummy" />
	<input type="hidden" name="clear_flag" id="clear_flag"/>
</form>
<table width="98%" border="0" cellspacing="0" cellpadding="0">
  <tr>
	<td width="507" nowrap="nowrap" class="content-title" i18n="PAGE_TITLE"></td>
	<td nowrap="nowrap" class="text"><br></td>
		<td valign="bottom" nowrap="nowrap">
			<div align="right">
	<A href="javascript:openhelpwin('log_settings.htm');">
				<img src="images/question_cui.gif" width="18" height="18" border="0">
				</a>
			</div>
		</td>
   </tr>
  <tr>
	<td colspan="3" class="hor-dotted-line"><img src="images/1space_cui.gif" width="1" height="10"></td>
  </tr>
  <tr>
	<td colspan="3"><img src="images/1space_cui.gif" width="1" height="10"></td>
  </tr>
</table>
<table width="98%" border="0" cellpadding="0" cellspacing="0" class="border">
  <tbody>
  <tr>
  <td>
	<table width="100%" border="0" cellspacing="0" cellpadding="0">
	<tbody>
		<tr>
			<td class="tableheader" i18n="TITLE.GLOBAL_LOG_SETTINGS"></td>
		</tr>
<!-- log setting start -->
		<tr>
			<td class="data1" style="padding-bottom:10; padding-top:10;">
				<table border="0" cellspacing="2" cellpadding="2">
					<tbody>
						<tr>
							<td width="150"><label for="json-purge_days" i18n="COLON_LABEL.STORE_LOGS_FOR"></label></td>
							<td>
								<input type="text" class="button" style="width:50px;" id="json-purge_days" value="14" />
								&nbsp;<span i18n="FREQUENCY.DAYS"></span>
							</td>
						</tr>
						<tr>
							<td width="150"><label for="json-purge_size" i18n="COLON_LABEL.MAX_LOG_DISK_SIZE"></label></td>
							<td>
								<input type="text" class="button" style="width:50px;" id="json-purge_size" value="5" />&nbsp;GB
							</td>
						</tr>
						<tr>
							<td colspan="2" i18n="INFO_LOG_EXCEED"></td>
						</tr>
					<!--nico add here-->
						<tr>
							<td>
								<i18n:message bundleRef="bundleLog" key="syslogsetting.mount_device" />
							</td>
							<td class="on_mount">
								<i18n:message bundleRef="bundleLog" key="syslogsetting.mount" />
								&nbsp;&nbsp;
								<input type="text" class="button" value="" id="mount_dev"></input>
								&nbsp;&nbsp;
								<i18n:message bundleRef="bundleLog" key="syslogsetting.mount_point" />
								&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
								<%if(accountinfo.getRoleID() == 0){%>
								<input type="button" id="mount_button" value="<i18n:message bundleRef='bundleLog' key='syslogsetting.mount' />"></input>
								<%}%>
							</td>
							<td class="off_mount">
								<!-- span id="mount_dev_name"></span -->
								<i18n:message bundleRef="bundleLog" key="syslogsetting.mount_info" />
								&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
								<%if(accountinfo.getRoleID() == 0){%>
								<input type="button" id="unmount_button" value="<i18n:message bundleRef='bundleLog' key='syslogsetting.umount' />"></input>
								<%}%>
							</td>
						</tr>
						<tr>
							<td>
								<label for="offload_logs">
									<input type="checkbox" id="offload_logs"></input>
									<i18n:message bundleRef="bundleLog" key="syslogsetting.offload_logs" />
								</label>
							</td>
							<td>
								<span style="color:silver">(</span>
								<span style="color:silver"><i18n:message bundleRef="bundleLog" key="syslogsetting.lastlogoffloadtime" /></span>
								<span id="llut"></span>
								<span style="color:silver">)</span>
							</td>
						</tr>
						<tr>
							<td>
								<label for="historical_report_mode">
									<input type="checkbox" id="historical_report_mode"></input>
									<i18n:message bundleRef="bundleLog" key="syslogsetting.import_logs" />
								</label>
								<a onmouseout="hideLayer()" onmouseover="popLayer(0,20,30)">
									<img width="14" height="17" border="0" align="absmiddle" src="images/info_mark_cui.gif">
								</a>
							</td>
							<td class="lr">
								<select name="log_retrieval_list" class="text" id="log_retrieval_list">
								</select>
								&nbsp;&nbsp;
								<input type="button" value="<i18n:message bundleRef='bundleLog' key='syslogsetting.import' />" id="log_retrieval">
								</input>
							</td>
						</tr>
						<tr class="lr">
							<td></td>
							<td>
								<!-- table width="540" border=0 cellPadding=0 cellSpacing=0 -->
								<table width="540" border=0 cellPadding=0 cellSpacing=0 class="lr">
									<tbody>
										<tr>
											<td>
												<table width="100%" border="0" cellpadding="0" cellspacing="0" class="border" id="log_retrieval_container">
													<tr>
														<td width="152"	 class="grey2"><i18n:message bundleRef='bundleLog' key='syslogsetting.log_period' /></td>
														<td width="136"	 class="grey2"><i18n:message bundleRef='bundleLog' key='syslogsetting.log_size' /></td>
														<td width="100"	 class="grey2"><i18n:message bundleRef='bundleLog' key='syslogsetting.action' /></td>
													</tr>
												</table>
											</td>
										</tr>
									</tbody>
								</table>
							</td>
						</tr>
						<tr>
							<td colspan="3"><img src="images/1space_cui.gif" width="1" height="10"></td>
						</tr>
						<tr>
							<td>&nbsp;&nbsp;<%if (!is_log_source) {%><%=AccessLevel.BUTTON_REPORT(request, response, "save_log_setting", "Save")%><%}%></td>
						</tr>
				<!-- nico add end -->
					</tbody>
				</table>
			</td>
		</tr>
<!-- log setting end -->

	  <tr>
		  <td class="tableheader" i18n="TITLE.GLOBAL_LOG_FILTER"></td>
	  </tr>
	  <tr>

		<td>

			<table width="100%" border="0" cellpadding="0" cellspacing="0">

					<tr><td style="padding-left:2px">
							<table border="0" cellpadding="0" cellspacing="0">
							   <tr><td height="5"></td></tr>

							   <tr><td height="5"></td></tr>
							   <tr><td>
								   <table id="tblDefineTemp" name="tblDefineTemp" border="0" cellpadding="0" cellspacing="0">
									<tr>
									   <td class="Filter"><img id="0" name ="Minus_icon" style="visibility:hidden" class="vAlignMid" src="images/icon_minus.gif" onClick="javascript:jsDelRow(this.id);"/></td>

									   <td class="Filter"><img id="Plus_icon" name="Plus_icon" class="vAlignMid" src="images/icon_plus.gif" onClick="javascript:jsAddRow();"/></td>

									   <td class="Filter"><div style="visibility:hidden">&nbsp;&nbsp;||&nbsp;&nbsp;</div></td>

									   <td class="Filter"><select name="logType" id="logType_0" class="text" onchange="getvalue(this)">
											   <option value="0" i18n="OPTION.GLOBAL_LOG_SETTINGS_Bandwidth"></option>
											   <option value="1" i18n="OPTION.GLOBAL_LOG_SETTINGS_Enforcement"></option>
											   <option value="2" i18n="OPTION.GLOBAL_LOG_SETTINGS_Internet_Access"></option>
											   <option value="3" i18n="OPTION.GLOBAL_LOG_SETTINGS_Internet_Security"></option>
											   <option value="4" i18n="OPTION.GLOBAL_LOG_SETTINGS_Data_Security"></option>
											   <option value="5" i18n="OPTION.GLOBAL_LOG_SETTINGS_Access_Control"></option>
									   </select></td>

									   <td	class="Filter"><select	style="width:100px;" name="scope" id="scope_0" class="text">

											 <option value="user" i18n="OPTION.GLOBAL_LOG_SETTINGS_user"></option>
											 <option value="dom" i18n="OPTION.GLOBAL_LOG_SETTINGS_dom"></option>

									   </select></td>

									   <td class="Filter" nowrap><input type="text" class="text"  id="value_0" name="value"/></td>
									</tr>
								  </table>
								</td>
							 </tr>
							<tr><td height="20"></td></tr>
							<%if(access == 3){%>
							<tr>
								<td><input type="button" class="button" id="save_filter_setting" value="Save" style="width:60px">
									<input type="button" class="button" id="clear_filter_setting" value="Clear" onClick="jsClearContent();" style="width:60px">
								</td>
							</tr>
							<%}%>
						</table>
					</td></tr>
			  </table>

		</td>

	  </tr>

	  <tr></tr>
	  <tr>
		  <td class="tableheader" i18n="TITLE.ANONYMOUS_LOG"></td>
	  </tr>
	  <tr>
		  <td class="data1" style="padding-bottom:10; padding-top:10;">
			<table border="0" cellspacing="2" cellpadding="2">
				<tbody>
				  <tr>
					<td width="220"><div i18n="ANONYMOUS_INFO"></div></td>
					<td width="60"><div id="anonymous_state">Disabled</div></td>
					<td><input type="button" class="button" id="anonymous_button" value="Enable" style="width:80px" <%if(access != 3){%>disabled<%}%>></td>
				  </tr>
			   </tbody>
			</table>
		  </td>
	  </tr>

	  <tr <%if(!isInterruptedEnable){%>style="display:none"<%}%>>
		  <td class="tableheader" i18n="TITLE.INTERRUPTED_LOG"></td>
	  </tr>
	  <tr <%if(!isInterruptedEnable){%>style="display:none"<%}%>>
		  <td class="data1" style="padding-bottom:10; padding-top:10;">
			<table border="0" cellspacing="2" cellpadding="2">
				<tbody>
				  <tr>
					<td width="220"><div i18n="INTERRUPTED_INFO"></div></td>
					<td width="60"><div id="interrupted_state">Disabled</div></td>
					<td><input type="button" class="button" id="interrupted_button" value="Enable" style="width:80px" <%if(access != 3){%>disabled<%}%>></td>
				  </tr>
			   </tbody>
			</table>
		  </td>
	  </tr>

	  <tr>
		  <td class="tableheader" i18n="TITLE.SYSLOG_SERVER"></td>
	  </tr>
	  <tr>
		  <td class="data1" style="padding-bottom:10; padding-top:10;">


			<form action = "report_logsetting.jsp" method="post" name="saveform">
			<input name="PostType" type="hidden" value="">
			<input name="ServerNo" type="hidden" value="">
			<input name="RemoveList" type="hidden" value="1">
			<input name="SelectedIPList" type="hidden" value="<%=strSelectedIPList%>">
			<input name="SelectedPortList" type="hidden" value="<%=strSelectedPortList%>">
			<input type=hidden name="daemonaction" value="0">
			<input type=hidden name="app_daemonaction" value="67">
		<input type="hidden" id="hidden_button"></input>

			<!--TOOL TIP-->
			<!--<div id="tooltip" style="visibility:hidden;position:absolute;z-index:1000;top:-100"></div>
			<script language="JavaScript" type="text/javascript">mig_clay();</script> -->
			<!--/TOOL TIP-->
			<table width="540" border=0 cellPadding=0 cellSpacing=0 class="border">
			  <tbody>
			<%if (access == 3 || is_log_source) { %>
				<tr>
				  <td><table width="100%" border="0" cellspacing="0" cellpadding="0">
					  <tr>
						<td>

						<table height="26" border="0" cellpadding="0" cellspacing="0">
						  <tr>
							<td ><img src="images/1space_cui.gif" width="5" height="1"></td>
							<% if (iCandidate != -1) { %>
							<td ><img src="images/icon_add.gif" width="18" height="18"></td>
							<td	 class="data1"><a href="syslog_add.jsp?PostType=add&ServerNo=<%=iCandidate%>&SelectedIPList=<%=strSelectedIPList%>&SelectedPortList=<%=strSelectedPortList%>"><i18n:message bundleRef="bundleLog" key="syslogsetting.add" /></a></td>
							<% } %>
							<td ><img src="images/1space_cui.gif" width="5" height="1"></td>
							<td ><img src="images/icon_delete.gif"></td>
							<td	 class="data1"><a href="#" onClick="do_delete();"><i18n:message bundleRef="bundleLog" key="syslogsetting.remove" /></a></td>
						  </tr>
						</table></td>
						<td align="right">&nbsp;</td>
					  </tr>

					</table>
					</td>
				</tr>
			<% } %>
				<tr>
				  <td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0" >
							<tr>
							  <td width="27" class="grey2" align="center"><input name="selectall" type="checkbox" value="checkbox" onClick="checkall(this);"/></td>
							  <td width="152"  class="grey2"><i18n:message bundleRef="bundleLog" key="syslogsetting.server_name" /></td>
							  <td width="136"  class="grey2"><i18n:message bundleRef="bundleLog" key="syslogsetting.udp_port" /></td>
							  <td width="100"  class="grey2"><i18n:message bundleRef="bundleLog" key="syslogsetting.enable" /></td>
							</tr>
							<% for(int i=0; i<iMaxServer; i++)
							{
								 if (!strEnable[i].equals("remove")) { line++; %>

							<tr name="syslog_server">
							  <td width="27" height="26"  align="center" class="data<%=((line+1)%2+1)%>b"><input name="selectall" id="cb_<%=i%>" type="checkbox" value="checkbox">
							  <td name="server" class="data<%=((line+1)%2+1)%>b"><a href="syslog_edit.jsp?PostType=edit&ServerNo=<%=i%>"><%=strSyslogServer[i]%></a></td>
							  <td name="serverport" class="data<%=((line+1)%2+1)%>b"><%=strSyslogServerPort[i]%></a></td>
							  <td name="serverenabled"	class="data<%=((line+1)%2+1)%>b">
			<%if (strEnableSyslog[i].equals("true")){%>
			<img src="images/enable_small.gif" width="14" height="13">
			<%}else{%>
			<img src="images/disable_small.gif" width="14" height="13">
			<%}%>
							  </td>
							</tr>

							<%
								}
							} %>
						</table>
						<% if (iCandidate == -1) { %>
						<tr>
							<td width="100%" nowrap="nowrap" class="data-highlight"><i18n:message bundleRef="bundleLog" key="syslogsetting.upto4" /></td>
						</tr>
						<% } %>
				  </td>
				</tr>
			  </tbody>
			</table>
			</form>




		  </td>
	  </tr>
	</tbody>
	</table>
  </td>
  </tr>
  </tbody>
</table>
<br />
<br />
<script language="JavaScript" type="text/javascript" src="lib/data/lang.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/jquery-1.8.3.min.js"></script>
<script language="javascript" type="text/javascript" src="log/js/lib/jquery-1.8.3.min.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/json2.min.js"></script>
<script language="javascript" type="text/javascript" src="log/js/lib/jquery-ui-1.10.2.custom.min.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/i18n.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/data/common_functions.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/data/report_logsetting.js"></script>
<script language="JavaScript" type="text/javascript">
	$(document).ready(function() {
		$("#save_log_setting").css("height", "20px");
		$("#save_log_setting").css("width", "60px");
		$("#save_log_setting").css("font-size", "10px");
		$("#save_log_setting").css("font-family", "Verdana,Arial,Helvetica,sans-serif");
	 	$("#save_log_setting").css("font-weight", "400");
	 	$("#save_log_setting").css("text-align", "center");



		descarray = new Array(1);
		descarray[0] = tipLogImport;
		localizePage("report_logsetting");

		if(<%=access%> != 3) {
			$("#anonymous_button").attr("disabled", true);
			$("#save_filter_setting").attr("disabled", true);
			$("#clear_filter_setting").attr("disabled", true);
		}
		$('#hidden_button').click(function() {
			var id = $('#tblDefineTemp tr:last-child td:last-child input').attr('id');
			auto_search_init(id);
			img_bind();
		});

		function img_bind() {
			$('img[name=Plus_icon]').each(function() {
				$(this).unbind('click').click(function() {
					$('#hidden_button').trigger('click');
				});
			});
		}

		auto_search_init("value_0");
		img_bind();

	function auto_search_init(id) {
		id = '#' + id;
		$(id).autocomplete({
			source: function(req, add) {
				var key = '';
				if($(this.element).parent().prev().children().eq(0).val() == "user")
					key = "CLF_UserName";
				else if($(this.element).parent().prev().children().eq(0).val() == "dom")
					key = "CLF_Domain";

				textSearch(key, req.term, function(data) {
					var res = $.map(data, function(el, i) {
						var elm_type = el.column_type;
						var elm_val = el.column_value;
				//		var src = new RegExp("(" + req.term + ")", "g");
				//		var label = elm_val.replace(src, '<b>' + "$1" + '</b>');
					//	return {"label": label, "value": elm_val};
						return {"label": elm_val, "value": elm_val};
					});
					add(res);
				});
			}
		});

		$(id).each(function() {
			if(!$(this).data('uiAutocomplete')) {
				return;
			}
			$(this).data('uiAutocomplete')._renderItem = function(ul, item) {
				return $("<li></li>")
					.data("item.autocomplete", item)
					.append($("<a></a>").html(item.label))
					.appendTo(ul);
			}
		});
	}

		function textSearch(key ,search, callback) {
			var restObj = {};
			restObj.column = key;
			restObj.keyword = "*" + search + "*";
			var restText = JSON.stringify(restObj);

			$.ajax({
				url: "../../rest/commonlog/log_search",
				type: "POST",
				dataType: "json",
				data: restText,
				success: function(searchData) {
					callback(searchData);
				}
			});
		}

	});
</script>
</body>
</html>
